SystemOrganization addCategory: #'Sourcetalk-Core'!
SystemOrganization addCategory: #'Sourcetalk-Tests'!
SystemOrganization addCategory: #'Sourcetalk-View'!
SystemOrganization addCategory: #'Sourcetalk-Client'!
SystemOrganization addCategory: #'Sourcetalk-Server'!

RRComponent subclass: #SKRssFeed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKRssFeed subclass: #SKRRssGroupsFeed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRRssGroupsFeed class methodsFor: 'initialization' stamp: 'AQ 10/4/2008 15:55'!
initialize
	self registerAsApplication: 'groups.rss'.! !

!SKRRssGroupsFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:49'!
renderChannelOn: rss
	rss title: 'Groups'.
	rss link: 'http://localhost:8080/seaside/sourcetalk/groups'.
	rss description: 'Remake of Squeak Source.'.! !

!SKRRssGroupsFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:57'!
renderContentOn: rss
	self renderChannelOn: rss.
	self model groups do: [ :each | self renderItem: each on: rss ].! !

!SKRRssGroupsFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:56'!
renderItem: aGroup on: rss
	rss item: [ rss title: 'New Group ', aGroup title.
		rss description: aGroup title, ' is our newest Group on Sourcetalk, it has bben created at ', aGroup timestamp asString , '.']! !

SKRssFeed subclass: #SKRRssMembersFeed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRRssMembersFeed class methodsFor: 'initialization' stamp: 'AQ 10/4/2008 15:43'!
initialize
	self registerAsApplication: 'members.rss'.! !

!SKRRssMembersFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:50'!
renderChannelOn: rss
	rss title: 'Members'.
	rss link: 'http://localhost:8080/seaside/sourcetalk/members'.
	rss description: 'Remake of Squeak Source.'.! !

!SKRRssMembersFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:57'!
renderContentOn: rss
	self renderChannelOn: rss.
	self model users do: [ :each | self renderItem: each on: rss ].! !

!SKRRssMembersFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:55'!
renderItem: aUser on: rss
	rss item: [ rss title: 'New User ', aUser title.
		rss description: aUser title, ' is our newest Member on Sourcetalk, he joined us the ', aUser timestamp asString , '.']! !

SKRssFeed subclass: #SKRRssProjectsFeed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRRssProjectsFeed class methodsFor: 'initialization' stamp: 'AQ 10/4/2008 15:44'!
initialize
	self registerAsApplication: 'projects.rss'.! !

!SKRRssProjectsFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:50'!
renderChannelOn: rss
	rss title: 'Projects'.
	rss link: 'http://localhost:8080/seaside/sourcetalk/projects'.
	rss description: 'Remake of Squeak Source.'.! !

!SKRRssProjectsFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:41'!
renderContentOn: rss
	self renderChannelOn: rss.
	self model projects do: [ :each | self renderItem: each on: rss ].! !

!SKRRssProjectsFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 15:41'!
renderItem: aProject on: rss
	rss item: [ rss title: 'New Project ', aProject title.
		rss description: aProject title, ' is the newest Project on Sourcetalk. It has been created at ', aProject timestamp asString , '.']! !

!SKRssFeed methodsFor: 'accessing' stamp: 'AQ 9/8/2008 02:26'!
model
	^ self s2root.! !

!SKRssFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 23:04'!
renderChannelOn: rss
	self subclassResponsibility! !

!SKRssFeed methodsFor: 'rendering' stamp: 'AQ 10/4/2008 23:15'!
renderItem: aGroup on: rss
	self subclassResponsibility! !

WAEntryPoint subclass: #SKHttpHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Server'!

!SKHttpHandler class methodsFor: 'initialization' stamp: 'lr 9/11/2008 11:50'!
initialize
	WADispatcher default register: (self named: 'repository')! !

!SKHttpHandler methodsFor: 'processing' stamp: 'lr 9/18/2008 14:43'!
handleRequest: aRequest 
	^ SKHttpService new handleRequest: aRequest! !

MDRepository subclass: #MDSourceTalkRepository
	instanceVariableNames: 'url project email password'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDSourceTalkRepository class methodsFor: 'accessing' stamp: 'lr 9/10/2008 09:50'!
type
	^ #SourceTalk! !

!MDSourceTalkRepository class methodsFor: 'instance-creation' stamp: 'AQ 9/26/2008 12:07'!
url: aUrlString project: aProjectString email: aUserEmailString password: aPasswordString
	^ self new initializeUrl: aUrlString project: aProjectString email: aUserEmailString password: aPasswordString! !

!MDSourceTalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:15'!
allHashstamps
	| result |
	result := self send: MDGetHashstamps new.
	result assertMessageIs: MDAllHashstamps.
	^ result hashstamps! !

!MDSourceTalkRepository methodsFor: 'private' stamp: 'AQ 9/26/2008 12:06'!
argumentsFor: aMessage
	| arguments stream |
	arguments := Dictionary new.
	arguments at: 'version' put: (Array with: self version).
	self email isNil
		ifFalse: [ arguments at: 'email' put: (Array with: self email) ].
	self password isNil
		ifFalse: [ arguments at: 'password' put: (Array with: self password) ].
	self project isNil
		ifFalse: [ arguments at: 'project' put: (Array with: self project) ].
	stream := ReadWriteStream on: ByteArray new.
	aMessage writeOn: stream.
	arguments
		at: 'message'
		put: (Array with: (Base64MimeConverter mimeEncode: stream)
			contents).
	^ arguments! !

!MDSourceTalkRepository methodsFor: 'accessing' stamp: 'AQ 9/26/2008 12:05'!
email
	^ email! !

!MDSourceTalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:14'!
get: aHashstamp
	| objects |
	objects := self getAll: (Set with: aHashstamp).
	^ objects isEmpty ifFalse: [ objects anyOne ]! !

!MDSourceTalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 12:20'!
getAll: aCollection
	| result |
	result := self send: (MDGetObjects with: aCollection).
	result assertMessageIs: MDObjects.
	^ result objects! !

!MDSourceTalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:15'!
includes: aHashstamp
	^ (self get: aHashstamp) notNil! !

!MDSourceTalkRepository methodsFor: 'initialization' stamp: 'AQ 9/26/2008 12:08'!
initializeUrl: aUrlString project: aProjectString email: aUserEmailString password: aPasswordString
	url := aUrlString.
	project := aProjectString.
	email := aUserEmailString.
	password := aPasswordString! !

!MDSourceTalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:14'!
memos
	| result |
	result := self send: MDGetMemos new.
	result assertMessageIs: MDMemos.
	^ result objects! !

!MDSourceTalkRepository methodsFor: 'accessing-derived' stamp: 'lr 9/11/2008 11:56'!
name
	^ self url , '#' , self project! !

!MDSourceTalkRepository methodsFor: 'accessing' stamp: 'lr 9/11/2008 11:57'!
password
	^ password! !

!MDSourceTalkRepository methodsFor: 'accessing' stamp: 'lr 9/11/2008 11:56'!
project
	^ project! !

!MDSourceTalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 12:23'!
put: anObject
	| result |
	result := self send: (MDPutObjects with: (Array with: anObject)). 
	result assertMessageIs: MDThankYou! !

!MDSourceTalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 12:22'!
putAll: aCollection
	| request |
	request := self send: (MDOfferObjects withObjects: aCollection).
	request assertMessageIs: MDRequestObjects.
	request 
		filter: aCollection
		in: [ :put | (self send: put) assertMessageIs: MDThankYou ]! !

!MDSourceTalkRepository methodsFor: 'public' stamp: 'lr 9/10/2008 10:15'!
selectFrom: aCollection
	| request |
	request := self send: (MDOfferObjects with: aCollection).
	request assertMessageIs: MDRequestObjects.
	^ request hashstamps! !

!MDSourceTalkRepository methodsFor: 'private' stamp: 'lr 9/10/2008 11:40'!
send: aMessage
	| response contents |
	response := HTTPSocket
		httpGet: self url
		args: (self argumentsFor: aMessage)
		accept: 'application/x-monticello'.
	response isString
		ifTrue: [ MDPeerError signal: response ].
	contents := ByteArray withAll: response contents.
	^ (MDNetMessage readFrom: contents readStream)
		checkForError! !

!MDSourceTalkRepository methodsFor: 'accessing' stamp: 'lr 9/11/2008 11:56'!
url
	^ url! !

!MDSourceTalkRepository methodsFor: 'accessing-derived' stamp: 'lr 9/10/2008 10:43'!
version
	^ '2.0'! !

!MADescription methodsFor: '*sourcetalk' stamp: 'lr 10/3/2008 12:25'!
onlySuperuser
	^ self propertyAt: #onlySuperuser ifAbsent: [ false ]! !

!MADescription methodsFor: '*sourcetalk' stamp: 'lr 10/3/2008 12:25'!
onlySuperuser: aBoolean
	self propertyAt: #onlySuperuser put: aBoolean! !

WARequestHandler subclass: #SKHttpService
	instanceVariableNames: 'escaper user repository'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Server'!

!SKHttpService methodsFor: 'messages' stamp: 'lr 9/10/2008 12:30'!
handleGet: message
	^ MDObjects with: (repository getAll: message hashstamps)! !

!SKHttpService methodsFor: 'messages' stamp: 'lr 9/10/2008 11:55'!
handleGetHashstamps: message
	^ MDAllHashstamps with: repository allHashstamps! !

!SKHttpService methodsFor: 'messages' stamp: 'lr 9/10/2008 11:55'!
handleGetMemos: message
	^ MDMemos with: repository memos! !

!SKHttpService methodsFor: 'messages' stamp: 'lr 9/10/2008 11:56'!
handleOfferObjects: message
	^ MDRequestObjects with: (repository selectFrom: message hashstamps)! !

!SKHttpService methodsFor: 'messages' stamp: 'lr 9/10/2008 11:56'!
handlePutObjects: message
	repository putAll: message objects.
	^ MDThankYou with: message objects size! !

!SKHttpService methodsFor: 'processing' stamp: 'lr 9/10/2008 11:32'!
handleRequest: aRequest
	| result |
	escaper := [ :response | ^ response ].
	result := [ self processRequest: aRequest ]
		on: Error
		do: [ :err | MDUnrecognizedMessage with: err description ].
	self return: result! !

!SKHttpService methodsFor: 'public' stamp: 'AQ 9/26/2008 12:10'!
lookupRepository: aString
	
	| project |
	project := self s2root getProjectNamed: aString.
	project isNil
		ifFalse:[^ project repository]
		ifTrue: [Error new]! !

!SKHttpService methodsFor: 'public' stamp: 'AQ 9/26/2008 11:19'!
lookupUser: aString password: aPassword
	
	user := self s2root userByEMail: aString.
	user notNil
		ifTrue: [(user verifyPassword: aPassword)
			ifTrue: [^ user]
			ifFalse: [^ Error new]]
		ifFalse: [^ self s2root anonymous].
	^ Error new.! !

!SKHttpService methodsFor: 'processing' stamp: 'lr 9/10/2008 12:16'!
processMessage: aMessage
	Transcript show: aMessage; cr.
	^ aMessage handledBy: self! !

!SKHttpService methodsFor: 'processing' stamp: 'AQ 9/26/2008 12:10'!
processRequest: aRequest
	user := self 
		lookupUser: (aRequest fields
			at: 'email'
			ifAbsent: [ aRequest user ])
		password: (aRequest fields
			at: 'password'
			ifAbsent: [ aRequest password ]).
	repository := self
		lookupRepository: (aRequest fields
			at: 'project'
			ifAbsent: [ nil ]).
	^ self processMessage: (MDNetMessage
		readFrom: (Base64MimeConverter
			mimeDecodeToBytes: (aRequest fields 
				at: 'message'
				ifAbsent: [ nil ]) 
					readStream)
					readStream)! !

!SKHttpService methodsFor: 'actions' stamp: 'lr 9/10/2008 11:47'!
return: aMessage
	"Answer return a response with the given message."
	
	| stream response |
	stream := ByteArray new writeStream.
	aMessage writeOn: stream.
	response := WAResponse new.
	response doNotCache; contentType: 'application/x-monticello'.
	response nextPutAll: (String withAll: stream contents).
	escaper value: response! !

TestCase subclass: #SKEntryTest
	instanceVariableNames: 'entry'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKEntryTest methodsFor: 'running' stamp: 'lr 9/18/2008 14:43'!
setUp
	entry := SKEntry new! !

!SKEntryTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:40'!
testAddTags
	self assert: (entry tags isEmpty).
	
	entry addTag: 'seaside'.
	self assert: (entry tags anyOne = 'seaside').
	self assert: (entry tags size = 1)! !

!SKEntryTest methodsFor: 'tests' stamp: 'AQ 7/7/2008 11:39'!
testRemoveTags
	self assert: (entry tags isEmpty).
	
	entry addTag: 'seaside'.
	self assert: (entry tags anyOne = 'seaside').
	
	entry removeTag: 'seaside'.
	self assert: (entry tags isEmpty)! !

!SKEntryTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 17:55'!
testTitle
	entry title: 'SqueakSource 2'.
	self assert: (entry title = 'SqueakSource 2').
	self deny: (entry title = 'Unnamed')! !

!SKEntryTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 17:54'!
testWiki
	entry wiki: 'aWiki'.
	self assert: (entry wiki = 'aWiki').
	self deny: (entry wiki = 'wikipedia')! !

TestCase subclass: #SKGroupTest
	instanceVariableNames: 'user superuser user2 group admin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKGroupTest methodsFor: 'running' stamp: 'lr 9/18/2008 14:43'!
setUp
	user := SKUser new.
	superuser := SKUser new.
	superuser superuser: true.
	admin := SKUser new.
	user2 := SKUser new.
	group := SKGroup new! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:27'!
testAddAdmin
	self assert: user groups isEmpty.
	self assert: group admins isEmpty.
	
	group addAdmin: admin..
	
	self assert: admin groups size = 1.
	self assert: admin groups anyOne = group.
	self assert: group admins size = 1.
	self assert: group admins anyOne = admin.! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:26'!
testAddUser
	self assert: user groups isEmpty.
	self assert: group users isEmpty.
	
	group addUser: user.
	
	self assert: user groups size = 1.
	self assert: user groups anyOne = group.
	self assert: group users size = 1.
	self assert: group users anyOne = user! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:23'!
testIsEditableBy
	group addUser: user.
	group addAdmin: admin.
	
	self deny: (group isEditableBy: user).
	self assert: (group isEditableBy: admin).
	self deny: (group isEditableBy: user2).
	self assert: (group isEditableBy: superuser).
	! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:35'!
testIsVisibleBy
	group addUser: user.
	group addAdmin: admin.
	
	self assert: (group isVisibleBy: user).
	self assert: (group isVisibleBy: admin).
	self deny: (group isVisibleBy: user2).
	self assert: (group isVisibleBy: superuser).
	! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 9/26/2008 02:37'!
testRemoveAdmin
	group addAdmin: admin.
	self assert: admin groups size = 1.
	self assert: group admins size = 1.
	group removeAdmin: admin.
	self assert: group admins isEmpty.
	self assert: admin groups isEmpty.! !

!SKGroupTest methodsFor: 'tests' stamp: 'AQ 9/26/2008 02:37'!
testRemoveUser
	group addUser: user.
	self assert: user groups size = 1.
	self assert: group users size = 1.
	group removeUser: user.
	self assert: group users isEmpty.
	self assert: user groups isEmpty.! !

TestCase subclass: #SKMemberTest
	instanceVariableNames: 'user group project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKMemberTest methodsFor: 'running' stamp: 'lr 9/18/2008 14:43'!
setUp
	user := SKUser new.
	group := SKGroup new.
	project := SKProject new! !

!SKMemberTest methodsFor: 'tests' stamp: 'lr 6/30/2008 14:47'!
testUserAddGroup
	self assert: user groups isEmpty.
	self assert: group users isEmpty.
	
	user addGroup: group.
	
	self assert: user groups size = 1.
	self assert: user groups anyOne = group.
	self assert: group users size = 1.
	self assert: group users anyOne = user! !

!SKMemberTest methodsFor: 'tests' stamp: 'AQ 9/26/2008 02:36'!
testUserRemoveGroup
	user addGroup: group.
	self assert: user groups size = 1.
	self assert: group users size = 1.
	
	user removeGroup: group.
	self assert: user groups isEmpty.
	self assert: group users isEmpty.! !

TestCase subclass: #SKProjectTest
	instanceVariableNames: 'group project superuser admin developer user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKProjectTest methodsFor: 'running' stamp: 'lr 9/18/2008 14:43'!
setUp
	developer := SKUser new.
	admin := SKUser new.
	user := SKUser new.
	superuser := SKUser new.
	superuser superuser: true.
	group := SKGroup new.
	project := SKProject new! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/12/2008 22:02'!
testAddAdmin
	self assert: project admins isEmpty.
	project addAdmin: admin.
	self assert: project admins size = 1.
	project addAdmin: group.
	self assert: project admins size = 2.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/12/2008 22:02'!
testAddDeveloper
	self assert: project developers isEmpty.
	project addDeveloper: developer.
	self assert: project developers size = 1.
	project addDeveloper: group.
	self assert: project developers size = 2.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:52'!
testIsEditableBy
	project addAdmin: admin.
	project addDeveloper: developer.
	
	self assert: (project isEditableBy: admin).
	self assert: (project isEditableBy: superuser).
	self deny: (project isEditableBy: developer).
	self deny: (project isEditableBy: user).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 13:36'!
testIsVisibleBy
	project addAdmin: admin.
	project addDeveloper: developer.
	
	self assert: (project isVisibleBy: admin).
	self assert: (project isVisibleBy: superuser).
	self assert: (project isVisibleBy: developer).
	self deny: (project isVisibleBy: user).
	
	project visibility: #visible.
	self assert: (project isVisibleBy: user).! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:19'!
testLicense
	self deny: project license = 'gnu'.
	project license: 'gnu'.
	self assert: project license = 'gnu'.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:24'!
testRating
	self assert: project rating = 0.
	project rating: 5.5.
	self assert: project rating = 5.5
	! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 9/26/2008 02:37'!
testRemoveAdmin
	project addAdmin: group.
	project addAdmin: admin.
	self assert: project admins size = 2.
	self deny: project admins isEmpty.
	project removeAdmin: group.
	self assert: project admins size = 1.
	self deny: project admins isEmpty.
	project removeAdmin: admin.
	self assert: project admins isEmpty.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 9/26/2008 02:36'!
testRemoveDeveloper
	project addDeveloper: group.
	project addDeveloper: developer.
	self assert: project developers size = 2.
	self deny: project developers isEmpty.
	project removeDeveloper: group.
	self assert: project developers size = 1.
	self deny: project developers isEmpty.
	project removeDeveloper: developer.
	self assert: project developers isEmpty.! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:22'!
testState
	self assert: project state = 'Created'.
	project state: 'Alpha'.
	self assert: project state = 'Alpha'.
	self deny: project state = 'Created'.
	! !

!SKProjectTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:59'!
testVisibility
	self deny: project visibility = #writable.
	self deny: project visibility = #visible.
	self assert: project visibility = #hidden.
	project visibility: #visible.
	self assert: project visibility = #visible.
	! !

TestCase subclass: #SKRootTest
	instanceVariableNames: 'root user group project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKRootTest methodsFor: 'running' stamp: 'lr 9/18/2008 14:43'!
setUp
	root := SKRoot new.
	group := SKGroup new.
	user := SKUser new.
	project := SKProject new! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:44'!
testAddGroup
	self assert: root groups isEmpty.
	root addGroup: group.
	self assert: root groups size = 1.
	self assert: root groups anyOne = group! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:45'!
testAddProject
	self assert: root projects isEmpty.
	root addProject: project.
	self assert: root projects size = 1.
	self assert: root projects anyOne = project! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:46'!
testAddUser
	self assert: root users isEmpty.
	root addUser: user.
	self assert: root users size = 1.
	self assert: root users anyOne = user! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 9/6/2008 13:13'!
testCountProjectsOfUser
	root addUser: user.
	self assert: root users size = 1.
	root addProject: project.
	project addAdmin: user.
	self assert: root projects size = 1.
	self assert: (root countProjectsOfUser: user) = 1! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 9/6/2008 14:19'!
testGetGroupsOfUser
	root addUser: user.
	self assert: root users size = 1.
	root addGroup: group.
	group addAdmin: user.
	self assert: root groups size = 1.
	self assert: (root getGroupsOfUser: user) anyOne = group.
	root removeGroup: group.
	self assert: (root getGroupsOfUser: user) isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 9/6/2008 14:17'!
testGetProjectsOfUser
	root addUser: user.
	self assert: root users size = 1.
	root addProject: project.
	project addAdmin: user.
	self assert: root projects size = 1.
	self assert: (root getProjectsOfUser: user) anyOne = project.
	root removeProject: project.
	self assert: (root getProjectsOfUser: user) isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 9/26/2008 02:36'!
testRemoveGroup
	root addGroup: group.
	self assert: root groups size = 1.
	root removeGroup: group.
	self assert: root groups isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 9/26/2008 02:36'!
testRemoveProject
	root addProject: project.
	self assert: root projects size = 1.
	root removeProject: project.
	self assert: root projects isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 9/26/2008 02:36'!
testRemoveUser
	root addUser: user.
	self assert: root users size = 1.
	root removeUser: user.
	self assert: root users isEmpty.! !

!SKRootTest methodsFor: 'tests' stamp: 'AQ 9/15/2008 10:16'!
testUserByEMail
	root addUser: user.
	self assert: root users size = 1.
	self assert: (root userByEMail: user email) = user.! !

TestCase subclass: #SKUserTest
	instanceVariableNames: 'user superuser user2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Tests'!

!SKUserTest methodsFor: 'running' stamp: 'lr 9/18/2008 14:43'!
setUp
	user := SKUser new.
	superuser := SKUser new.
	superuser superuser: true.
	user2 := SKUser new! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 7/6/2008 20:15'!
testEmail
	self deny: user email = 'e@mail.net'.
	user email: 'e@mail.net'.
	self assert: user email = 'e@mail.net'! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 11:55'!
testIsEditableBy
	self assert: (user isEditableBy: user).
	self deny: (user isEditableBy: user2).
	self assert: (user isEditableBy: superuser).! !

!SKUserTest methodsFor: 'tests' stamp: 'AQ 7/9/2008 12:33'!
testIsVisibleBy
	self assert: (user isVisibleBy: user).
	self assert: (user isVisibleBy: user2).
	self assert: (user isVisibleBy: superuser).! !

!SKUserTest methodsFor: 'tests' stamp: 'lr 7/9/2008 15:02'!
testPassword
	user password: '12345'.
	self assert: (user verifyPassword: '12345').
	self deny: (user verifyPassword: '1234')! !

!SKUserTest methodsFor: 'tests' stamp: 'lr 10/3/2008 12:24'!
testSuperuser
	self deny: user isSuperuser.
	user superuser: true.
	self assert: user isSuperuser! !

WAFileLibrary subclass: #SKFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKFileLibrary methodsFor: 'uploaded' stamp: 'AQ 10/11/2008 19:51'!
defaultCss
	^ '/* html */
body { margin: 0; }

/* parts */	
.container { border: 1px dotted #c9c9c9; border-top: none; }

.logo h1 { background: url(logo.png) no-repeat; margin: 0; height: 153px; width: 950px; }
.logo h1 a { display: block; height: 153px; outline: none; }
.logo h1 a span { display: none; }

.tabs div { text-align: center; color: #3a8fcd; font-size: 2em; }
.tabs div.span-6 { margin: 0; width: 239px; }
.tabs div.last { width: 229px; }
.tabs div a { display: block; color: inherit; text-decoration: none; outline: none; }
.tabs div.active { background-color: #f7f7f7; color: #5da922; }

.main { background: url(main.png) repeat-x; }
.main .menu input { width: 100px; }

.browse div { float: left; }

'! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
ieCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* ie.css */
body {text-align:center;}
.container {text-align:left;}
* html .column {overflow-x:hidden;}
* html legend {margin:-18px -8px 16px 0;padding:0;}
ol {margin-left:2em;}
sup {vertical-align:text-top;}
sub {vertical-align:text-bottom;}
html>body p code {*white-space:normal;}
hr {margin:-8px auto 11px;}'! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
logoPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 3 189 0 0 0 153 8 2 0 0 0 108 106 202 70 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 69 144 73 68 65 84 120 218 236 189 107 144 28 215 117 231 89 143 204 122 119 119 245 19 221 0 26 143 198 139 0 40 128 4 71 4 36 145 150 73 137 34 233 29 121 172 144 229 13 143 102 35 36 121 20 177 31 150 164 99 63 216 65 202 243 105 45 41 236 47 59 164 246 131 119 180 35 41 98 87 218 9 211 12 42 204 25 137 212 131 180 7 90 145 128 76 144 4 137 7 241 70 163 129 110 244 179 186 235 93 149 85 181 167 43 129 196 237 155 153 55 111 102 85 117 87 87 255 127 236 0 171 42 51 111 222 188 121 42 243 159 167 206 61 199 95 171 213 78 158 60 249 240 195 15 251 0 88 255 192 152 1 140 25 0 88 50 0 45 50 102 63 233 102 12 4 0 0 0 0 0 0 98 2 24 2 0 0 0 0 0 0 164 116 243 201 147 39 49 16 160 51 128 49 3 24 51 0 176 100 0 90 100 204 136 211 0 0 172 49 90 165 72 255 86 233 175 86 182 92 65 241 171 203 255 243 7 148 128 138 225 2 0 0 176 86 40 24 2 0 192 42 171 100 173 86 169 214 180 74 181 162 85 75 245 79 202 21 27 197 76 4 252 1 53 24 97 223 6 252 138 26 84 253 190 160 26 12 211 91 12 41 0 0 128 213 211 205 152 235 10 58 6 24 115 219 106 229 114 181 164 85 203 244 87 212 114 37 173 80 174 22 203 149 18 253 91 173 85 101 90 88 86 207 129 176 26 12 209 191 33 37 18 86 98 203 159 150 117 85 29 86 232 195 96 24 198 12 0 44 25 128 150 26 51 226 52 0 0 173 162 168 229 43 181 114 169 82 44 105 185 92 41 83 208 178 197 74 190 89 141 71 213 120 36 24 143 170 93 74 112 57 120 195 239 15 132 58 84 64 3 0 0 104 19 160 155 1 0 77 70 171 146 86 206 235 114 57 91 90 36 197 172 217 135 97 52 69 64 199 212 238 120 168 71 127 27 240 7 194 74 60 28 140 248 17 194 1 0 0 160 169 32 159 6 232 40 96 204 107 75 81 203 167 139 243 244 55 159 155 186 181 120 121 50 125 109 169 184 208 82 209 76 228 203 217 185 220 36 237 142 52 186 111 121 114 97 53 95 78 47 22 231 10 90 166 38 23 4 2 99 6 0 150 12 128 140 49 195 223 12 0 104 20 146 167 197 74 142 68 179 86 45 167 11 11 233 210 124 117 141 4 171 226 87 123 162 3 172 239 57 170 118 35 114 3 0 0 64 83 128 110 6 0 52 68 65 203 21 180 44 73 231 116 97 126 177 56 91 109 3 23 111 56 24 237 143 109 214 227 158 151 197 116 32 68 74 26 153 55 0 0 0 52 8 226 52 64 71 1 99 94 77 74 149 226 98 97 38 95 78 23 202 153 91 139 151 23 10 211 142 162 89 241 171 137 80 79 79 120 96 83 98 91 79 168 59 226 211 232 79 43 220 74 45 156 210 255 230 230 78 150 242 147 197 252 84 58 115 173 92 206 121 235 88 177 146 159 202 92 213 195 54 124 203 241 214 165 165 226 92 169 158 37 26 198 12 0 44 25 0 207 198 12 127 51 0 192 53 164 143 73 149 146 30 173 214 42 75 133 217 165 226 130 163 92 238 10 247 46 102 175 204 47 93 88 200 92 203 22 103 82 233 43 82 10 88 171 116 197 118 68 35 35 221 241 205 155 251 15 171 106 204 85 63 73 163 247 197 70 140 183 17 37 22 85 187 112 250 0 0 0 120 3 186 25 0 224 14 35 48 163 168 229 230 178 147 226 105 127 170 95 73 45 157 155 78 125 72 127 101 205 163 255 184 90 173 229 74 165 66 89 235 137 111 221 62 124 116 184 255 80 44 210 47 185 173 26 8 111 234 218 22 240 7 245 183 97 37 26 85 18 72 181 1 0 0 192 163 110 70 78 114 208 49 192 152 91 138 225 102 166 215 139 249 217 197 226 172 96 229 116 230 90 106 233 163 235 183 143 55 107 239 90 165 146 41 148 180 234 114 40 200 182 161 163 163 195 199 6 147 123 60 72 103 37 160 38 66 201 246 151 206 48 102 128 203 50 0 237 102 204 240 55 3 0 164 40 85 138 185 242 82 173 86 173 214 42 115 185 91 249 114 214 110 205 137 233 19 211 115 191 205 21 166 90 209 141 92 169 156 43 150 244 215 3 61 123 142 236 251 119 50 190 231 117 42 157 1 0 0 180 21 208 205 0 0 103 150 39 255 213 163 44 72 52 223 78 143 151 171 214 115 236 102 82 23 207 95 253 47 126 95 166 165 157 41 106 149 76 161 104 92 187 118 109 121 236 190 109 79 59 134 62 147 116 30 233 222 105 188 13 43 209 152 218 141 51 11 0 0 64 30 228 211 0 29 5 140 185 233 212 150 99 51 82 186 104 46 87 10 83 75 215 44 69 115 174 48 247 219 211 47 157 185 244 127 182 90 52 215 37 111 48 25 139 248 253 126 253 237 229 155 111 253 230 244 75 139 153 9 241 86 212 237 249 220 36 35 190 243 244 48 0 99 6 0 150 12 128 188 49 195 223 12 0 16 137 230 76 41 165 85 203 186 104 190 157 25 183 204 52 119 229 230 91 23 199 127 30 13 249 2 1 255 170 245 173 82 173 166 114 5 227 10 166 6 99 247 239 250 210 246 225 79 137 183 234 143 141 24 85 81 136 120 40 137 170 40 0 0 0 36 129 110 6 0 88 67 114 153 68 179 94 170 218 78 52 151 203 185 19 103 191 159 74 95 238 97 28 192 174 136 69 134 18 145 33 227 109 166 48 157 43 76 123 147 206 196 131 123 191 42 150 206 1 127 96 56 177 211 40 137 226 247 7 122 194 253 8 116 6 0 0 32 171 155 49 215 21 116 12 48 230 213 20 205 139 153 137 19 103 190 95 42 47 184 18 205 91 6 142 246 38 118 12 247 30 234 77 140 169 138 117 80 114 182 48 189 144 185 122 59 245 17 253 137 51 61 147 116 94 200 230 217 79 28 165 115 56 24 221 212 181 221 120 27 10 134 227 161 36 140 25 0 88 50 0 142 198 12 127 51 0 64 36 154 237 38 2 94 159 122 251 163 203 175 214 106 5 73 209 76 114 121 215 200 231 182 14 28 53 47 82 2 42 61 195 215 95 214 244 152 16 78 67 95 158 252 213 199 19 175 217 165 127 206 151 202 217 187 25 54 36 165 51 23 173 209 21 74 42 136 214 0 0 0 224 4 116 51 0 192 139 104 126 239 194 143 73 46 39 99 145 96 64 20 228 160 42 177 125 91 191 184 107 228 243 113 38 24 67 39 224 15 68 148 68 40 24 102 195 36 170 203 229 84 178 5 147 68 38 209 124 238 198 79 237 212 115 58 95 40 106 149 123 59 13 198 30 57 252 108 79 98 171 93 175 104 215 155 187 119 25 105 233 232 109 79 100 16 167 30 0 0 128 24 228 211 0 29 5 140 185 65 170 245 137 128 181 187 33 25 169 252 180 157 104 166 23 61 209 176 88 52 143 141 60 254 71 159 250 207 135 118 254 91 179 104 142 170 113 146 170 97 37 202 197 22 147 132 141 170 93 230 12 113 164 191 169 29 106 109 139 149 199 58 17 9 179 62 239 114 37 119 226 204 247 203 229 156 224 48 211 133 133 149 98 61 15 99 6 0 150 12 128 216 152 225 111 6 0 220 129 205 158 65 164 11 243 11 166 41 122 134 104 142 133 67 177 144 106 215 84 178 107 236 95 237 254 179 161 228 253 230 69 36 148 163 74 130 20 179 184 51 5 45 99 87 90 229 227 27 175 189 123 233 255 226 62 52 71 107 236 218 242 216 39 118 125 217 214 103 0 151 51 0 0 0 151 96 22 57 0 224 14 172 104 46 106 57 129 104 86 2 1 129 104 30 27 121 252 137 7 190 109 41 154 151 5 183 218 237 40 154 137 136 146 8 216 164 185 216 55 250 197 99 251 159 227 62 140 134 84 46 11 222 229 155 111 205 164 46 218 181 111 118 57 107 149 34 108 0 0 0 128 131 110 198 111 40 160 99 128 49 123 38 87 94 50 68 115 181 86 153 201 242 101 68 22 51 19 186 104 38 186 162 182 179 232 72 209 30 187 239 57 187 68 25 81 181 75 62 95 50 73 103 91 105 62 252 184 89 58 199 66 33 238 147 143 175 255 76 208 126 182 180 200 190 45 85 139 48 102 0 96 201 0 8 140 25 113 26 0 116 38 215 23 206 146 20 222 222 123 64 166 154 116 81 203 211 202 198 219 153 236 13 46 70 34 87 152 123 235 221 191 41 87 150 35 134 237 34 52 72 43 127 246 19 223 178 115 51 251 150 189 212 161 174 112 175 171 163 72 21 102 106 86 149 86 238 200 98 83 192 198 124 54 87 173 174 184 166 137 115 107 112 137 53 146 145 65 228 114 6 0 0 96 123 35 195 16 0 176 222 245 241 143 223 255 107 122 113 126 230 132 121 233 151 14 62 251 165 131 207 137 91 208 170 229 188 118 175 56 118 186 48 111 14 44 94 158 102 87 23 205 129 128 63 170 42 150 162 249 137 7 190 147 236 218 105 183 23 210 163 172 66 149 36 20 12 11 102 236 237 27 253 226 141 217 119 166 83 31 25 159 68 85 149 139 114 190 114 243 159 5 186 153 158 22 216 94 149 42 69 153 24 18 0 0 0 27 19 196 105 128 142 98 3 26 51 41 63 82 204 150 162 89 146 124 57 109 248 116 181 74 121 177 56 203 173 240 225 229 87 22 239 134 109 196 66 33 115 182 102 71 209 236 91 14 186 136 6 220 187 114 131 126 85 188 194 167 246 175 136 9 137 152 52 61 245 92 16 229 76 79 8 213 90 133 121 132 40 194 152 1 128 37 3 96 103 204 203 183 49 20 242 1 29 3 140 217 131 104 102 75 141 204 229 110 113 117 1 73 116 94 190 249 214 157 231 236 128 63 98 229 108 126 104 207 55 197 162 89 79 213 236 161 123 193 128 195 111 98 241 200 208 190 173 95 52 222 146 166 15 43 65 110 157 27 83 239 8 71 224 158 175 189 108 170 186 2 99 6 0 150 12 128 97 204 136 228 3 96 227 162 85 138 108 133 145 116 97 190 88 89 17 20 81 46 231 222 251 248 255 49 222 154 39 222 45 139 230 221 255 126 108 248 113 241 142 188 137 102 223 157 82 130 14 236 31 253 35 214 229 172 42 188 212 30 159 62 33 200 229 204 6 118 215 106 85 173 157 164 51 0 0 128 182 2 113 26 160 163 216 152 113 26 158 183 205 107 247 226 152 171 181 138 57 66 227 252 248 207 115 197 185 59 23 11 43 103 243 150 129 163 251 70 191 40 222 139 223 31 8 53 80 197 90 9 132 196 43 232 37 9 141 183 102 127 51 113 107 238 3 187 205 185 248 233 74 85 131 49 3 0 75 6 192 210 152 17 167 1 58 138 13 104 204 227 169 115 222 54 44 104 25 214 183 154 202 79 115 17 26 139 153 9 35 66 195 103 229 108 142 69 134 62 189 255 207 29 119 20 49 21 5 108 58 251 71 255 136 145 233 126 197 84 197 112 106 238 67 187 109 233 168 203 149 2 243 86 131 49 3 0 75 6 192 210 152 17 167 1 128 5 215 23 206 158 155 126 135 254 218 191 171 179 185 155 130 165 3 177 173 150 159 215 106 213 2 227 103 45 106 185 204 202 100 198 190 250 116 64 86 140 154 253 184 159 222 111 155 167 153 37 20 140 53 114 128 74 192 57 237 15 117 131 173 191 173 154 186 58 155 186 36 216 188 196 84 60 209 218 198 223 12 0 0 160 221 88 190 33 157 60 121 18 143 131 160 51 240 96 204 185 242 18 169 228 241 212 57 122 113 110 250 196 108 110 98 54 123 71 137 126 243 147 127 187 46 36 190 72 55 199 183 88 126 158 215 50 108 94 228 84 126 134 111 118 234 237 217 197 123 105 40 34 170 194 165 209 216 55 250 135 130 84 205 140 234 13 5 26 115 54 155 211 119 88 50 58 120 236 230 236 157 164 34 74 144 116 243 138 48 229 114 37 183 152 153 232 73 88 63 69 104 149 123 43 87 106 218 250 53 102 0 58 227 178 12 64 219 26 243 178 110 134 65 131 142 193 149 49 255 248 253 191 126 227 194 15 5 43 220 55 120 180 253 15 89 28 167 97 233 111 174 214 170 108 80 111 182 180 200 77 7 244 45 87 218 123 157 125 27 85 87 204 207 83 149 216 161 29 127 42 211 189 80 48 178 58 227 48 58 112 236 29 223 139 119 186 23 176 80 234 115 139 23 237 116 115 65 203 246 248 6 244 215 130 50 43 237 108 204 0 116 198 101 25 128 54 55 102 196 105 128 141 139 88 52 15 196 183 12 218 200 172 246 193 49 146 196 242 16 10 76 149 19 98 49 207 79 7 188 62 245 182 49 29 208 183 236 51 38 86 56 125 31 218 243 77 153 8 141 186 110 14 175 206 80 80 127 146 93 99 250 107 174 183 58 169 244 132 221 182 220 92 192 106 219 72 103 0 0 0 109 5 242 105 128 142 66 222 152 197 225 13 196 254 161 99 237 127 188 226 114 39 150 254 114 179 179 89 171 241 153 215 56 103 115 120 101 26 141 88 100 200 49 241 156 33 154 87 179 108 245 38 38 110 36 20 228 67 156 115 197 121 187 13 185 17 168 182 71 42 58 92 153 193 70 187 44 3 208 254 198 140 124 26 160 163 144 55 102 199 2 123 247 13 172 131 32 141 115 211 162 163 216 222 123 192 252 161 91 103 243 178 110 94 153 17 249 208 206 63 149 236 94 208 41 133 92 115 73 132 135 4 75 217 112 237 14 51 102 0 96 201 0 172 142 49 35 78 3 108 80 196 138 211 183 78 130 155 197 234 127 91 207 126 238 19 25 103 243 141 219 43 156 67 92 144 134 188 179 217 183 138 193 205 58 189 76 205 66 197 42 139 179 128 162 150 195 151 2 0 0 128 24 196 105 128 142 66 222 152 29 20 103 114 127 251 7 55 59 134 154 152 165 127 169 178 66 29 102 138 41 110 133 197 204 4 231 151 13 169 30 157 205 1 127 32 224 95 213 39 243 222 196 152 120 133 153 212 197 142 52 102 0 96 201 0 172 142 49 35 78 3 116 20 146 198 76 138 83 92 102 175 3 130 155 45 231 53 114 57 155 205 105 52 198 111 243 109 178 105 155 85 37 38 239 108 86 87 107 70 32 219 61 227 181 127 195 24 51 0 176 100 0 86 205 152 17 167 1 54 34 206 193 205 131 235 224 66 47 14 53 217 214 195 7 55 23 181 60 155 100 45 107 42 116 178 172 155 167 86 180 233 247 251 131 76 78 55 182 156 181 35 65 191 186 134 131 163 6 113 113 3 0 0 208 100 218 177 238 73 58 63 153 41 76 25 111 19 145 225 174 232 72 19 219 47 107 153 217 244 197 133 204 165 98 57 173 127 66 237 199 35 195 35 189 15 110 64 11 208 71 195 243 32 155 7 115 184 247 193 176 146 232 235 218 211 148 238 77 46 188 71 187 152 75 95 52 78 211 64 215 30 85 73 216 173 47 105 204 227 139 14 181 169 155 238 111 158 201 76 204 230 238 228 65 27 136 109 109 74 16 136 88 253 239 31 226 131 52 180 234 189 170 120 213 90 197 92 32 240 214 204 7 229 149 129 28 92 34 228 93 35 159 119 163 92 155 227 111 118 149 21 110 40 121 255 116 234 163 206 248 110 162 90 4 128 37 3 208 110 198 220 46 117 79 230 211 23 47 78 254 124 106 225 125 82 96 150 43 12 247 62 144 136 140 208 191 219 7 31 21 200 38 199 93 140 207 252 38 203 136 114 142 109 131 143 238 31 253 99 15 2 250 189 43 63 16 44 125 112 236 27 142 45 156 189 241 178 33 61 173 14 255 65 65 175 72 92 234 47 88 253 154 45 220 206 20 38 119 143 60 77 127 22 194 113 230 248 165 201 215 233 223 123 42 71 137 143 244 30 249 228 158 255 69 70 64 11 6 243 131 171 63 50 90 219 61 242 20 13 169 7 45 126 125 230 56 53 206 118 143 59 77 219 6 31 177 60 46 59 99 126 227 194 15 217 192 12 113 218 227 152 218 109 153 218 249 190 193 163 174 244 52 237 241 248 213 87 222 189 249 75 189 24 33 127 20 201 253 219 123 15 28 217 252 249 135 182 124 193 131 61 59 134 154 80 251 236 219 90 173 202 86 147 206 151 51 230 77 166 230 78 243 15 214 76 144 6 73 210 120 100 72 178 123 77 12 110 174 84 43 205 186 206 228 10 179 62 223 30 223 58 1 82 3 116 6 176 100 208 73 198 172 180 131 98 62 121 241 123 164 152 197 171 213 87 120 255 210 228 207 127 227 251 174 64 54 217 201 202 15 174 254 208 113 23 186 154 164 63 82 231 159 217 255 188 43 255 171 46 22 61 235 102 82 138 39 47 124 79 176 66 191 208 125 251 198 169 231 236 22 109 74 62 96 30 240 227 103 191 107 126 62 41 107 89 58 118 122 108 16 31 120 58 63 249 187 139 255 135 157 162 229 90 163 191 222 196 238 135 247 62 35 249 40 66 227 240 209 248 223 211 35 4 109 238 120 154 206 140 191 252 232 129 231 101 28 219 164 47 127 252 254 95 187 210 187 175 158 121 201 252 249 243 191 255 99 201 22 102 50 19 63 61 247 18 137 102 209 81 164 206 209 31 173 67 50 253 201 189 95 123 114 239 215 233 133 124 39 29 67 77 56 137 95 172 20 216 183 75 5 139 100 198 147 115 31 114 159 132 152 104 135 177 145 207 201 119 79 9 168 109 120 201 203 21 230 165 214 243 35 198 3 0 0 128 213 221 205 183 166 191 161 144 66 18 235 69 129 108 10 41 9 71 95 166 164 200 51 107 244 127 60 249 141 167 143 188 212 172 96 3 25 101 47 94 129 212 167 183 150 111 167 86 60 45 208 131 199 137 11 47 9 84 169 88 224 190 119 229 7 226 39 4 51 36 208 73 214 147 28 63 186 247 89 199 211 122 252 236 119 196 138 153 107 249 231 167 158 229 78 147 165 49 59 22 213 147 68 210 217 252 234 153 23 45 101 183 88 166 191 113 225 71 95 58 248 44 169 103 201 173 196 193 205 230 76 26 149 106 201 120 173 85 202 101 38 102 67 199 28 164 225 91 78 192 124 79 65 142 14 184 240 181 7 3 77 123 38 175 214 180 102 53 53 144 220 187 142 68 127 39 253 186 157 205 102 43 149 74 161 80 160 127 131 193 224 208 208 144 252 210 53 239 30 49 61 61 77 139 244 215 241 120 188 187 187 219 215 41 208 161 21 139 69 26 1 122 221 215 215 215 138 193 71 156 6 139 166 105 185 92 46 22 139 41 138 130 209 88 119 172 113 156 6 9 184 115 55 254 193 219 182 241 200 176 163 104 38 49 250 230 233 23 228 117 24 11 109 101 214 100 246 43 103 90 170 155 227 77 138 240 94 246 214 159 253 174 96 5 85 137 11 142 241 103 239 62 107 23 69 227 44 242 110 252 195 129 209 175 216 29 5 53 126 252 236 119 221 62 222 24 167 233 79 62 243 178 17 186 99 105 204 167 110 253 170 241 209 227 194 30 44 185 190 112 246 251 191 251 139 241 212 57 15 237 235 78 241 227 215 94 121 238 211 127 39 19 253 236 42 184 217 20 164 97 17 17 52 183 196 159 92 127 29 253 245 80 242 126 201 194 218 119 164 103 243 38 5 174 78 213 235 181 157 197 104 73 39 73 141 27 55 110 44 45 221 9 43 34 209 201 137 51 241 210 53 239 30 113 237 218 181 123 15 144 163 163 157 164 155 217 67 235 233 233 129 37 183 250 41 197 24 240 29 59 118 172 190 169 131 198 141 121 205 126 142 36 145 228 89 52 47 139 152 193 71 28 53 226 27 167 158 243 38 154 13 77 246 235 211 223 146 209 196 179 233 70 147 194 138 245 168 56 72 67 82 181 59 138 102 193 142 230 211 23 127 122 226 27 158 69 51 113 120 231 215 236 68 115 58 63 73 138 220 131 104 54 78 211 9 167 159 44 154 226 111 118 116 54 211 94 190 251 79 95 245 38 154 239 125 47 82 231 254 195 47 191 40 14 240 240 185 15 110 46 175 44 28 157 179 210 205 147 179 124 112 179 234 213 217 188 44 67 215 200 101 155 41 76 123 219 80 9 222 233 112 123 70 152 0 0 214 59 197 98 145 125 74 161 215 186 155 31 172 47 214 172 238 201 9 247 225 25 44 7 70 191 210 160 70 148 33 91 152 250 104 252 239 87 97 52 196 177 215 195 189 15 120 86 237 122 124 51 9 223 19 23 156 35 7 18 145 17 75 93 78 207 15 130 201 148 142 168 74 252 254 109 127 98 167 200 255 241 100 67 138 124 89 68 206 252 119 227 225 193 108 204 203 137 44 178 55 27 63 71 230 218 123 44 164 116 73 52 139 181 172 36 212 200 247 127 247 23 150 19 19 89 121 237 74 229 179 65 26 213 90 197 156 182 57 87 152 227 106 107 47 107 95 38 184 121 83 242 126 249 67 240 251 3 254 38 133 8 107 149 162 187 209 243 170 155 217 238 183 201 213 185 147 170 69 144 98 240 188 148 93 109 105 105 105 122 122 122 149 187 215 193 226 70 114 228 97 201 45 26 109 35 248 103 213 76 29 52 110 204 107 19 167 49 62 115 188 17 29 70 58 82 16 183 208 44 209 172 115 246 198 203 164 249 196 25 60 196 178 207 49 52 185 193 224 102 71 127 179 46 124 101 92 239 241 200 38 243 182 63 123 247 217 70 78 150 254 144 99 57 128 212 248 207 79 61 219 200 111 2 119 219 201 210 195 131 30 153 109 54 102 199 249 115 178 186 217 62 78 227 221 155 191 32 165 219 220 239 200 171 103 94 18 196 58 159 159 117 40 118 200 77 49 212 24 127 115 73 203 155 55 153 73 93 176 146 191 254 187 79 62 177 36 83 194 218 145 160 191 77 227 246 66 74 212 250 209 46 112 47 101 158 18 104 151 206 119 204 175 219 154 166 177 138 33 18 137 200 47 93 126 186 158 159 159 156 156 52 196 107 211 99 112 29 59 192 201 157 120 60 222 169 74 46 24 12 194 146 91 135 30 211 76 246 118 231 82 163 40 225 112 120 53 77 29 52 197 152 215 230 14 49 62 243 27 241 10 187 71 158 214 53 92 182 112 155 100 37 167 219 4 153 52 230 211 23 37 69 51 137 209 176 154 40 150 51 98 213 75 154 236 250 204 113 113 238 14 65 254 56 130 246 34 238 201 148 147 110 22 207 213 155 115 138 18 57 113 225 123 146 194 215 28 167 65 219 54 232 12 142 71 134 45 211 137 232 138 92 44 154 85 37 78 35 175 7 178 95 158 124 157 158 136 4 99 104 55 74 98 137 41 123 189 83 187 183 247 30 176 92 180 28 211 124 242 47 37 149 183 46 103 45 211 210 113 152 39 246 177 136 35 79 184 174 214 106 85 86 55 23 172 198 124 41 123 203 66 254 222 141 211 24 74 126 194 213 112 53 81 122 106 53 23 73 232 178 140 179 185 92 177 136 138 238 177 9 28 103 83 230 25 79 11 160 89 24 161 195 119 46 137 43 181 130 120 169 190 2 235 241 109 186 108 117 236 0 231 111 110 145 184 92 19 184 67 51 63 51 128 38 66 66 121 223 190 125 122 120 6 153 241 142 29 59 204 223 133 150 154 58 104 206 121 244 173 197 92 87 177 212 123 242 200 139 156 6 34 53 124 246 198 63 212 127 142 207 146 150 218 110 51 35 80 119 172 58 238 157 164 216 209 189 207 24 30 80 199 233 131 164 242 197 186 153 203 89 97 22 232 226 254 44 100 46 11 150 138 131 52 28 247 94 210 50 2 185 105 210 169 137 149 7 126 92 102 91 26 156 93 35 79 233 167 140 78 1 141 39 141 152 177 225 131 99 95 183 83 243 98 69 206 157 38 106 159 30 165 28 179 121 152 141 249 155 159 252 91 250 51 222 254 213 47 254 181 32 200 129 212 234 11 143 253 68 222 146 73 254 190 248 219 255 217 81 4 235 137 50 88 31 240 178 139 250 228 95 10 54 52 87 45 49 112 140 60 185 111 96 197 182 149 149 193 205 249 114 206 188 201 98 102 194 66 55 223 21 144 195 46 117 179 223 223 68 97 225 98 82 32 171 155 107 110 246 17 97 102 196 42 109 51 65 176 99 178 16 136 253 181 142 222 220 197 197 21 5 122 250 250 250 86 179 123 156 184 36 233 211 73 106 134 27 219 22 205 119 68 62 13 214 186 14 30 60 40 121 58 154 110 234 160 41 198 188 54 113 26 2 193 68 42 211 236 56 236 235 218 243 200 129 231 143 106 207 124 52 254 247 36 4 237 162 38 78 93 249 129 216 177 74 154 251 209 3 47 112 137 56 104 119 143 31 250 142 32 5 242 228 194 41 241 225 136 163 147 251 157 50 114 136 219 119 148 221 226 135 16 87 147 47 217 145 175 231 184 248 142 120 125 234 27 151 65 89 173 39 7 164 63 146 188 199 207 126 151 250 102 95 117 69 164 200 31 222 251 140 57 132 125 184 247 65 59 221 28 86 187 238 108 232 100 204 226 200 96 129 90 181 228 63 157 248 11 177 132 221 150 220 79 170 221 236 171 126 104 203 23 222 72 254 72 16 67 34 8 11 145 40 18 190 226 40 180 218 61 221 92 173 85 204 25 232 136 217 69 11 43 50 188 176 189 110 130 52 234 210 179 105 186 185 92 41 203 175 44 158 20 56 208 99 251 77 100 253 205 193 182 153 23 216 49 82 67 44 206 196 75 139 117 238 125 211 235 172 178 118 100 29 210 177 88 204 215 65 228 114 185 86 139 102 31 226 52 164 159 223 90 109 234 160 41 198 220 118 97 136 130 168 6 210 100 130 2 34 243 233 139 142 26 209 46 175 28 233 69 146 128 118 106 94 28 75 48 239 20 38 209 39 20 190 180 185 184 125 113 144 70 58 63 217 96 124 176 238 207 46 150 51 153 194 36 251 57 61 162 136 91 166 17 251 131 135 94 178 123 134 161 207 31 63 244 109 234 158 213 120 58 40 242 195 59 191 102 57 239 83 240 80 36 153 223 218 49 177 198 145 205 79 200 15 221 241 171 175 156 186 245 75 177 104 126 225 177 159 216 85 51 113 74 36 103 155 191 66 28 121 66 187 227 210 216 85 170 26 35 67 45 68 179 165 179 121 89 77 6 238 37 161 115 103 85 205 172 27 226 194 113 156 201 223 179 144 90 173 102 178 201 168 221 134 33 37 98 8 104 127 251 21 61 209 52 109 102 102 134 228 29 155 43 45 30 143 247 245 245 113 190 207 201 201 73 186 245 22 10 5 223 221 224 72 125 91 61 71 175 162 40 35 117 88 69 72 139 232 95 90 141 110 210 180 62 187 84 208 153 249 249 121 221 11 75 91 245 244 244 208 190 4 170 139 213 157 98 85 202 46 213 83 38 155 167 82 209 49 234 47 6 7 7 205 25 112 91 218 61 31 147 169 141 58 166 239 133 246 24 137 68 196 187 144 63 185 116 68 122 34 60 187 214 104 53 218 47 173 175 143 12 173 70 93 178 28 10 241 200 208 250 244 12 96 196 218 250 132 73 232 104 95 186 157 208 182 52 164 100 117 130 30 10 26 161 189 251 234 254 123 218 239 125 247 221 103 156 80 189 87 212 224 232 232 168 217 157 47 191 119 214 254 245 166 232 45 125 104 12 23 157 38 250 92 172 71 221 142 176 228 215 83 95 205 120 203 102 1 247 102 234 174 250 233 106 240 217 108 229 62 83 194 114 90 153 253 82 116 88 58 115 41 199 144 175 205 126 67 153 90 120 191 108 239 81 22 112 242 162 67 130 142 135 247 62 35 72 198 220 223 181 71 224 5 159 180 15 159 189 40 244 155 170 74 92 156 1 122 222 41 122 88 172 8 197 65 26 2 234 113 195 143 108 179 143 120 57 123 227 101 241 113 145 44 118 60 77 150 211 55 197 138 156 186 100 23 15 253 222 149 31 218 117 198 56 59 98 99 22 75 85 65 16 179 133 159 198 169 6 161 88 52 95 95 56 43 216 182 145 224 102 243 182 108 254 227 130 85 144 134 229 76 193 123 195 18 113 61 49 165 137 169 220 180 170 11 127 243 66 230 218 189 167 5 83 124 115 119 124 139 237 227 250 221 212 212 109 149 132 78 55 102 186 75 93 186 116 137 187 167 46 213 161 123 222 225 195 135 89 17 112 227 198 13 86 6 113 219 210 253 146 86 160 127 233 6 73 255 210 34 246 254 71 171 25 75 237 186 68 55 212 137 137 9 86 108 233 154 134 176 19 61 156 238 228 86 16 44 229 118 196 118 82 151 125 102 137 223 244 238 249 76 17 192 180 2 181 79 123 97 115 29 232 143 31 36 230 118 236 216 225 234 20 147 100 185 118 237 26 219 97 122 61 95 199 220 26 29 203 213 171 87 185 14 235 150 64 235 239 219 183 79 32 157 39 235 112 59 114 12 236 214 87 211 183 229 220 162 180 71 26 79 199 167 44 214 146 141 115 199 54 254 241 199 31 27 35 76 253 225 14 193 213 222 185 246 73 249 153 237 129 54 164 189 28 60 120 208 242 96 61 140 176 252 215 51 151 203 177 221 99 179 128 187 53 117 15 253 116 53 248 52 116 118 93 245 221 157 188 104 188 21 132 157 116 36 100 204 1 223 90 252 134 34 142 217 61 117 229 7 110 27 156 79 95 116 76 229 38 78 93 103 78 37 33 47 244 133 222 226 35 226 205 197 83 36 73 17 138 43 158 204 185 79 29 77 66 252 201 35 47 62 114 224 121 65 225 24 71 103 243 163 7 94 240 86 138 69 172 200 235 129 52 207 91 110 37 152 221 184 125 240 247 238 61 29 9 141 217 109 141 61 1 111 92 248 161 32 58 153 228 242 115 159 254 59 65 221 108 177 130 23 200 119 199 224 102 115 168 9 43 61 43 53 11 25 58 107 149 76 195 32 225 82 55 7 154 231 175 117 91 241 100 33 115 85 176 180 39 110 61 41 144 77 166 17 12 132 218 231 2 173 27 179 249 174 204 106 56 129 231 140 238 136 116 95 180 116 98 209 61 242 244 233 211 220 125 215 88 106 190 133 235 92 171 99 183 148 90 163 221 153 51 103 153 117 167 204 82 221 43 38 122 156 51 197 75 180 162 123 62 171 36 116 52 116 150 9 194 116 129 46 127 126 105 101 58 185 118 29 230 206 44 117 227 204 153 51 150 167 204 80 111 118 59 162 97 209 159 136 196 253 49 123 13 117 105 197 138 36 22 106 83 50 141 157 110 201 230 14 176 186 205 124 212 110 247 206 189 189 117 235 150 165 61 232 90 220 114 12 61 140 176 231 175 39 219 178 43 83 247 214 79 87 131 207 117 155 59 64 221 111 125 199 209 208 89 225 254 146 198 188 54 191 72 138 125 168 231 110 252 131 252 84 54 157 179 78 17 26 159 217 255 124 43 14 36 157 159 20 79 110 115 172 207 34 14 110 118 148 221 110 147 93 236 30 121 250 223 28 253 129 56 246 163 62 158 47 139 31 66 28 139 53 122 83 228 71 247 62 107 246 97 79 46 188 247 211 19 223 176 51 9 146 218 135 119 126 77 114 239 205 10 110 38 197 252 198 133 31 9 86 248 230 195 127 35 174 249 231 164 224 109 213 255 248 226 89 113 223 184 192 104 78 122 150 43 37 139 75 106 165 96 254 80 9 24 193 205 99 46 117 115 243 146 105 184 113 54 151 181 28 155 188 185 100 74 140 154 236 178 62 35 97 37 194 28 117 123 21 61 161 91 20 123 211 210 157 166 198 108 161 193 193 65 241 237 205 238 126 124 254 252 121 193 173 218 242 150 76 50 133 19 133 250 143 209 220 189 217 172 33 188 5 55 219 201 130 123 79 65 43 131 10 90 212 61 115 79 60 12 157 221 153 101 75 96 240 223 62 69 97 79 46 117 155 84 14 187 95 61 156 131 219 181 229 222 105 47 50 106 158 198 202 236 235 229 164 21 237 113 100 100 132 93 141 149 80 142 112 131 79 167 76 240 208 226 97 239 220 121 17 156 11 243 128 120 27 97 87 95 79 193 19 157 188 169 123 182 4 87 131 207 125 113 244 184 23 163 29 182 41 238 24 55 8 107 19 167 177 103 228 105 113 44 178 158 75 78 156 197 130 117 70 94 159 249 239 98 177 216 148 58 213 22 247 146 89 135 132 122 219 133 250 114 124 230 184 83 12 241 46 113 251 98 111 55 255 156 100 53 217 206 67 175 14 239 252 186 231 17 187 52 249 186 64 142 115 103 156 20 243 7 87 127 40 62 70 146 218 236 201 21 24 179 99 141 61 121 127 179 216 217 124 100 243 19 15 109 249 130 184 5 135 192 232 30 91 127 243 249 25 135 10 2 92 96 116 117 165 244 180 156 20 104 25 223 28 48 146 55 7 163 107 117 121 170 214 92 5 105 92 49 94 91 4 55 7 99 177 72 191 141 110 142 221 61 228 64 187 197 105 112 33 19 187 119 239 214 117 131 30 43 201 77 183 183 44 207 161 71 57 211 34 238 87 90 29 61 116 129 110 255 172 146 48 139 75 253 71 103 246 86 189 111 223 62 253 230 74 159 179 45 91 102 145 99 151 114 226 204 110 169 30 135 77 29 99 157 103 118 129 16 173 235 30 13 133 157 220 161 206 208 216 114 67 231 232 211 53 86 227 68 51 181 182 117 235 86 218 187 17 135 202 246 228 234 213 171 108 203 198 202 186 235 145 125 6 224 36 20 29 62 219 61 218 132 54 212 83 2 115 35 99 246 26 178 137 132 125 76 81 104 106 196 210 150 196 150 172 71 28 113 237 115 171 177 9 254 60 236 221 210 239 75 199 165 7 57 112 190 103 61 19 92 131 35 204 237 81 252 245 180 115 75 187 50 117 207 150 224 106 240 245 47 130 165 49 115 207 42 27 48 227 199 154 229 211 232 235 218 67 34 73 172 135 228 165 243 117 103 157 231 236 143 20 7 10 15 216 196 40 95 188 37 242 139 111 27 124 84 28 1 236 152 199 122 88 232 24 158 119 19 164 97 55 217 206 109 175 44 19 158 72 34 174 119 99 116 175 254 32 116 252 204 248 203 142 222 244 253 163 127 204 89 200 234 4 55 11 156 205 212 206 87 31 248 43 241 230 239 222 252 133 200 216 226 91 4 190 106 215 193 205 188 18 173 186 255 182 238 114 181 190 26 108 154 244 100 103 52 58 50 181 112 154 217 144 63 204 158 132 109 112 115 244 238 92 100 53 216 94 179 215 201 152 185 219 91 165 82 209 111 204 150 209 189 230 27 179 113 247 165 155 40 167 54 88 113 105 233 129 99 69 30 221 173 217 13 15 29 58 100 168 58 46 153 49 231 6 182 155 84 39 179 212 124 179 183 204 101 209 186 238 249 76 222 104 99 23 164 144 116 93 66 123 103 135 78 48 181 142 83 45 156 250 49 68 18 73 22 238 204 234 33 185 172 82 49 86 214 167 100 25 75 185 225 226 66 90 185 51 206 95 184 86 142 45 247 40 66 207 87 70 1 14 118 76 36 127 163 215 47 203 118 101 23 169 229 193 193 65 61 112 188 145 189 155 79 22 59 176 180 119 182 77 118 222 155 231 17 230 175 87 194 175 167 171 128 37 75 83 111 164 159 242 131 111 116 192 104 141 77 186 194 90 123 188 206 70 211 205 107 153 79 227 225 61 207 252 227 201 63 19 175 35 41 157 197 250 155 196 171 140 179 57 157 23 39 176 75 88 109 210 104 144 134 216 77 238 115 74 166 49 47 29 164 65 99 40 72 69 226 170 87 123 54 63 237 249 164 11 20 121 60 50 76 103 170 158 159 238 117 250 87 166 181 71 14 60 47 249 139 196 93 197 217 156 224 230 227 87 95 17 56 155 31 221 249 101 113 132 134 111 217 217 252 43 209 195 128 125 38 13 218 175 219 80 19 214 101 91 182 138 199 88 110 182 32 250 177 53 164 172 217 149 209 85 156 198 116 234 12 179 33 239 111 238 239 177 142 13 83 3 225 192 221 172 121 74 160 237 178 62 113 254 209 75 151 46 9 166 127 113 186 65 47 172 96 123 109 25 25 177 187 231 113 90 115 102 102 134 85 228 134 83 205 124 79 53 215 63 19 171 1 71 173 192 173 96 169 74 91 215 61 203 71 17 86 125 154 35 101 37 221 111 108 94 5 234 210 214 173 162 43 6 247 72 35 63 245 144 235 27 119 198 197 89 171 217 157 234 1 18 62 211 116 52 87 137 20 44 131 100 216 39 16 31 227 98 247 182 119 238 41 136 149 149 190 149 254 251 102 141 176 171 175 167 171 239 130 165 169 123 238 167 171 193 55 58 96 140 167 33 169 185 184 148 141 25 164 65 44 135 48 174 73 237 248 190 174 61 15 239 125 198 113 53 146 206 142 177 206 78 65 26 79 73 136 230 73 15 57 206 26 12 210 160 227 114 76 244 38 110 95 114 82 32 181 243 200 1 217 240 110 199 188 120 163 3 143 120 62 233 130 138 226 37 45 253 227 127 126 250 205 211 223 146 17 205 170 18 127 242 200 139 150 162 89 96 204 226 200 96 249 224 230 119 111 138 66 44 190 176 251 107 206 45 76 136 131 52 246 219 75 127 135 60 122 98 245 111 231 108 206 21 231 154 248 213 246 251 154 147 188 185 86 171 202 123 199 203 90 110 58 245 17 115 164 188 110 30 72 238 181 220 48 170 222 185 123 249 253 129 80 155 249 155 201 152 233 222 207 222 207 244 169 126 146 129 146 108 140 7 183 200 208 34 150 247 108 174 104 28 123 183 54 103 91 99 197 186 89 119 114 82 158 83 3 226 165 62 83 16 133 229 44 171 214 117 207 60 110 156 104 230 2 112 29 19 156 25 29 230 156 205 2 73 71 50 133 237 131 121 101 214 111 202 46 210 19 137 216 157 113 159 176 152 139 158 211 131 221 41 245 225 218 181 107 31 124 240 129 209 25 218 68 94 183 145 37 179 15 48 6 52 152 150 147 17 61 236 157 179 97 199 21 140 253 122 30 97 221 222 36 191 158 156 114 53 71 147 59 154 122 35 253 148 31 124 187 71 2 243 119 141 118 177 49 107 128 175 89 156 134 206 129 209 175 204 167 47 57 202 98 177 215 217 49 129 177 76 80 129 56 72 195 174 112 137 88 225 57 6 105 216 101 85 51 112 172 20 40 51 41 208 46 67 133 29 83 78 181 15 61 71 138 139 31 78 228 179 80 115 117 4 57 236 140 217 185 198 158 156 191 57 87 94 18 132 38 31 217 252 132 163 179 89 236 174 22 247 196 109 112 243 154 16 108 82 62 141 178 27 103 243 237 212 135 43 239 82 43 38 5 170 193 216 96 210 250 91 28 15 221 145 74 237 38 154 13 99 166 219 63 27 248 72 247 102 210 16 187 119 239 22 123 179 186 235 216 45 21 7 70 115 57 167 216 251 61 119 167 164 27 57 187 84 172 59 205 238 94 249 165 118 30 184 150 118 207 60 50 134 203 86 63 11 236 82 153 212 215 150 34 70 236 162 230 194 73 205 83 205 236 202 50 139 227 80 105 88 216 13 185 39 10 110 91 115 230 10 178 144 157 59 119 202 87 229 48 71 28 249 238 198 214 59 30 178 228 222 57 107 225 102 16 114 43 8 6 74 126 132 117 36 191 158 174 178 49 218 153 186 231 126 154 131 52 236 6 95 220 67 182 159 146 214 222 121 172 125 221 19 221 15 42 35 157 251 18 187 45 19 33 139 181 35 73 79 153 84 208 226 136 222 190 174 221 86 58 47 227 20 31 34 242 203 210 33 139 75 27 250 36 10 13 202 76 10 164 135 147 62 167 118 86 124 57 211 151 26 233 146 128 140 211 241 58 66 103 243 225 61 207 244 121 234 131 56 184 121 32 190 69 50 184 89 236 241 125 104 139 115 217 148 87 207 190 40 94 65 208 19 183 193 205 190 149 33 194 37 173 176 142 46 79 174 38 5 78 204 190 179 82 115 175 112 84 15 36 173 127 186 81 252 170 26 188 227 91 109 195 32 13 67 241 208 189 153 157 70 166 231 79 229 238 91 226 91 47 167 60 204 250 210 82 52 115 119 92 82 42 220 210 91 183 110 201 171 1 241 175 234 102 215 151 76 196 103 235 186 103 169 117 140 128 1 206 173 72 159 11 146 94 115 176 217 9 44 197 58 167 135 4 135 192 105 41 182 41 110 244 184 51 206 109 200 89 75 101 101 46 26 174 136 29 29 172 7 71 163 57 229 153 157 240 242 182 119 206 194 185 231 4 206 199 207 46 245 60 194 174 190 158 92 247 220 6 44 53 216 79 249 193 103 215 225 166 6 178 179 8 104 233 134 13 210 240 173 97 156 6 43 157 101 162 84 237 202 154 136 99 21 54 37 31 112 108 57 157 159 20 123 142 45 35 19 174 59 133 19 136 131 52 28 157 205 142 157 151 153 20 24 143 12 203 135 53 223 85 183 147 194 6 55 121 62 209 83 246 65 26 142 144 133 60 121 228 197 167 108 202 61 174 176 19 27 99 22 215 216 147 119 211 138 195 139 31 218 234 160 155 95 61 243 98 35 110 111 15 121 244 216 136 5 15 147 2 215 16 87 21 182 111 204 188 195 60 42 84 185 124 26 195 253 159 176 220 42 22 186 243 80 221 134 65 26 172 49 155 39 215 91 38 210 18 168 64 54 32 193 172 95 217 187 163 192 83 197 169 43 61 15 180 188 26 144 204 220 108 183 130 165 19 174 117 221 51 175 96 8 5 46 23 50 157 26 121 209 236 115 89 181 155 75 196 198 223 5 86 102 210 181 251 133 129 219 208 28 150 205 201 44 203 217 144 36 16 119 239 222 125 248 240 97 15 162 153 44 153 27 76 193 136 121 219 59 55 95 144 203 3 205 29 47 171 249 60 143 48 251 76 226 248 245 52 207 61 104 196 212 221 246 83 126 240 237 190 47 122 193 81 246 65 209 177 62 101 167 178 198 113 26 172 116 246 57 121 157 167 22 222 183 44 218 87 210 50 130 173 100 130 10 196 251 37 233 105 217 136 99 153 21 129 159 251 189 43 63 112 116 54 59 86 60 145 153 20 120 84 34 130 220 244 20 49 37 60 174 7 87 211 48 104 240 119 143 60 229 42 141 160 32 9 157 72 173 14 200 6 55 11 38 23 110 75 238 23 20 58 209 251 240 234 153 151 196 237 11 194 172 29 131 155 185 204 205 13 162 121 21 217 129 38 165 114 211 170 37 201 53 39 102 79 148 181 28 35 184 249 158 111 238 63 108 185 97 34 116 199 237 20 14 70 218 240 2 205 26 179 30 229 105 220 29 245 223 217 217 187 47 123 99 54 135 171 10 194 21 196 242 145 11 187 100 239 163 92 130 14 203 4 192 130 150 197 75 125 114 193 205 173 235 158 89 235 24 138 141 213 40 122 154 191 53 49 15 115 118 5 46 190 217 250 107 85 175 19 201 29 187 192 231 77 195 66 42 147 107 220 45 71 142 28 57 117 234 20 187 59 201 9 148 146 123 55 71 15 175 184 62 76 76 176 75 73 53 74 30 139 120 132 57 219 16 127 61 185 136 32 241 183 76 62 0 70 166 159 220 224 200 15 62 59 53 144 181 121 189 206 185 111 163 178 246 113 26 174 164 243 229 201 215 205 186 89 28 167 65 194 203 193 167 229 84 80 250 224 54 235 220 109 226 201 136 2 87 113 58 63 41 222 163 142 99 68 132 227 164 192 222 196 110 15 213 73 178 13 71 83 216 33 95 18 156 158 25 182 15 254 158 160 12 184 91 28 211 80 200 39 211 16 180 51 16 219 42 238 195 119 255 233 171 142 237 11 122 34 62 4 95 179 131 155 171 166 148 20 178 186 185 25 241 205 165 74 81 126 101 46 72 67 91 249 59 111 79 124 171 170 90 120 245 194 193 168 114 55 101 94 88 105 187 108 74 116 163 226 252 70 116 175 98 239 94 236 207 217 220 173 209 156 83 76 32 146 28 11 127 152 165 24 151 250 215 78 123 9 194 166 29 151 114 137 147 217 198 105 16 44 111 252 205 237 158 111 101 32 50 43 116 216 223 175 221 74 28 243 46 168 41 35 233 47 189 229 186 97 39 133 245 56 90 118 77 193 47 239 250 96 234 201 161 73 52 155 163 93 5 161 174 102 145 164 87 190 144 207 164 225 115 25 210 237 97 239 2 11 231 202 190 232 66 188 241 17 118 245 245 108 138 169 123 182 4 207 131 111 103 219 110 139 201 119 30 107 83 247 196 155 116 38 169 250 136 175 201 101 255 78 93 249 129 135 244 17 142 147 17 237 84 47 201 244 55 79 127 75 102 14 156 99 132 137 227 164 64 59 197 223 182 52 69 46 91 26 179 216 83 43 206 151 108 150 191 118 139 182 247 238 23 108 245 157 183 254 173 120 58 224 221 70 108 131 155 103 115 55 197 71 33 246 118 175 47 42 210 206 230 178 150 99 131 52 124 166 74 129 99 91 62 107 185 97 34 156 212 95 132 130 225 38 214 6 111 22 122 221 7 186 197 246 213 161 187 166 32 132 209 85 112 51 39 146 56 117 40 78 215 85 40 20 184 130 97 50 218 203 3 220 46 168 147 122 206 99 26 4 82 36 150 247 254 230 118 143 171 126 204 106 29 218 187 33 197 102 102 102 220 254 102 205 230 217 213 147 114 80 131 122 185 19 58 167 7 15 30 228 186 205 122 49 73 245 234 85 108 184 12 208 230 84 30 180 161 33 215 104 195 51 103 206 208 10 150 165 233 204 35 195 58 26 233 72 105 67 35 133 8 125 174 127 114 248 240 97 249 67 62 127 254 188 192 62 27 223 59 119 198 141 168 12 46 186 64 79 178 193 157 44 111 35 220 200 215 147 27 112 73 83 247 108 9 50 65 32 118 15 45 22 138 200 105 66 97 199 211 46 113 26 6 71 247 62 67 226 216 78 86 210 231 164 59 101 230 249 201 122 116 210 23 197 101 11 237 34 4 28 53 171 93 39 79 92 248 158 100 101 108 199 136 8 113 160 72 61 194 225 233 166 159 160 22 121 163 27 153 240 199 97 105 204 98 79 173 216 79 188 226 201 109 225 172 23 151 82 93 52 59 122 139 125 78 145 30 226 189 11 74 12 122 166 86 171 249 239 86 13 92 101 74 21 217 41 140 55 102 223 97 131 52 42 213 42 231 41 183 12 210 32 161 108 100 210 8 175 93 65 68 129 106 212 239 118 122 201 92 115 65 102 186 97 179 119 71 177 50 230 66 56 184 219 170 157 175 203 44 242 124 166 31 148 237 130 1 26 135 203 33 77 157 100 93 200 198 143 224 173 235 158 121 42 21 59 38 134 110 214 43 195 185 202 45 64 74 136 237 103 182 142 209 26 247 251 62 173 204 30 248 124 29 174 65 203 84 30 172 110 246 153 202 35 11 134 218 188 83 179 243 222 28 135 224 120 200 108 183 197 81 221 30 246 206 253 102 194 89 139 97 249 150 101 95 60 140 176 219 175 167 56 20 74 210 212 61 91 130 204 164 67 75 204 83 3 141 169 177 27 25 210 24 171 231 101 153 148 152 22 70 114 83 172 246 102 77 193 9 137 136 232 44 10 68 42 73 240 95 159 254 150 184 63 118 133 6 231 220 20 234 51 144 201 69 205 28 215 176 88 241 59 40 176 65 143 89 150 85 225 15 214 174 202 122 203 67 39 177 41 162 217 14 113 197 19 187 144 98 179 123 88 198 97 204 49 147 153 144 20 205 62 137 72 15 193 82 59 111 119 64 66 248 198 194 214 5 168 245 170 123 108 29 190 213 161 234 38 115 243 249 137 215 86 8 238 149 25 232 182 13 29 181 12 210 232 186 27 217 172 4 66 74 251 205 8 20 84 239 211 21 0 55 179 135 211 13 130 56 13 113 8 135 165 170 176 243 69 113 158 81 179 252 18 187 189 29 157 226 130 16 8 163 219 173 235 30 247 235 54 167 101 89 159 37 231 240 115 132 196 141 64 113 154 221 150 226 89 92 118 5 153 5 250 134 11 240 229 210 117 251 228 242 45 88 186 174 101 30 66 204 197 204 27 223 187 99 103 168 77 187 90 137 30 70 216 237 215 83 28 167 33 105 234 158 45 193 213 224 11 186 173 215 73 241 129 85 203 167 81 143 79 120 225 245 83 207 58 170 231 144 75 119 178 56 195 131 93 162 12 234 207 207 222 125 86 236 61 221 63 250 199 118 211 209 178 133 219 226 94 113 185 35 244 240 12 121 209 236 115 154 209 232 56 41 112 143 87 103 179 56 174 186 254 107 64 198 114 60 79 92 120 73 207 180 109 135 160 140 203 164 116 170 13 90 147 172 72 176 130 165 49 123 208 187 231 166 223 249 171 95 252 107 87 14 102 115 61 148 119 111 254 226 63 252 242 139 146 162 217 39 140 244 240 57 121 205 237 28 213 193 128 194 104 104 235 231 228 88 196 90 124 84 234 126 219 114 37 191 202 87 37 121 103 243 116 234 163 84 250 202 10 245 83 94 161 96 70 135 143 89 61 75 4 186 34 189 250 235 168 18 243 181 31 67 117 44 23 209 77 215 82 1 116 223 133 43 136 160 7 131 26 112 66 147 212 36 187 212 44 46 45 61 88 244 137 94 23 141 237 134 165 252 18 40 33 241 82 159 169 242 159 33 50 72 61 24 33 170 173 235 158 160 44 8 167 74 117 151 179 171 243 75 221 51 43 126 93 111 89 30 142 229 84 54 58 95 247 221 119 159 93 176 41 29 148 101 76 2 109 66 13 178 210 205 82 180 141 214 177 212 88 212 115 189 17 201 131 21 79 218 179 83 246 242 123 23 215 190 214 71 149 30 162 4 251 117 59 194 250 215 211 114 220 204 95 79 206 211 111 217 13 25 83 247 102 9 30 6 223 24 85 46 217 34 181 223 96 52 127 103 176 122 113 26 215 103 142 151 181 236 212 194 251 83 11 207 13 247 62 112 120 231 215 237 202 145 136 103 143 13 152 84 157 88 231 209 30 73 173 114 62 236 249 244 197 95 159 254 150 88 52 171 74 252 136 125 6 55 113 178 54 226 236 141 151 169 99 219 6 31 37 65 73 199 78 154 82 190 174 135 79 162 226 137 216 225 29 143 12 123 118 223 214 253 247 239 219 63 255 100 233 121 227 241 67 223 54 100 189 62 205 81 175 125 72 131 118 84 179 173 72 34 120 18 160 115 65 141 28 24 253 138 248 17 136 214 209 29 222 230 115 106 224 33 78 227 248 181 87 158 220 251 117 67 119 30 191 250 10 125 162 231 123 166 127 37 243 58 235 123 121 227 194 15 31 221 249 101 106 138 20 243 27 23 126 36 78 26 109 166 145 132 24 50 219 134 20 119 89 35 234 254 230 224 194 74 97 186 10 148 165 117 243 233 171 255 47 251 182 90 173 105 76 230 230 88 184 223 178 220 73 76 237 210 107 107 183 167 179 217 16 61 132 254 35 190 62 199 136 68 109 79 79 143 229 173 139 238 154 130 166 4 75 117 33 229 40 98 140 208 2 234 3 235 109 229 124 186 102 137 67 135 96 215 103 241 82 189 111 135 14 29 50 106 151 216 29 126 139 186 39 222 118 164 142 231 243 171 187 238 244 152 102 227 96 5 51 237 244 221 209 49 234 26 81 96 9 156 188 211 3 36 116 251 161 246 13 217 36 227 56 164 61 146 104 99 107 199 208 230 177 88 204 109 98 13 90 223 131 198 144 223 187 185 76 38 141 143 126 200 122 74 111 153 14 187 26 97 253 235 233 187 27 99 35 254 122 210 39 142 135 47 105 234 30 44 193 219 224 155 69 179 254 45 131 104 246 173 102 62 141 51 227 47 179 90 150 212 51 105 187 131 219 190 50 156 124 128 85 120 239 93 249 129 32 18 128 54 49 107 50 199 98 212 191 57 251 93 106 115 87 189 218 54 233 51 93 73 59 118 248 241 67 223 105 36 144 154 68 228 155 78 65 32 66 125 211 37 94 65 28 36 61 210 64 182 56 146 236 226 241 161 93 191 242 219 255 145 134 61 172 38 210 249 41 246 241 131 142 154 30 18 236 20 173 248 76 157 188 240 61 82 198 36 157 169 243 236 200 79 46 188 71 159 143 207 252 134 221 145 64 55 123 96 54 123 243 127 253 175 159 213 117 39 167 116 207 77 159 32 73 125 239 177 205 41 18 250 199 239 255 53 253 121 238 73 43 38 246 201 84 189 238 239 217 61 187 104 241 36 86 173 107 208 133 140 59 221 172 85 138 141 136 81 173 90 214 228 42 5 78 167 62 98 107 107 47 187 118 86 254 92 190 111 251 83 214 46 219 240 128 254 162 61 157 205 220 13 181 29 102 225 120 238 134 56 95 149 99 54 43 186 235 203 220 173 91 212 189 85 120 58 114 37 190 185 26 144 146 154 181 145 99 148 28 255 22 33 185 119 46 192 134 212 182 231 148 121 110 71 184 137 95 79 87 67 237 193 18 228 33 81 206 101 42 148 175 133 185 65 88 141 124 26 233 252 164 89 231 145 12 34 169 100 104 53 95 221 135 42 118 202 90 198 236 118 69 71 104 115 113 220 45 201 44 87 49 18 251 71 255 88 44 61 197 78 217 198 233 77 236 18 175 32 62 94 203 2 135 146 200 84 138 17 8 119 129 162 173 11 226 184 224 20 215 31 168 164 70 149 86 35 163 178 116 96 123 51 230 92 121 201 210 55 204 149 212 150 79 187 225 13 121 223 182 60 108 213 107 213 70 206 134 213 152 141 2 174 214 31 135 114 217 194 116 60 178 74 10 195 179 179 153 200 151 203 204 193 198 44 103 4 246 132 7 244 244 115 97 37 218 158 206 230 6 141 25 128 13 101 201 108 112 191 171 248 93 96 198 156 195 209 46 108 122 35 27 243 242 61 181 213 151 102 199 116 197 186 96 114 140 100 176 251 29 191 185 137 35 168 181 163 123 159 117 120 202 108 160 108 222 157 155 122 3 249 98 231 37 50 55 123 110 156 196 104 35 227 169 43 90 183 103 208 3 118 15 66 150 198 44 159 158 217 12 151 195 174 145 166 124 78 30 229 70 150 218 62 25 51 210 80 15 78 176 56 233 113 235 231 1 35 230 225 246 74 183 110 75 41 202 233 102 179 179 89 171 84 216 76 26 99 91 62 107 158 17 104 68 54 251 253 129 72 243 50 243 180 8 136 102 208 25 180 206 146 197 53 125 128 187 187 234 165 75 16 205 50 198 188 26 249 52 92 249 122 237 16 204 210 35 157 215 136 82 228 154 210 211 72 139 105 176 108 222 195 123 159 17 43 72 113 208 182 227 164 192 145 198 186 103 151 69 164 241 211 125 255 182 63 81 155 84 96 226 210 228 235 242 43 55 226 199 61 117 235 87 236 219 135 182 60 225 185 169 111 126 242 111 91 23 193 44 152 251 168 48 5 252 212 128 133 135 213 50 8 216 16 163 190 149 85 172 157 239 100 181 178 231 99 44 106 249 154 92 38 141 127 185 244 159 185 79 10 204 140 64 53 24 219 189 229 49 139 39 132 80 159 254 240 16 81 162 109 152 179 25 0 224 10 46 237 137 124 146 53 96 134 139 147 134 104 182 163 229 249 52 198 235 51 2 27 108 132 100 177 216 7 252 232 129 231 27 23 100 36 205 101 68 179 46 76 29 43 17 90 66 157 164 93 56 186 93 197 161 213 226 73 129 141 63 66 208 243 73 35 210 89 160 104 233 184 28 125 249 146 100 11 83 150 201 82 44 141 249 200 230 207 123 222 17 231 111 214 167 253 121 19 205 180 173 160 140 182 35 226 40 17 193 220 71 54 165 70 216 102 106 96 143 141 203 185 84 15 213 152 78 125 40 223 207 170 215 2 221 203 218 215 42 91 139 153 143 111 188 198 165 209 168 86 107 172 110 182 116 54 43 126 181 39 58 160 63 72 180 191 179 217 183 42 153 142 0 88 215 150 44 78 141 12 92 49 50 50 98 72 103 136 102 129 49 183 60 78 35 211 112 165 140 225 222 7 254 224 161 151 196 235 244 117 237 105 68 144 233 114 214 85 11 71 247 62 227 65 253 63 125 228 165 198 163 74 196 147 2 29 115 113 200 240 224 216 55 60 247 115 247 200 83 194 165 79 63 236 126 232 204 231 139 148 189 165 91 221 210 152 247 15 29 243 28 95 193 249 170 73 52 127 233 160 59 75 27 136 111 249 223 158 120 141 68 115 131 71 189 173 71 228 111 190 190 96 175 155 253 14 254 230 229 78 218 184 156 75 117 49 90 214 114 87 166 222 148 236 103 165 90 241 118 128 69 45 47 163 185 169 51 167 175 253 196 36 184 239 137 230 88 184 223 210 217 220 23 187 19 94 21 85 187 214 197 5 26 113 26 160 51 88 157 224 102 115 186 64 224 10 26 192 157 59 119 250 234 217 51 32 154 5 198 220 242 8 250 3 163 95 25 29 120 196 72 85 230 86 30 209 230 15 218 231 131 227 4 89 60 50 252 230 233 23 220 238 165 30 208 252 140 219 236 25 219 6 31 165 13 37 67 80 92 29 136 111 217 41 40 234 140 120 242 92 127 147 10 136 208 131 68 95 215 238 247 156 234 144 115 35 73 114 86 156 121 90 55 137 144 146 112 155 155 143 29 201 122 188 135 187 243 245 231 143 252 157 124 253 17 93 31 63 180 245 137 63 218 255 172 217 203 251 228 222 175 143 47 158 59 126 245 21 153 118 72 46 127 245 129 191 50 92 212 141 132 71 31 217 252 132 183 100 29 203 211 1 239 134 78 68 212 152 207 42 126 184 191 123 247 229 155 111 153 63 215 170 85 189 106 224 149 201 95 143 13 63 46 179 59 77 186 68 54 75 173 86 149 116 54 255 243 135 223 102 11 4 214 183 173 229 75 247 130 67 246 109 127 202 236 108 14 7 163 17 53 81 23 205 113 54 112 5 0 176 126 97 227 52 16 164 209 56 221 221 221 226 92 215 192 183 58 249 52 72 72 29 221 251 44 253 233 9 197 38 23 222 115 44 215 92 47 19 253 148 91 121 52 210 251 224 159 124 230 229 143 198 255 158 100 186 163 38 35 5 182 125 240 247 100 116 158 64 89 198 35 155 62 184 250 35 15 7 34 86 183 130 236 203 142 147 2 251 18 77 171 232 163 63 243 208 1 10 138 159 27 199 104 87 147 220 78 97 111 74 62 64 45 203 199 190 211 131 202 182 193 71 28 189 224 118 198 76 202 245 133 199 126 242 234 153 151 72 239 10 66 129 117 185 124 100 243 231 31 218 242 5 193 94 150 35 149 123 246 83 107 130 166 72 230 62 185 247 107 251 135 86 212 221 104 36 210 154 20 252 64 124 203 108 246 38 183 151 253 67 71 73 142 11 90 14 248 3 164 20 245 228 110 106 48 66 111 205 110 221 205 131 135 213 11 177 114 37 103 222 188 168 85 34 170 50 157 250 72 62 171 70 169 82 12 185 76 85 81 172 228 100 156 205 31 223 120 109 218 52 73 49 95 214 72 58 235 175 7 122 246 108 31 254 148 121 4 250 99 155 125 235 39 66 67 108 204 0 172 47 90 103 201 71 142 28 193 240 54 23 136 102 71 99 246 27 247 155 213 36 157 159 204 44 167 82 94 174 18 103 20 58 73 68 70 72 134 146 246 34 229 215 96 213 101 189 218 200 212 194 251 153 194 36 155 222 78 207 58 76 138 77 47 74 210 172 99 33 153 190 144 185 100 184 129 73 145 83 251 180 47 218 69 131 83 244 218 7 122 218 153 90 126 224 185 109 212 124 161 97 108 252 100 177 103 138 243 163 235 1 39 205 61 89 190 250 252 185 115 211 239 140 167 206 25 197 183 73 43 111 239 221 63 16 219 186 45 185 223 149 174 165 166 72 133 83 59 227 139 103 117 57 75 77 81 35 15 109 33 229 253 68 43 146 214 189 122 230 69 18 235 180 11 146 227 36 238 57 81 46 160 160 229 242 229 244 157 71 175 220 100 166 180 104 94 231 212 249 255 123 220 170 32 121 40 24 236 142 45 71 69 111 25 56 250 217 79 188 32 179 187 176 18 117 21 5 78 154 62 93 156 119 92 45 149 190 250 179 127 249 115 238 67 186 130 205 103 243 250 117 76 13 198 30 123 232 47 99 17 190 108 120 111 100 168 43 210 231 247 7 186 195 253 152 14 8 0 0 192 51 107 163 155 1 0 222 68 191 207 83 66 186 90 173 154 42 220 41 5 156 45 45 206 229 44 114 5 206 164 46 254 127 167 95 180 220 188 47 30 11 4 252 244 226 243 15 126 123 40 121 191 243 101 197 31 232 9 247 251 229 20 42 245 109 169 56 231 232 108 46 107 185 159 190 253 103 92 132 198 242 152 148 202 185 226 157 200 144 67 187 190 60 102 138 108 14 7 163 155 186 182 251 150 147 105 36 219 60 97 51 0 0 128 54 167 229 249 52 0 88 77 58 219 152 73 49 123 203 230 65 18 54 172 68 245 215 81 53 97 233 115 29 76 238 137 133 251 45 55 55 234 137 252 246 220 139 102 229 106 41 133 139 149 156 100 223 50 165 148 140 104 254 229 251 223 50 239 186 90 173 25 162 121 160 103 143 89 52 27 17 26 81 181 107 221 137 102 92 153 1 46 203 0 180 155 49 195 223 12 192 134 64 171 20 211 165 148 254 218 46 84 227 250 212 219 239 93 248 177 149 236 246 247 197 163 244 47 189 30 27 121 252 216 125 207 201 236 177 43 220 39 158 129 71 242 154 186 225 56 143 80 23 205 92 226 57 157 165 92 161 84 207 48 109 23 161 209 31 27 137 135 122 220 198 141 0 0 0 0 150 32 212 15 128 13 129 18 12 43 129 208 93 69 219 107 185 206 246 225 79 89 186 156 151 19 86 220 205 142 124 101 242 77 201 156 116 153 82 74 159 140 104 173 227 171 229 250 10 222 69 115 81 171 232 162 153 120 112 239 87 205 162 57 17 234 33 209 28 10 134 33 154 1 0 0 52 77 55 227 55 20 208 49 192 152 5 68 149 59 121 154 212 96 36 28 140 90 174 179 111 187 117 250 237 124 169 108 252 54 245 206 185 23 101 164 115 221 157 156 42 104 25 174 4 96 169 82 204 149 151 210 197 121 129 170 214 73 165 175 218 137 102 234 76 166 112 167 190 238 190 109 79 111 30 60 204 173 160 6 194 201 232 144 18 80 215 175 104 134 49 3 92 150 1 104 55 99 70 156 6 0 27 136 108 41 69 178 213 183 236 172 205 221 206 140 91 174 243 155 15 94 156 93 180 72 119 24 86 130 93 209 123 229 6 143 237 127 78 50 163 179 239 78 173 111 63 201 93 71 173 108 48 49 123 226 237 115 255 209 46 156 218 136 208 216 54 116 244 200 125 255 19 239 15 240 7 54 37 182 69 213 174 68 40 233 71 2 13 0 0 0 77 2 186 25 128 13 68 181 158 188 66 119 0 223 78 95 47 86 242 230 117 114 133 185 183 222 253 27 203 92 206 201 88 68 9 6 141 183 99 35 143 63 180 251 155 170 210 228 114 3 164 149 127 123 238 63 222 156 61 97 183 130 145 67 163 39 190 245 145 67 207 154 171 156 144 104 142 135 122 32 154 1 0 0 52 23 196 105 128 142 2 198 236 240 133 247 7 34 202 157 180 246 70 221 105 142 88 164 255 254 93 95 178 92 180 152 47 178 79 218 87 38 223 252 111 191 123 78 190 4 183 140 98 62 125 245 39 63 125 251 207 4 162 185 168 85 196 162 185 62 23 48 217 1 162 25 198 12 112 89 6 160 221 140 25 254 102 0 54 22 172 203 121 49 63 187 88 156 181 92 205 177 12 10 203 80 242 254 177 145 207 201 135 109 152 201 22 166 207 79 188 118 101 242 87 226 60 119 149 106 53 149 43 208 85 203 78 52 247 132 7 134 186 70 49 17 16 0 0 64 43 128 110 6 96 3 81 208 114 5 45 107 76 212 171 214 42 183 211 227 229 106 209 114 101 187 64 231 136 170 36 34 22 185 144 85 37 54 58 120 108 235 192 177 77 201 79 72 6 111 76 167 62 154 90 56 61 49 247 59 203 201 127 118 162 121 160 103 207 209 3 223 52 139 230 68 168 103 75 207 238 117 84 73 27 0 0 192 250 211 205 173 171 29 15 192 42 3 99 22 144 43 47 21 53 62 160 185 92 41 220 206 140 91 86 30 41 151 115 191 57 253 210 98 118 194 188 40 22 14 197 66 162 220 204 177 200 80 34 50 52 148 60 104 35 151 207 148 42 57 25 173 108 22 205 150 19 1 125 203 201 245 146 91 123 238 11 117 80 69 64 24 51 128 37 3 208 110 198 12 127 51 0 27 87 52 235 216 85 222 214 165 243 135 151 95 177 12 216 136 135 67 81 161 116 110 34 69 173 146 41 20 149 64 244 254 93 95 218 62 252 41 243 10 61 225 129 109 189 251 3 152 5 8 0 0 160 149 64 55 3 208 249 228 203 233 130 48 110 56 149 191 189 84 92 176 91 122 238 218 127 251 120 252 231 230 207 237 2 54 154 172 248 235 217 51 6 122 246 28 217 247 239 204 197 77 136 205 221 99 131 241 81 156 101 0 0 0 173 6 249 52 64 71 1 99 54 83 173 85 197 162 153 72 70 55 37 66 61 118 75 247 239 248 31 62 115 232 57 115 41 193 66 89 91 170 199 78 180 170 231 213 26 181 95 214 148 67 187 190 252 200 225 231 204 162 89 13 132 118 246 222 223 169 162 25 198 12 96 201 0 180 155 49 195 223 12 64 135 35 136 208 224 152 207 77 102 74 139 118 75 203 229 220 165 155 111 153 29 207 126 191 191 39 26 102 243 58 55 167 219 165 114 165 18 220 177 249 247 119 111 121 204 60 5 48 224 15 116 133 147 35 93 187 195 74 20 167 24 0 0 192 234 0 221 12 64 135 179 88 152 177 156 246 231 65 58 251 234 85 81 206 95 251 153 57 226 153 132 115 60 28 14 4 252 141 119 184 80 214 72 21 111 30 248 164 157 98 142 4 99 61 209 193 129 248 86 4 52 3 0 0 88 109 221 140 185 174 160 99 128 49 155 89 200 223 118 181 190 96 154 160 163 122 142 168 74 52 164 6 3 94 228 44 93 139 42 53 37 217 125 112 40 121 255 230 193 195 118 171 69 213 248 112 98 103 183 85 160 51 140 25 0 88 50 0 45 53 102 248 155 1 128 110 230 41 87 10 51 153 155 90 173 236 168 158 175 79 189 115 229 230 63 115 69 185 149 64 32 172 42 33 37 40 35 160 105 221 100 98 87 36 60 220 159 60 216 147 216 42 94 57 28 140 246 199 54 147 104 70 120 6 0 0 128 213 7 186 25 0 232 102 11 170 181 74 42 63 45 142 217 184 35 178 235 113 207 102 245 236 171 135 62 171 129 0 201 103 122 225 247 249 212 224 178 140 214 170 181 106 253 178 163 105 149 109 195 191 55 182 229 247 99 18 206 99 197 175 246 197 54 69 212 59 53 77 34 74 44 162 196 61 87 210 174 213 170 101 250 175 254 96 224 247 5 161 194 1 0 0 200 234 102 252 134 2 58 6 24 115 179 116 179 78 81 203 205 101 39 29 29 207 134 122 190 113 251 100 174 56 231 118 47 219 134 142 142 14 31 27 76 238 177 92 26 240 7 122 194 3 93 145 62 147 40 15 68 148 104 40 24 115 21 229 92 207 46 146 41 85 138 53 38 230 155 90 136 135 146 74 64 133 49 3 0 75 6 64 96 204 240 55 3 208 225 164 139 243 90 181 220 80 11 133 249 197 226 172 228 228 194 235 83 111 127 124 253 117 15 234 57 22 238 223 189 245 247 71 135 142 26 115 1 21 191 218 19 29 136 170 137 128 95 148 172 35 20 12 43 129 176 26 12 139 5 180 86 41 150 170 69 187 212 34 164 194 187 195 253 152 104 8 0 0 64 0 116 51 0 29 78 65 203 228 203 217 6 27 169 214 42 233 194 66 182 180 40 227 123 110 68 61 251 234 238 231 189 163 159 29 27 250 180 17 149 33 9 169 94 37 160 6 233 31 191 106 232 223 74 173 90 173 105 165 74 193 81 247 43 129 80 87 184 23 6 3 0 0 64 164 155 241 27 10 232 24 96 204 102 106 181 234 98 113 174 38 157 138 174 174 32 213 229 184 223 101 185 172 113 114 147 164 115 166 152 42 86 164 18 66 207 164 46 126 124 253 103 179 139 23 37 247 27 86 130 74 48 24 81 21 191 223 31 139 12 29 218 249 167 163 3 199 84 37 182 106 99 213 21 74 42 193 48 140 25 0 88 50 0 150 198 12 127 51 0 157 79 65 203 229 203 105 135 103 104 127 32 76 146 53 16 226 132 35 233 230 114 165 88 170 228 217 96 15 173 82 206 148 230 51 165 69 153 224 13 177 122 14 5 137 0 201 229 80 125 250 32 183 148 68 243 232 224 177 251 182 252 97 178 107 231 42 12 84 88 137 198 212 110 24 12 0 0 0 235 123 37 116 51 0 27 67 58 219 70 107 40 129 80 40 24 113 204 41 161 85 138 121 45 167 85 75 236 135 217 210 226 82 97 190 92 45 58 118 192 156 242 153 84 114 50 22 145 76 246 28 139 12 237 223 250 135 99 35 159 107 169 251 153 30 30 146 145 65 88 11 0 0 0 91 221 140 223 80 64 199 0 99 22 11 223 82 181 88 169 106 90 181 28 240 7 2 126 69 13 134 73 49 187 154 12 103 169 158 139 90 46 149 159 145 9 222 208 213 243 228 220 135 122 210 58 87 210 89 103 108 228 241 177 225 207 13 37 239 111 209 40 245 70 55 193 152 1 128 37 3 96 105 204 240 55 3 0 92 83 208 114 5 45 91 51 133 62 47 228 111 203 68 110 176 41 159 73 58 199 195 161 136 170 184 234 64 44 50 52 54 252 216 174 145 207 199 35 67 157 170 155 1 0 0 180 27 208 205 0 0 47 144 104 206 149 151 74 149 21 17 26 213 90 101 46 119 75 62 125 135 145 118 35 17 9 187 149 206 58 67 201 251 199 70 62 215 196 233 131 208 205 0 0 0 68 186 25 191 161 128 142 1 198 188 202 88 58 158 211 133 249 133 194 180 124 35 183 102 62 184 114 235 159 10 197 113 111 210 89 103 203 192 209 209 193 99 99 195 143 55 114 56 74 64 237 10 247 193 152 1 128 37 3 96 105 204 240 55 3 0 26 66 171 150 243 229 52 87 90 165 168 229 102 178 19 85 55 201 239 22 51 19 211 115 111 223 158 255 151 70 58 163 231 223 216 58 112 108 83 242 19 30 60 208 161 96 56 30 74 226 156 2 0 0 176 4 186 25 0 208 4 72 58 23 180 28 251 73 185 82 152 205 78 202 164 218 96 9 7 130 183 231 126 247 241 196 107 229 149 173 121 64 247 64 111 74 222 47 31 3 29 83 187 29 243 138 0 0 0 216 208 186 25 191 161 128 142 1 198 188 134 148 42 197 92 121 137 141 217 168 214 42 183 211 227 110 165 115 79 120 160 39 58 112 101 234 205 243 19 175 165 210 87 26 239 88 178 107 140 212 115 253 207 193 9 157 140 12 250 219 166 212 54 140 25 224 178 12 64 187 25 51 252 205 0 128 166 65 162 57 83 90 100 179 212 121 147 206 137 80 79 95 108 132 94 76 167 62 186 50 245 235 43 147 111 54 171 135 164 161 251 18 59 122 227 99 189 93 59 185 100 118 30 138 158 164 243 147 153 194 212 212 194 123 217 194 237 76 97 114 83 242 129 7 199 190 1 51 0 0 128 78 5 186 25 0 208 100 184 26 43 13 74 103 162 172 229 174 76 254 250 220 196 63 230 220 76 55 148 65 85 98 189 137 177 68 116 40 22 30 236 142 116 245 119 237 83 149 132 229 154 217 194 20 169 228 250 139 101 137 156 206 79 209 39 220 58 135 119 126 13 186 25 0 0 58 92 55 227 55 20 208 49 192 152 219 4 173 90 206 150 82 198 188 192 198 165 179 142 238 126 190 49 243 78 227 209 207 28 74 48 24 86 130 13 54 210 92 221 12 99 6 184 44 3 208 110 198 12 127 51 0 160 37 212 106 213 130 150 53 38 11 54 75 58 251 234 238 231 27 179 239 92 153 252 53 201 232 166 116 53 224 247 135 67 106 227 113 205 240 55 3 0 64 103 163 96 8 0 0 173 192 239 15 68 213 174 96 32 164 79 22 12 248 131 155 186 182 185 149 206 153 210 34 253 203 73 103 85 137 141 13 63 78 127 217 194 244 196 204 137 203 183 223 108 100 250 160 223 231 139 168 138 31 39 12 0 0 128 19 203 30 150 147 39 79 98 32 64 103 0 99 110 55 66 193 112 79 184 159 254 93 190 220 212 165 179 26 8 187 106 129 164 243 124 110 210 114 81 60 50 180 111 244 139 127 240 175 254 247 127 243 169 239 63 180 251 223 39 187 198 60 136 230 112 72 245 251 253 48 102 0 96 201 0 56 26 51 226 52 0 0 171 65 169 82 204 151 151 170 181 106 19 3 54 204 232 33 28 55 102 222 153 78 125 232 24 3 77 114 57 172 42 193 230 137 102 196 105 0 0 64 103 3 221 12 0 88 37 106 181 106 177 146 203 151 179 45 149 206 6 169 244 213 219 169 143 166 82 31 90 106 232 96 32 16 82 149 230 230 106 134 110 6 0 128 206 215 205 152 235 10 58 6 24 115 251 83 173 85 179 165 197 82 37 191 10 210 217 32 91 152 94 200 92 157 79 95 158 78 157 209 42 185 76 254 186 26 12 54 126 44 195 189 15 132 148 174 222 196 174 174 232 72 60 50 60 208 181 199 46 141 29 140 25 224 178 12 64 7 24 51 252 205 0 128 53 64 91 46 46 152 153 88 188 184 106 210 89 39 172 68 35 74 34 224 15 232 37 75 140 172 204 196 237 212 251 150 155 232 202 88 127 221 127 87 25 143 244 62 136 147 8 0 0 27 13 232 102 0 192 154 81 212 10 55 82 231 178 229 165 85 144 206 161 96 56 28 140 42 193 48 134 29 0 0 128 55 144 79 3 116 20 48 230 245 69 88 137 140 245 31 238 139 13 215 19 110 200 206 207 19 100 216 176 240 13 248 3 17 37 214 19 25 140 135 146 235 75 52 195 152 1 46 203 0 180 155 49 195 223 12 0 88 99 170 181 234 84 250 106 81 203 151 171 37 173 82 170 212 202 70 161 65 1 98 175 115 192 31 80 131 97 37 16 14 193 193 12 0 0 160 73 64 55 3 0 218 72 58 223 125 171 105 213 114 165 90 169 250 52 250 87 32 157 147 209 161 128 255 206 12 63 133 164 114 64 9 248 21 122 65 127 24 85 0 0 0 205 5 113 26 160 163 128 49 175 215 43 145 63 48 220 181 51 172 68 239 190 85 66 193 104 84 77 196 213 100 119 184 191 43 156 76 132 186 233 47 162 196 194 193 136 241 87 174 20 51 197 197 152 218 221 19 25 236 141 110 234 10 247 209 107 90 167 51 68 51 140 25 224 178 12 64 187 25 51 252 205 0 128 118 129 243 58 75 66 106 155 52 55 41 239 181 237 121 169 178 156 34 218 239 11 26 234 31 0 0 64 135 1 221 12 0 232 4 233 60 152 24 85 3 161 53 233 240 66 126 106 169 48 111 124 18 15 117 15 196 183 174 173 142 7 0 0 208 10 16 167 1 58 10 24 243 186 191 36 173 12 216 144 132 116 246 173 197 75 110 213 118 179 84 62 43 154 137 108 105 105 58 115 29 198 12 0 44 25 116 158 49 195 223 12 0 104 59 188 121 157 73 115 15 38 182 198 212 238 85 235 231 92 238 22 39 154 13 70 186 119 68 154 87 59 16 0 0 64 59 128 95 18 1 0 237 119 97 170 123 157 163 106 220 173 218 190 157 30 95 42 204 173 78 39 11 90 198 78 52 19 249 114 22 231 17 0 0 58 80 55 227 55 20 208 49 192 152 59 76 58 39 66 73 183 27 206 229 38 167 51 227 50 25 160 27 36 149 159 129 49 3 0 75 6 27 202 152 17 167 1 0 104 107 4 177 16 2 148 128 50 148 216 222 186 212 22 5 45 51 185 116 77 176 194 96 98 171 7 209 15 0 0 160 157 65 156 6 0 160 173 233 143 109 38 13 234 118 43 173 170 221 90 186 188 144 191 221 162 94 205 100 38 196 43 172 102 152 53 0 0 128 213 211 205 248 13 5 116 12 48 230 142 36 17 74 142 116 239 240 144 217 45 149 159 33 245 92 208 50 205 237 15 201 113 210 229 130 21 186 35 125 141 231 161 131 49 3 92 150 1 104 55 99 70 156 6 0 96 125 80 212 242 115 185 91 222 146 205 145 242 238 143 111 110 74 78 229 76 41 37 118 54 183 67 29 22 0 0 0 173 0 186 25 0 176 110 168 214 170 115 217 91 164 92 61 108 75 66 182 59 210 223 19 25 108 68 209 58 138 102 111 249 167 1 0 0 172 11 16 167 1 58 10 24 115 135 95 176 234 25 154 55 117 109 243 160 125 73 115 167 242 51 55 82 231 23 242 183 61 100 219 160 77 166 51 227 50 158 230 102 137 102 24 51 192 101 25 128 118 51 102 248 155 1 0 235 15 82 177 179 217 137 108 105 201 115 11 241 80 119 140 254 212 110 71 9 94 174 150 50 197 133 165 194 156 88 109 163 188 54 0 0 116 60 208 205 0 128 245 74 65 203 204 100 38 196 83 244 28 137 170 113 53 24 14 43 49 37 160 4 3 33 53 16 34 125 92 170 228 232 223 162 150 207 151 51 142 17 213 164 149 251 227 155 145 117 14 0 0 54 132 110 62 121 242 228 195 15 63 140 177 0 29 0 140 121 3 178 84 152 243 22 122 209 20 186 35 125 189 209 225 86 184 153 97 204 0 151 101 0 218 205 152 225 111 6 0 172 123 72 52 47 22 102 50 197 133 6 125 207 174 72 132 146 201 216 144 26 8 97 252 1 0 96 131 0 221 12 0 232 28 50 165 212 82 97 206 91 174 58 73 2 254 64 34 156 236 142 12 64 49 3 0 192 70 3 249 52 64 71 1 99 222 224 36 66 201 205 221 187 232 175 41 149 71 120 185 28 74 110 234 218 182 189 247 64 127 108 243 42 136 102 24 51 192 101 25 128 118 51 102 248 155 1 0 29 75 81 203 231 202 75 69 45 71 47 60 4 64 147 86 14 43 209 176 18 139 170 241 136 146 192 120 2 0 192 6 7 186 25 0 176 33 96 179 100 232 159 104 149 114 165 86 54 86 32 125 172 191 80 131 97 37 160 132 130 49 36 149 3 0 0 192 235 102 204 117 5 29 3 140 25 192 152 1 128 37 3 208 34 99 134 191 25 0 0 0 0 0 0 103 240 43 36 0 0 0 0 0 0 206 252 255 2 12 0 171 150 197 58 36 57 72 132 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
mainPng
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 10 0 0 1 60 8 2 0 0 0 118 4 183 238 0 0 0 25 116 69 88 116 83 111 102 116 119 97 114 101 0 65 100 111 98 101 32 73 109 97 103 101 82 101 97 100 121 113 201 101 60 0 0 0 72 73 68 65 84 120 218 236 211 177 13 0 48 8 3 65 28 101 255 121 41 51 65 24 0 157 219 235 208 147 238 174 255 78 141 91 203 55 137 179 96 157 187 26 86 42 198 82 196 74 197 88 231 24 99 31 138 49 198 24 99 140 49 198 24 99 140 241 122 126 2 12 0 140 169 5 131 9 54 124 151 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
printCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* print.css */
body {line-height:1.5;font-family:"Helvetica Neue", Helvetica, Arial, sans-serif;color:#000;background:none;font-size:10pt;}
.container {background:none;}
hr {background:#ccc;color:#ccc;width:100%;height:2px;margin:2em 0;padding:0;border:none;}
hr.space {background:#fff;color:#fff;}
h1, h2, h3, h4, h5, h6 {font-family:"Helvetica Neue", Arial, "Lucida Grande", sans-serif;}
code {font:.9em "Courier New", Monaco, Courier, monospace;}
img {float:left;margin:1.5em 1.5em 1.5em 0;}
a img {border:none;}
p img.top {margin-top:0;}
blockquote {margin:1.5em;padding:1em;font-style:italic;font-size:.9em;}
.small {font-size:.9em;}
.large {font-size:1.1em;}
.quiet {color:#999;}
.hide {display:none;}
a:link, a:visited {background:transparent;font-weight:700;text-decoration:underline;}
a:link:after, a:visited:after {content:" (" attr(href) ") ";font-size:90%;}'! !

!SKFileLibrary methodsFor: 'uploaded' stamp: ''!
registernowJpg
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(255 216 255 224 0 16 74 70 73 70 0 1 1 1 0 72 0 72 0 0 255 225 0 22 69 120 105 102 0 0 77 77 0 42 0 0 0 8 0 0 0 0 0 0 255 219 0 67 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 219 0 67 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 192 0 17 8 0 46 0 217 3 1 34 0 2 17 1 3 17 1 255 196 0 29 0 0 3 1 1 0 3 1 1 0 0 0 0 0 0 0 0 0 7 8 9 6 4 5 10 2 3 255 196 0 55 16 0 2 2 2 1 2 2 10 1 1 8 2 3 0 0 0 4 5 2 3 1 6 7 0 8 17 18 19 20 21 22 84 85 147 148 211 212 9 33 23 34 53 69 117 132 180 196 24 36 37 50 81 255 196 0 28 1 0 1 5 1 1 1 0 0 0 0 0 0 0 0 0 0 0 4 5 6 7 8 3 2 10 255 196 0 51 17 0 2 2 2 1 1 7 4 2 0 5 5 1 0 0 0 3 4 2 5 1 6 7 18 0 17 19 33 84 146 240 8 20 21 22 34 81 23 49 53 113 131 35 65 97 129 179 180 255 218 0 12 3 1 0 2 17 3 17 0 63 0 247 138 20 18 228 153 138 44 232 174 202 232 145 25 201 18 178 16 204 35 101 85 231 24 205 117 91 47 55 154 216 231 24 204 113 143 12 75 251 216 206 49 140 244 94 225 184 248 149 191 88 175 211 232 208 255 0 198 9 255 0 77 187 254 80 125 60 245 221 121 222 218 245 78 179 173 173 37 195 247 167 14 177 66 160 227 137 150 192 242 236 197 67 10 60 37 40 226 86 221 100 177 8 71 50 198 51 44 227 30 61 124 203 60 245 140 108 70 130 3 145 202 121 0 75 174 32 72 231 57 207 44 64 97 8 225 137 16 165 41 37 24 12 112 140 167 57 203 17 142 51 156 227 29 190 143 83 78 191 53 228 117 226 68 2 6 12 83 156 166 136 0 16 6 61 100 41 73 60 198 3 24 225 25 76 132 156 163 24 67 18 148 179 140 99 191 8 207 112 220 124 74 223 172 87 233 244 123 134 227 226 86 253 98 191 79 171 78 254 216 57 248 125 245 71 24 91 197 219 46 55 199 154 253 91 80 26 228 43 14 210 227 174 92 105 171 160 229 141 245 23 48 83 1 131 215 148 29 151 184 40 8 210 68 43 170 239 71 50 7 197 171 238 67 227 125 215 138 118 246 90 30 254 142 205 127 109 81 234 158 209 79 35 86 178 176 124 28 45 38 135 156 20 156 198 0 93 18 68 34 130 41 144 229 91 25 213 117 115 198 124 39 31 21 150 53 187 229 58 103 177 182 214 111 106 235 213 179 197 43 47 88 235 246 41 38 189 206 65 38 177 82 118 89 88 64 13 158 86 132 152 194 4 156 90 200 35 35 96 94 30 51 44 36 175 177 210 45 155 5 125 86 199 73 102 251 53 185 184 89 42 251 218 247 27 98 163 7 138 217 181 10 203 48 67 22 183 12 202 43 229 225 194 74 224 243 136 188 95 19 49 143 105 183 220 55 31 18 183 235 21 250 125 30 225 184 248 149 191 88 175 211 234 249 73 217 119 116 155 14 175 141 193 87 11 237 151 35 152 241 46 156 147 236 181 173 203 26 202 243 109 87 131 173 51 98 30 202 125 87 213 140 88 60 195 83 126 8 132 234 149 62 147 23 85 153 205 23 8 88 197 218 1 3 17 65 212 17 96 151 135 117 54 84 93 37 213 102 105 180 107 71 156 99 117 100 87 116 101 85 148 206 17 178 22 71 48 148 113 44 103 29 121 185 67 122 215 3 92 206 195 173 221 208 175 110 44 158 164 247 52 54 21 97 180 4 113 12 200 213 197 121 112 65 209 71 4 30 114 69 164 88 99 19 135 126 127 148 123 253 83 191 165 108 38 125 122 13 134 154 241 138 146 196 22 128 167 188 66 204 213 167 151 87 72 108 4 147 6 154 101 151 135 62 225 177 17 207 61 51 238 199 241 207 114 119 220 55 31 18 183 235 21 250 125 30 225 184 248 149 191 88 175 211 235 73 116 94 193 59 166 221 243 173 153 253 152 176 214 245 237 128 240 70 155 205 153 130 53 86 39 8 185 66 86 53 103 173 148 214 173 178 161 5 26 82 34 113 194 79 77 111 151 20 213 9 93 56 199 166 79 121 221 177 240 151 0 235 220 117 174 113 214 255 0 86 213 202 181 51 33 111 32 35 37 165 37 108 12 160 208 58 46 84 226 26 248 50 180 93 96 16 142 8 144 232 87 117 182 50 38 183 128 206 100 50 128 150 153 25 228 120 167 151 133 166 223 239 150 250 219 26 206 189 66 42 226 96 219 82 165 215 91 189 157 163 2 18 203 235 41 90 9 118 46 205 128 18 111 18 74 71 32 194 128 47 134 114 51 144 172 104 62 121 67 138 75 183 81 105 21 59 8 54 75 251 194 216 67 194 213 217 22 192 173 44 43 64 66 176 198 198 229 97 78 10 96 228 195 138 67 195 82 193 178 217 199 137 132 107 224 204 7 50 142 237 215 151 86 105 203 249 13 142 154 240 13 17 181 209 29 102 224 90 71 227 235 103 93 57 78 21 68 103 54 169 136 22 226 249 215 117 99 78 23 230 4 217 65 21 209 43 38 61 241 175 134 247 13 199 196 173 250 197 126 159 91 101 207 221 195 247 23 173 246 179 174 240 55 40 240 14 120 248 38 42 117 253 31 59 211 66 236 140 29 171 211 162 176 144 134 85 173 192 104 212 181 190 104 80 190 76 14 203 67 130 206 50 70 67 88 4 175 31 2 198 92 99 218 87 113 92 198 146 59 39 29 241 123 135 90 253 185 179 3 58 52 244 26 210 195 253 13 158 134 217 44 51 106 110 146 134 144 170 239 53 54 77 124 201 132 45 174 234 229 44 78 155 99 5 155 174 148 218 219 85 70 167 198 32 222 119 139 98 106 149 54 219 5 67 60 125 123 89 176 84 222 48 57 78 205 8 81 229 57 88 25 5 97 53 10 55 162 185 21 150 26 192 194 227 176 132 90 42 77 59 114 85 141 98 215 104 228 147 233 90 93 88 246 139 74 186 27 85 247 202 75 42 27 90 80 78 16 174 122 119 88 111 8 5 230 167 22 132 68 100 196 26 142 87 145 10 162 115 150 86 20 53 238 27 143 137 91 245 138 253 62 143 112 220 124 74 223 172 87 233 245 95 53 237 239 154 145 242 18 190 41 107 198 251 40 124 132 240 91 142 73 171 204 90 230 107 128 71 161 129 55 154 170 218 174 176 38 1 213 74 166 82 153 66 21 117 17 200 37 87 155 61 37 51 134 53 213 239 97 218 70 155 218 44 218 40 225 131 247 62 227 218 104 122 253 87 195 13 31 152 197 118 213 177 205 109 46 166 42 107 92 227 95 26 205 80 99 216 91 139 43 93 230 149 235 113 60 79 51 149 114 135 110 63 225 190 87 228 56 238 197 66 174 84 194 208 106 172 44 111 127 59 81 120 179 4 114 185 120 178 77 114 181 53 42 93 101 189 156 193 152 200 26 121 141 114 230 4 20 137 49 248 224 193 120 239 156 189 197 250 12 244 209 61 103 27 114 239 86 149 245 244 159 133 181 165 97 120 41 96 124 172 61 134 197 198 173 19 89 77 108 69 129 32 107 104 16 226 234 25 176 40 19 1 54 69 243 153 238 27 143 137 91 245 138 253 62 143 112 220 124 74 223 172 87 233 244 246 97 173 63 85 177 157 168 28 164 234 182 117 174 9 215 141 69 10 100 67 42 94 6 100 215 146 171 213 134 244 211 180 234 78 174 193 37 69 56 178 121 190 57 174 56 204 191 167 84 19 62 204 59 163 79 169 93 187 178 225 141 172 93 124 97 45 56 172 203 42 172 116 32 148 85 139 239 32 189 86 150 54 109 34 87 69 62 54 95 146 19 85 154 97 11 101 102 35 138 173 242 86 181 85 123 253 238 45 51 73 171 223 220 226 146 51 157 206 106 181 235 43 28 84 64 121 158 9 59 76 168 177 190 194 35 200 231 137 201 191 11 16 204 39 137 103 25 142 123 172 107 59 61 26 147 53 184 185 217 104 170 51 115 40 66 159 22 151 213 200 102 218 100 196 50 56 86 253 211 1 251 233 19 19 134 97 21 124 92 203 4 142 99 140 245 71 180 15 238 27 143 137 91 245 138 253 62 143 112 220 124 74 223 172 87 233 245 67 233 26 38 225 201 27 16 186 158 139 175 176 217 246 67 170 42 241 19 171 174 54 152 69 32 143 97 101 217 92 39 56 99 49 28 106 172 186 207 239 99 194 16 150 127 175 135 77 68 189 171 247 5 176 242 11 238 45 79 198 15 140 222 53 106 86 17 178 169 197 202 105 21 13 78 151 138 213 78 91 190 37 141 58 234 249 177 94 101 4 137 81 77 170 182 232 122 104 194 25 176 98 97 79 138 186 237 238 240 42 177 73 173 94 92 46 245 158 41 18 61 93 5 141 128 92 185 202 164 119 21 10 149 69 205 6 44 242 144 76 222 16 12 166 214 85 17 24 240 188 40 74 120 245 103 97 164 82 153 165 238 118 58 90 147 165 91 155 151 67 103 121 94 129 148 168 195 34 75 54 173 13 166 5 53 235 112 225 130 166 94 44 96 174 25 48 193 226 248 179 132 51 18 123 134 227 226 86 253 98 191 79 163 220 55 31 18 183 235 21 250 125 61 182 109 109 222 157 176 186 213 54 64 38 175 96 215 89 152 153 210 219 45 30 251 0 102 190 249 140 104 118 218 37 196 13 59 70 34 185 213 102 105 186 200 98 112 150 49 60 248 117 226 166 78 207 97 112 169 2 64 175 102 229 227 32 83 168 90 44 60 229 48 102 204 170 130 0 33 161 227 143 61 229 151 125 84 83 15 28 121 172 178 56 241 199 143 76 243 177 187 27 146 175 154 228 131 240 102 73 205 25 166 72 185 7 34 92 130 74 201 108 199 6 139 49 54 50 25 3 48 193 112 92 100 121 135 95 151 103 104 33 77 53 34 252 24 28 209 154 241 114 14 197 177 201 73 169 33 96 209 106 44 198 89 12 151 144 127 234 224 248 158 69 145 103 196 196 186 123 179 217 39 238 27 143 137 91 245 138 253 62 143 112 220 124 74 223 172 87 233 245 113 157 218 103 113 171 182 228 90 33 92 77 179 99 108 216 215 220 217 82 113 253 156 109 178 84 61 241 26 246 76 9 8 242 2 74 5 36 78 52 88 91 162 87 209 11 165 26 165 102 39 156 71 174 107 151 59 125 230 62 9 37 96 220 173 163 49 212 253 181 11 100 168 187 11 82 225 89 242 31 16 201 20 14 231 95 96 217 76 204 30 54 87 59 194 245 220 25 77 118 87 101 180 70 187 33 41 73 30 215 121 46 173 11 43 75 45 51 105 174 172 166 100 73 91 216 189 171 220 40 133 83 135 136 100 5 44 156 97 49 174 139 38 139 0 144 128 209 4 82 68 225 204 33 44 18 29 81 212 182 14 58 178 122 190 178 187 112 214 108 44 173 214 43 149 85 233 108 181 45 61 102 160 36 88 157 170 245 0 217 24 117 96 201 115 196 167 88 100 16 228 19 98 114 142 71 46 153 7 220 55 31 18 183 235 21 250 125 30 225 184 248 149 191 88 175 211 233 239 173 107 27 30 228 236 13 111 83 68 219 100 126 210 239 64 189 50 64 9 100 196 187 60 51 41 98 129 4 174 219 167 26 225 25 91 117 158 95 71 77 80 157 182 202 21 194 83 197 1 186 118 103 220 231 31 106 164 110 187 103 18 61 95 173 134 37 135 158 120 172 53 231 87 45 10 152 198 119 150 213 98 39 44 154 171 24 122 229 233 9 189 128 35 86 61 113 178 203 229 92 42 178 80 77 83 87 191 223 215 88 91 209 106 247 247 85 53 49 148 237 109 42 117 235 43 26 234 200 66 24 36 231 96 234 107 25 100 163 1 231 4 148 153 40 177 24 103 18 206 113 28 247 246 83 105 103 162 209 88 33 85 119 178 209 83 218 90 202 48 171 173 181 190 174 175 176 178 156 231 225 194 8 38 219 1 97 201 76 152 200 227 21 198 76 202 125 241 198 58 188 177 4 123 134 227 226 86 253 98 191 79 163 220 55 31 18 183 235 21 250 125 62 53 141 97 254 230 253 86 173 171 42 41 222 194 236 168 132 165 72 81 140 203 60 185 198 83 128 227 194 114 132 101 108 163 9 102 49 204 177 153 103 30 24 241 206 113 140 244 27 255 0 22 242 31 22 189 11 88 228 45 69 198 169 176 49 92 51 96 84 53 31 21 154 90 210 204 53 120 165 209 85 83 183 51 170 243 87 154 53 126 25 243 74 209 172 142 35 253 49 226 218 50 236 230 172 53 208 107 29 45 50 205 13 22 45 135 88 204 235 0 233 99 25 137 51 63 17 229 81 52 72 78 18 26 243 44 75 56 206 50 140 51 137 99 57 113 32 245 176 216 134 156 182 41 138 221 133 166 234 245 68 177 94 22 39 76 82 204 10 216 81 145 48 201 86 28 161 40 144 240 20 133 9 98 81 148 241 156 119 98 103 247 13 199 196 173 250 197 126 159 71 184 110 62 37 111 214 43 244 250 173 249 3 129 57 143 138 197 84 103 34 113 238 195 168 140 240 236 172 81 99 122 41 167 218 39 198 191 75 33 133 132 47 178 203 108 133 121 140 167 156 71 203 15 60 49 41 98 86 67 18 253 242 39 0 243 23 18 164 75 177 114 78 132 227 77 85 176 153 112 10 44 119 32 71 44 178 199 163 4 223 78 85 196 201 180 27 53 211 156 78 83 44 42 43 199 140 99 231 243 203 17 203 155 85 92 128 150 45 178 238 173 176 41 138 0 168 197 238 90 215 172 215 197 40 31 206 34 137 237 178 85 161 138 224 187 41 70 42 17 207 6 12 102 88 192 101 60 231 29 155 150 180 209 28 205 86 20 217 168 154 205 233 90 5 38 22 191 174 62 110 78 142 51 39 67 85 129 51 47 200 21 72 198 82 104 106 120 211 95 24 150 75 136 99 30 81 83 148 38 36 245 111 91 176 107 61 107 211 122 63 87 157 179 240 244 62 139 207 231 244 148 213 225 227 233 163 229 242 249 188 124 37 227 225 225 143 31 73 211 35 144 127 202 63 223 255 0 210 233 111 215 74 211 145 164 130 114 231 25 36 252 78 172 199 29 56 254 37 36 49 221 143 251 127 24 227 255 0 126 125 185 216 0 107 56 80 139 25 196 33 225 244 245 103 191 63 200 80 158 123 243 254 242 207 110 219 67 255 0 24 39 253 54 239 249 65 245 165 255 0 199 174 159 157 191 187 30 51 196 235 205 129 107 19 121 184 29 156 99 57 205 88 70 140 233 172 179 255 0 204 99 15 175 81 12 231 57 198 60 39 159 15 25 120 99 57 161 161 255 0 140 19 254 155 119 252 160 250 218 47 226 225 255 0 26 105 28 131 201 219 199 33 239 250 46 143 96 154 130 173 97 30 55 45 177 6 179 54 94 240 56 246 163 73 171 131 182 1 72 207 81 142 176 4 12 176 108 89 234 216 60 120 91 40 96 168 226 115 254 19 169 70 235 234 3 140 212 179 101 68 235 150 217 170 174 93 59 204 5 84 226 182 189 226 95 148 103 57 230 49 66 12 70 183 237 251 167 56 248 146 44 71 30 249 206 56 204 19 153 109 93 167 224 158 71 106 181 102 155 176 99 92 179 167 76 9 0 204 183 38 54 15 14 136 83 0 65 25 150 115 4 172 112 126 248 70 93 24 30 73 44 116 194 89 198 139 119 141 221 198 155 218 203 49 237 215 245 101 91 87 55 110 186 218 225 35 19 45 176 113 85 105 168 217 187 189 41 91 29 195 74 38 222 14 92 57 216 189 140 160 27 4 176 219 228 212 130 79 18 177 70 193 50 7 99 122 181 157 217 119 11 201 189 211 242 210 132 100 157 173 17 171 225 82 64 7 191 58 255 0 190 18 77 82 192 24 80 3 82 220 23 232 53 164 200 5 188 26 139 58 220 210 208 240 76 26 217 73 116 97 78 113 119 83 200 249 229 110 225 121 95 115 169 149 109 149 23 183 180 87 174 26 57 16 36 59 245 141 126 220 162 215 174 2 202 167 58 50 33 74 151 138 108 37 68 179 85 211 38 194 49 41 206 233 217 59 255 0 248 195 231 222 59 210 211 242 47 16 111 91 80 58 49 219 75 81 246 29 91 96 100 112 202 133 40 146 21 69 43 48 43 108 195 197 96 13 131 192 107 76 79 89 152 242 159 101 197 66 17 182 193 224 61 186 154 155 156 149 230 47 170 186 90 93 202 210 173 62 37 214 247 11 251 13 59 93 103 21 202 80 185 177 83 87 221 175 175 221 216 180 72 14 12 90 220 89 28 182 98 35 140 144 50 117 176 160 44 79 4 198 11 153 45 248 85 174 37 250 97 184 184 212 107 44 219 229 77 135 83 162 67 110 216 23 149 131 119 137 208 92 63 76 123 234 106 229 71 50 76 21 117 53 192 29 113 70 162 208 52 82 84 207 23 163 35 206 69 124 174 219 57 147 75 223 55 30 118 238 71 145 181 142 32 224 181 160 178 79 166 241 55 172 172 100 192 186 103 117 89 90 225 249 193 142 77 165 108 164 211 70 73 165 66 35 92 49 184 194 108 92 56 225 4 52 169 99 159 221 153 38 211 187 144 239 127 150 121 156 180 181 212 137 1 175 121 19 85 74 77 85 227 49 118 215 96 160 45 121 171 26 33 227 68 205 20 91 13 119 124 113 153 250 45 138 66 151 93 182 72 124 89 63 121 206 189 180 112 50 180 91 190 247 204 93 232 180 228 157 203 58 203 236 232 33 183 217 21 178 62 59 20 195 190 73 42 181 82 211 182 167 140 83 196 218 70 26 241 82 4 156 17 227 228 148 229 69 21 194 142 146 31 198 190 153 205 213 115 182 183 186 106 9 30 45 227 83 135 114 139 124 219 10 71 101 250 193 136 235 2 230 222 198 172 178 109 10 146 24 150 237 82 129 5 33 93 228 150 160 178 40 44 161 238 7 5 8 76 139 101 218 54 187 14 113 225 13 31 102 212 218 184 160 95 144 88 220 207 86 93 206 171 147 119 51 218 190 204 107 85 189 217 39 76 92 209 106 122 253 57 89 77 228 104 43 130 157 26 85 235 52 105 20 158 28 162 187 6 187 173 107 8 112 183 51 238 154 222 210 181 69 227 26 18 250 128 108 133 168 90 241 198 158 10 180 87 205 139 52 154 236 110 5 139 205 166 246 216 64 109 39 111 108 12 229 211 175 176 168 98 56 96 152 145 244 71 129 57 127 159 249 143 188 78 98 129 115 98 139 130 184 187 59 62 145 132 4 41 128 139 136 112 177 204 22 38 204 200 188 105 149 118 210 126 69 49 249 179 129 126 0 44 196 87 231 21 12 72 149 147 148 219 224 232 185 175 191 182 0 106 17 166 196 27 127 60 40 89 18 132 178 22 12 88 130 58 94 6 196 248 123 113 225 11 135 59 32 181 121 84 225 230 244 213 95 137 87 153 230 113 204 180 195 249 43 228 126 229 180 93 90 2 104 2 10 175 133 246 20 240 81 184 238 72 170 190 253 176 22 167 20 72 196 39 104 94 109 242 235 250 251 80 166 8 161 176 0 72 220 81 86 152 188 150 227 200 177 1 35 53 255 0 142 251 244 53 29 201 166 219 249 15 111 212 180 212 218 86 179 179 59 9 134 227 177 37 215 22 150 232 208 225 172 132 8 228 59 48 49 202 62 35 191 53 136 227 211 57 223 95 179 230 92 49 31 86 243 226 63 206 22 83 177 228 142 58 250 121 188 182 216 238 201 14 95 142 241 183 238 251 184 49 80 169 20 190 123 195 18 58 160 91 109 152 45 169 210 235 228 112 81 152 154 21 123 79 2 88 84 43 224 83 132 95 120 94 186 53 220 121 191 243 237 37 94 189 76 57 241 60 180 189 75 76 211 13 155 102 134 221 26 93 101 119 103 50 170 173 54 118 155 139 225 168 89 64 171 17 245 146 60 114 201 143 146 66 82 180 127 151 221 168 92 13 194 154 77 120 140 205 149 251 110 212 94 115 159 239 14 44 107 80 165 118 49 140 75 250 196 187 102 211 50 204 163 143 46 66 134 35 44 249 167 140 84 102 159 188 242 215 101 60 120 219 180 125 214 157 99 104 214 117 205 66 218 151 41 136 17 40 169 106 58 238 64 216 56 218 220 93 73 3 169 111 89 217 162 202 161 117 62 174 125 235 195 26 119 69 67 156 159 152 19 184 45 159 133 59 142 239 193 122 125 243 147 144 3 194 90 230 164 6 181 239 154 205 144 24 164 97 42 181 227 246 44 82 151 101 23 7 166 166 220 237 123 14 66 37 137 182 96 40 251 44 177 236 182 204 214 45 55 89 125 188 241 215 5 118 95 103 32 238 159 249 87 174 108 60 119 180 45 2 66 107 102 178 214 252 71 41 125 150 223 67 42 109 74 245 141 219 67 187 68 178 208 132 169 34 21 215 92 61 214 198 99 27 152 141 234 182 110 175 111 101 184 115 199 61 108 176 122 144 124 93 182 178 223 25 108 27 85 94 249 75 173 109 26 88 180 138 37 22 67 109 172 33 108 22 112 149 46 63 3 12 76 167 147 197 147 19 45 74 51 70 190 65 106 184 217 42 171 181 62 16 224 221 118 105 92 151 146 245 101 212 228 138 29 98 203 72 184 216 181 157 196 187 157 219 76 59 170 216 140 104 50 152 237 148 64 129 33 23 111 0 146 194 134 21 140 160 235 240 42 249 97 198 188 227 220 31 38 247 115 198 155 65 155 60 132 229 70 174 245 190 52 33 189 186 206 189 25 167 69 105 48 73 176 199 8 152 167 37 90 187 224 188 135 70 180 200 139 7 38 146 9 101 33 42 30 119 102 140 106 15 242 59 221 47 37 112 47 246 97 174 113 46 209 29 99 98 216 253 225 116 252 191 98 107 175 39 236 85 254 207 5 88 222 175 178 40 112 53 81 52 226 88 91 233 135 166 171 227 149 158 76 219 154 236 148 51 155 253 191 242 247 26 17 223 213 92 191 179 72 77 83 71 216 249 15 145 93 172 41 166 105 20 4 151 237 128 236 148 107 198 59 179 63 250 193 199 37 180 22 70 25 57 64 69 199 17 131 239 186 145 6 178 250 239 254 247 56 183 182 142 77 45 207 49 238 189 194 38 1 210 158 44 101 174 104 154 154 205 159 92 48 35 182 16 41 216 25 161 43 2 47 195 71 204 196 177 187 138 172 52 37 131 66 86 121 42 149 135 68 121 102 137 85 188 87 103 186 53 244 243 207 7 211 121 68 141 238 54 188 161 221 251 5 158 245 45 121 244 104 170 227 89 96 254 228 6 172 108 151 101 39 54 144 68 200 157 149 231 247 150 35 24 215 145 77 52 177 16 217 188 157 93 167 173 207 156 30 13 187 141 6 174 163 89 198 189 248 161 173 210 97 124 139 183 86 114 177 175 71 80 58 200 87 29 119 19 214 79 33 58 21 216 135 218 87 144 147 98 34 12 93 204 205 194 255 0 26 124 67 75 84 220 135 221 86 214 170 123 158 250 91 205 148 29 56 107 50 191 215 45 97 80 177 105 177 183 7 36 198 144 130 121 177 179 99 36 130 27 101 194 68 42 107 99 28 250 16 216 202 204 211 232 249 55 147 56 5 95 33 115 55 120 188 163 172 170 167 104 175 30 224 112 126 177 48 79 146 60 131 50 238 161 74 98 170 22 163 93 187 46 22 80 9 55 13 97 203 104 171 30 213 118 231 201 152 225 92 209 216 7 56 241 243 190 220 222 246 252 223 147 104 226 61 249 121 123 60 53 231 210 102 189 51 11 0 216 237 147 65 29 235 230 185 156 23 24 217 91 50 78 160 181 80 156 74 192 84 12 69 126 92 17 97 3 32 251 154 237 215 128 244 14 63 221 182 221 143 186 227 121 119 156 205 138 203 53 49 152 191 9 217 167 102 45 68 181 144 237 64 92 102 212 239 50 45 93 199 122 131 54 109 86 169 28 143 12 206 54 121 165 40 79 245 157 166 122 31 211 255 0 28 109 156 95 10 235 102 40 181 27 253 167 101 176 177 228 122 109 107 94 14 255 0 96 137 243 115 61 187 95 139 32 217 55 141 144 5 193 235 117 250 102 216 21 94 100 68 165 62 162 193 18 2 9 178 107 48 222 57 223 144 181 110 75 157 133 90 247 123 85 14 181 174 33 95 199 183 27 21 249 180 84 29 95 21 16 213 111 178 177 181 221 43 94 48 242 11 27 235 133 64 91 44 96 110 70 56 136 230 224 205 253 191 139 173 127 27 135 114 251 215 32 72 10 65 11 93 211 246 6 67 10 36 124 162 174 107 183 60 8 48 130 163 24 140 35 17 234 83 39 180 211 140 70 30 16 166 24 140 49 28 75 203 99 247 115 223 54 191 219 54 228 247 72 226 125 63 93 216 185 77 245 235 54 78 66 110 227 38 101 18 195 228 129 82 132 227 182 25 97 96 50 112 246 122 202 164 152 244 21 50 90 34 213 81 91 47 74 81 37 17 72 200 95 226 255 0 120 226 30 44 227 238 90 218 119 222 75 227 237 65 230 195 178 43 93 66 125 147 113 215 18 190 37 54 164 150 230 21 22 18 150 108 133 96 64 198 25 179 28 40 214 81 68 160 97 96 219 69 114 178 209 243 24 100 70 243 182 180 223 119 61 171 118 119 117 151 182 219 54 6 251 9 246 89 60 217 156 16 216 235 205 157 81 206 127 250 213 71 166 197 20 87 28 98 186 169 174 186 171 140 43 132 99 138 115 252 96 178 225 95 165 142 51 170 210 173 43 151 223 249 27 98 219 246 155 59 69 177 90 245 134 178 160 155 154 18 48 87 156 15 26 203 91 106 166 106 213 93 146 130 4 18 19 180 18 209 137 124 51 130 219 255 0 9 171 185 139 234 111 145 172 247 26 203 6 52 78 62 215 245 61 102 182 177 140 216 36 134 198 217 84 131 241 9 152 140 195 43 26 186 171 48 89 50 194 194 52 198 87 163 88 86 101 33 245 128 223 199 113 217 216 238 251 118 211 185 184 141 49 109 183 108 111 54 118 145 27 23 96 120 177 126 204 166 166 198 140 17 113 4 98 156 18 93 184 171 23 223 125 222 79 47 165 186 217 249 167 42 51 177 221 50 205 227 186 174 26 93 136 79 52 38 218 97 185 149 108 99 44 194 138 244 129 9 218 135 157 185 142 113 228 133 204 20 132 36 101 159 238 230 226 106 134 113 156 75 195 50 135 90 99 252 96 183 227 93 67 150 55 157 239 145 183 189 35 74 130 109 34 8 208 103 115 218 80 107 56 49 134 198 220 91 138 37 94 93 156 20 140 184 21 232 200 20 156 139 43 34 53 45 163 18 35 28 146 62 122 204 92 27 92 29 179 155 248 244 55 174 174 53 154 221 43 238 174 157 177 100 43 0 171 86 53 43 251 60 178 201 164 49 67 45 133 35 143 50 148 163 212 67 98 49 254 82 142 59 105 46 105 176 54 173 195 27 233 105 18 57 24 91 79 126 158 157 58 245 202 193 134 197 146 209 163 173 194 235 134 36 36 240 169 92 1 49 24 198 93 195 22 115 47 227 137 103 181 207 223 175 122 187 7 2 236 9 120 223 137 70 79 253 163 54 82 27 125 143 101 61 125 13 108 68 150 210 139 130 84 194 3 108 101 73 45 24 93 19 13 148 88 98 250 23 1 117 86 80 13 215 184 172 160 191 31 201 209 249 135 105 218 69 91 96 226 103 108 101 189 233 56 205 116 226 16 192 111 235 213 118 50 158 16 37 82 196 237 136 213 215 3 193 206 99 152 226 184 155 69 118 89 227 100 97 102 109 238 123 134 165 205 31 200 21 187 51 237 171 95 15 143 174 230 52 244 91 180 51 116 176 13 98 205 43 64 184 32 41 50 14 152 23 74 170 151 186 81 173 198 97 147 146 49 81 86 50 170 202 97 117 196 66 171 30 223 202 95 56 233 156 140 231 138 52 238 63 220 181 109 205 42 21 143 246 102 236 181 23 234 182 69 209 104 232 161 149 128 9 12 19 148 104 148 154 8 137 141 34 65 230 248 145 26 27 83 125 245 98 171 133 156 182 238 223 205 238 237 124 125 245 119 176 219 236 203 185 66 229 205 103 27 113 166 167 247 170 253 180 81 21 169 209 122 238 190 183 175 172 172 186 131 234 221 57 101 24 78 115 40 167 15 184 144 215 80 96 198 90 159 12 165 172 111 159 74 84 53 90 217 212 188 82 158 203 145 57 23 104 251 54 114 196 157 45 90 238 35 76 245 142 99 210 53 211 121 38 105 213 175 148 225 8 12 176 159 129 9 157 162 29 245 218 14 185 170 118 169 217 190 217 221 43 229 34 177 220 246 84 38 187 26 219 177 9 95 21 83 109 20 26 54 167 65 112 132 172 0 29 133 252 215 30 218 225 243 43 37 237 33 50 93 119 205 56 180 213 221 255 0 29 157 193 243 79 112 228 243 89 92 174 208 77 131 93 91 126 177 36 213 197 26 181 160 171 45 228 95 197 138 32 48 24 212 204 181 184 94 0 82 180 102 51 101 125 30 20 219 105 94 149 129 19 47 138 225 93 203 131 251 166 236 185 31 110 251 111 38 168 227 173 183 95 78 153 3 1 88 50 80 189 173 54 105 237 71 57 35 197 65 57 44 74 159 169 52 17 2 139 40 139 100 38 53 215 24 37 150 135 108 5 42 207 83 189 243 167 1 118 67 192 205 56 95 183 221 176 13 251 148 159 65 132 14 216 21 28 27 89 47 120 212 76 4 118 225 176 182 85 155 20 208 106 145 107 164 125 127 90 18 251 239 22 225 65 139 10 51 76 79 48 185 222 171 122 158 134 151 10 238 149 187 221 37 7 211 239 31 241 4 173 47 42 171 54 52 135 99 188 242 93 213 101 146 246 180 150 26 226 204 97 203 75 172 60 202 118 24 89 229 102 52 95 19 120 20 128 121 19 11 194 54 122 71 55 135 121 143 79 177 209 238 111 121 231 123 229 136 214 210 218 89 107 238 77 13 43 142 169 172 107 79 87 114 142 194 192 50 165 101 62 82 89 180 36 194 76 192 142 162 69 50 88 156 17 30 88 145 59 45 209 85 62 239 202 161 208 213 140 234 186 38 207 201 155 40 80 132 35 152 214 149 47 182 85 107 121 143 158 25 140 33 91 6 40 179 230 244 120 150 35 143 45 121 170 217 66 200 61 59 153 30 158 107 254 75 248 191 64 30 17 48 93 66 222 54 64 230 20 215 233 99 98 212 151 157 202 27 13 83 148 124 97 153 86 169 201 130 221 102 124 241 22 200 78 23 71 51 162 202 176 160 254 48 185 55 142 248 239 154 182 188 111 207 213 235 36 237 186 94 81 107 175 30 21 80 11 102 126 30 172 98 82 123 217 147 101 98 133 123 72 9 77 194 200 203 42 164 162 23 196 72 95 235 151 136 57 58 42 186 238 207 59 126 231 221 183 152 182 126 105 64 239 147 57 129 249 67 46 197 238 22 55 15 68 88 235 48 188 136 78 9 50 92 17 45 35 34 208 20 246 109 138 225 171 128 21 212 0 147 28 121 181 176 170 183 135 117 170 77 183 128 181 68 191 98 211 117 250 91 127 168 120 110 188 151 155 123 234 218 200 210 235 245 16 128 17 215 224 187 71 9 100 123 105 169 88 58 193 198 24 132 126 242 6 158 48 9 22 112 179 121 111 98 186 213 121 211 104 115 20 27 117 245 197 87 1 75 78 227 156 84 209 216 216 202 230 246 214 121 59 183 211 97 80 20 112 5 84 26 178 37 145 37 62 188 229 73 6 25 201 176 40 78 79 254 83 91 177 222 249 179 131 120 89 29 147 40 248 170 137 3 131 78 60 241 155 238 69 217 7 215 151 83 108 43 151 154 194 188 154 240 210 166 169 199 207 77 39 98 116 231 24 54 207 51 79 249 120 120 21 60 121 196 26 212 165 94 88 178 220 222 60 162 62 147 30 154 33 36 71 16 10 150 42 242 102 89 174 119 236 1 227 54 102 112 198 37 94 35 136 89 153 103 53 59 55 245 125 163 233 188 226 103 119 60 137 204 122 227 135 65 163 91 78 165 171 209 176 36 118 48 38 171 83 21 208 106 129 26 123 142 114 253 157 131 231 54 175 140 42 144 43 13 50 214 114 143 172 224 35 64 196 206 236 251 141 103 220 199 43 155 186 76 91 212 234 234 132 138 13 37 17 19 140 175 94 128 107 238 191 214 152 98 169 204 124 183 108 85 247 30 195 52 202 112 163 19 25 108 8 42 133 212 17 99 135 212 46 198 150 135 69 245 24 75 171 234 75 29 211 159 54 189 102 179 93 215 234 45 85 183 98 171 143 244 105 96 53 155 5 207 218 204 163 174 149 165 127 140 5 83 44 226 126 179 45 49 226 114 3 195 81 191 129 53 231 55 139 191 167 209 211 209 220 215 233 252 25 171 236 150 91 5 245 173 91 53 43 218 111 123 166 60 107 26 42 143 185 128 201 97 138 215 252 19 178 224 227 32 230 1 102 19 204 34 100 136 220 55 200 63 229 31 239 255 0 233 116 183 233 145 200 63 229 31 239 255 0 233 116 183 235 1 82 255 0 166 45 255 0 55 255 0 160 189 183 109 191 250 139 31 240 255 0 240 23 110 219 67 255 0 24 39 253 54 239 249 65 244 218 234 118 28 146 68 158 108 20 139 198 178 81 204 51 96 246 217 76 243 12 230 50 204 51 42 229 25 102 57 148 99 156 199 57 240 206 99 28 248 120 227 29 121 126 217 113 243 86 95 124 87 229 233 37 141 57 93 103 39 137 135 12 102 16 143 76 163 44 231 248 227 252 251 241 229 231 217 82 22 163 77 124 6 66 156 243 137 202 93 81 148 113 142 233 119 121 119 103 207 203 187 63 63 201 253 209 210 7 219 46 62 106 203 239 138 252 189 30 217 113 243 86 95 124 87 229 233 15 235 135 245 34 246 79 178 223 207 135 211 151 221 31 159 223 204 249 81 202 110 0 118 171 8 106 45 135 43 161 128 87 50 10 169 230 171 76 2 162 107 153 130 215 102 37 12 215 97 3 198 202 161 60 78 57 132 167 137 121 163 225 227 143 163 142 82 117 162 247 59 197 154 106 62 223 123 178 212 248 75 95 0 95 254 83 91 84 66 180 172 201 81 129 64 25 90 38 107 168 127 173 108 154 152 232 35 77 244 123 46 136 97 99 40 23 138 136 166 241 198 6 220 124 156 251 101 199 205 89 125 241 95 151 163 219 46 62 106 203 239 138 252 189 94 124 63 201 45 241 101 94 237 175 51 175 87 109 26 254 250 165 98 183 96 133 197 230 173 116 56 84 153 131 174 52 54 77 124 224 177 85 67 201 146 70 193 60 117 137 209 226 33 38 112 188 218 11 52 167 44 113 210 188 155 103 166 223 173 126 254 181 125 163 53 98 213 49 229 83 75 179 83 206 118 130 92 44 77 237 122 244 6 175 101 160 197 104 73 22 243 208 84 201 156 152 125 231 130 197 91 234 199 118 229 110 17 237 247 181 39 92 67 191 115 154 142 119 218 44 209 246 205 104 65 96 200 7 123 30 200 83 168 50 165 80 36 47 1 155 242 80 167 85 35 7 12 102 79 25 219 145 4 89 59 3 42 242 134 29 124 62 115 58 64 251 101 199 205 89 125 241 95 151 163 219 46 62 106 203 239 138 252 189 112 230 142 71 182 230 38 117 72 22 158 163 89 165 210 104 7 174 107 181 137 179 103 108 224 235 135 128 226 56 179 188 182 49 172 45 77 8 174 24 12 167 204 115 24 198 100 158 8 201 217 96 221 184 123 143 42 248 145 109 158 67 183 182 216 238 55 43 194 108 59 5 147 107 214 213 168 75 2 100 185 150 107 169 106 194 20 43 3 41 28 211 32 129 137 98 82 148 33 12 141 112 174 0 191 186 58 64 251 101 199 205 89 125 241 95 151 163 219 46 62 106 203 239 138 252 189 82 127 174 31 212 139 217 62 215 47 231 195 233 203 238 143 207 239 230 124 159 221 29 32 125 178 227 230 172 190 248 175 203 209 237 151 31 53 101 247 197 126 94 143 215 15 234 69 236 159 99 243 225 244 229 247 71 231 247 243 62 79 238 142 144 62 217 113 243 86 95 124 87 229 232 246 203 143 154 178 251 226 191 47 71 235 135 245 34 246 79 177 249 240 250 114 251 163 243 251 249 159 39 247 71 72 31 108 184 249 171 47 190 43 242 244 123 101 199 205 89 125 241 95 151 163 245 195 250 145 123 39 216 252 248 125 57 125 209 249 253 252 207 147 251 163 164 15 182 92 124 213 151 223 21 249 122 61 178 227 230 172 190 248 175 203 209 250 225 253 72 189 147 236 126 124 62 156 190 232 252 254 254 103 201 253 209 210 7 219 46 62 106 203 239 138 252 189 30 217 113 243 86 95 124 87 229 232 253 112 254 164 94 201 246 63 62 31 78 95 116 126 127 127 51 228 254 232 233 3 237 151 31 53 101 247 197 126 94 143 108 184 249 171 47 190 43 242 244 126 184 127 82 47 100 251 31 159 15 167 47 186 63 63 191 153 242 127 116 116 129 246 203 143 154 178 251 226 191 47 71 182 92 124 213 151 223 21 249 122 63 92 63 169 23 178 125 143 207 135 211 151 221 31 159 223 204 249 63 186 58 64 251 101 199 205 89 125 241 95 151 163 219 46 62 106 203 239 138 252 189 31 174 31 212 139 217 62 199 231 195 233 203 238 143 207 239 230 124 187 110 65 255 0 40 255 0 127 255 0 75 165 191 94 73 6 152 95 147 214 203 36 175 71 230 244 126 177 125 183 121 60 254 95 63 147 210 78 94 95 55 150 62 111 47 135 155 203 31 31 31 12 120 120 221 72 144 90 74 42 37 229 44 78 67 235 239 148 113 156 99 61 100 156 241 221 140 249 249 98 93 223 239 142 204 14 177 22 153 33 227 28 195 4 232 238 140 179 140 231 29 35 132 51 231 143 47 60 199 57 199 254 51 219 255 217) asByteArray ].
	^ cache at: 1! !

!SKFileLibrary methodsFor: 'uploaded' stamp: 'AQ 9/26/2008 11:45'!
screenCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* reset.css */
html, body, div, span, object, iframe, h1, h2, h3, h4, h5, h6, p, blockquote, pre, a, abbr, acronym, address, code, del, dfn, em, img, q, dl, dt, dd, ol, ul, li, fieldset, form, label, legend, table, caption, tbody, tfoot, thead, tr, th, td {margin:0;padding:0;border:0;font-weight:inherit;font-style:inherit;font-size:100%;font-family:inherit;vertical-align:baseline;}
body {line-height:1.5;}
table {border-collapse:separate;border-spacing:0;}
caption, th, td {text-align:left;font-weight:normal;}
table, td, th {vertical-align:middle;}
blockquote:before, blockquote:after, q:before, q:after {content:"";}
blockquote, q {quotes:"" "";}
a img {border:none;}

/* typography.css */
body {font-size:75%;color:#222;background:#fff;font-family:"Helvetica Neue", Helvetica, Arial, sans-serif;}
h1, h2, h3, h4, h5, h6 {font-weight:normal;color:#111;}
h1 {font-size:3em;line-height:1;margin-bottom:0.5em;}
h2 {font-size:2em;margin-bottom:0.75em;}
h3 {font-size:1.5em;line-height:1;margin-bottom:1em;}
h4 {font-size:1.2em;line-height:1.25;margin-bottom:1.25em;height:1.25em;}
h5 {font-size:1em;font-weight:bold;margin-bottom:1.5em;}
h6 {font-size:1em;font-weight:bold; display: inline;}
h1 img, h2 img, h3 img, h4 img, h5 img, h6 img {margin:0;}
p {margin:0 0 1.5em;}
p img {float:left;margin:1.5em 1.5em 1.5em 0;padding:0;}
p img.right {float:right;margin:1.5em 0 1.5em 1.5em;}
a:focus, a:hover {color:#000;}
a {color:#009;text-decoration:underline;}
blockquote {margin:1.5em;color:#666;font-style:italic;}
strong {font-weight:bold;}
em, dfn {font-style:italic;}
dfn {font-weight:bold;}
sup, sub {line-height:0;}
abbr, acronym {border-bottom:1px dotted #666;}
address {margin:0 0 1.5em;font-style:italic;}
del {color:#666;}
pre, code {margin:1.5em 0;white-space:pre;}
pre, code, tt {font:1em ''andale mono'', ''lucida console'', monospace;line-height:1.5;}
li ul, li ol {margin:0 1.5em;}
ul, ol {margin:0 1.5em 1.5em 1.5em;}
ul {list-style-type:disc;}
ol {list-style-type:decimal;}
dl {margin:0 0 1.5em 0;}
dl dt {font-weight:bold;}
dd {margin-left:1.5em;}
table {margin-bottom:1.4em;width:100%;}
th {font-weight:bold;background:#C3D9FF;}
th, td {padding:4px 10px 4px 5px;}
tr.even td {background:#E5ECF9;}
tfoot {font-style:italic;}
caption {background:#eee;}
.small {font-size:.8em;margin-bottom:1.875em;line-height:1.875em;}
.large {font-size:1.2em;line-height:2.5em;margin-bottom:1.25em;}
.hide {display:none;}
.quiet {color:#666;}
.loud {color:#000;}
.highlight {background:#ff0;}
.added {background:#060;color:#fff;}
.removed {background:#900;color:#fff;}
.first {margin-left:0;padding-left:0;}
.last {margin-right:0;padding-right:0;}
.top {margin-top:0;padding-top:0;}
.bottom {margin-bottom:0;padding-bottom:0;}

/* grid.css */
.container {width:950px;margin:0 auto;}
.showgrid {background:url(src/grid.png);}
body {margin:1.5em 0;}
div.span-1, div.span-2, div.span-3, div.span-4, div.span-5, div.span-6, div.span-7, div.span-8, div.span-9, div.span-10, div.span-11, div.span-12, div.span-13, div.span-14, div.span-15, div.span-16, div.span-17, div.span-18, div.span-19, div.span-20, div.span-21, div.span-22, div.span-23, div.span-24 {float:left;margin-right:10px;}
div.last {margin-right:0;}
.span-1 {width:30px;}
.span-2 {width:70px;}
.span-3 {width:110px;}
.span-4 {width:150px;}
.span-5 {width:190px;}
.span-6 {width:230px;}
.span-7 {width:270px;}
.span-8 {width:310px;}
.span-9 {width:350px;}
.span-10 {width:390px;}
.span-11 {width:430px;}
.span-12 {width:470px;}
.span-13 {width:510px;}
.span-14 {width:550px;}
.span-15 {width:590px;}
.span-16 {width:630px;}
.span-17 {width:670px;}
.span-18 {width:710px;}
.span-19 {width:750px;}
.span-20 {width:790px;}
.span-21 {width:830px;}
.span-22 {width:870px;}
.span-23 {width:910px;}
.span-24, div.span-24 {width:950px;margin:0;}
.append-1 {padding-right:40px;}
.append-2 {padding-right:80px;}
.append-3 {padding-right:120px;}
.append-4 {padding-right:160px;}
.append-5 {padding-right:200px;}
.append-6 {padding-right:240px;}
.append-7 {padding-right:280px;}
.append-8 {padding-right:320px;}
.append-9 {padding-right:360px;}
.append-10 {padding-right:400px;}
.append-11 {padding-right:440px;}
.append-12 {padding-right:480px;}
.append-13 {padding-right:520px;}
.append-14 {padding-right:560px;}
.append-15 {padding-right:600px;}
.append-16 {padding-right:640px;}
.append-17 {padding-right:680px;}
.append-18 {padding-right:720px;}
.append-19 {padding-right:760px;}
.append-20 {padding-right:800px;}
.append-21 {padding-right:840px;}
.append-22 {padding-right:880px;}
.append-23 {padding-right:920px;}
.prepend-1 {padding-left:40px;}
.prepend-2 {padding-left:80px;}
.prepend-3 {padding-left:120px;}
.prepend-4 {padding-left:160px;}
.prepend-5 {padding-left:200px;}
.prepend-6 {padding-left:240px;}
.prepend-7 {padding-left:280px;}
.prepend-8 {padding-left:320px;}
.prepend-9 {padding-left:360px;}
.prepend-10 {padding-left:400px;}
.prepend-11 {padding-left:440px;}
.prepend-12 {padding-left:480px;}
.prepend-13 {padding-left:520px;}
.prepend-14 {padding-left:560px;}
.prepend-15 {padding-left:600px;}
.prepend-16 {padding-left:640px;}
.prepend-17 {padding-left:680px;}
.prepend-18 {padding-left:720px;}
.prepend-19 {padding-left:760px;}
.prepend-20 {padding-left:800px;}
.prepend-21 {padding-left:840px;}
.prepend-22 {padding-left:880px;}
.prepend-23 {padding-left:920px;}
div.border {padding-right:4px;margin-right:5px;border-right:1px solid #eee;}
div.colborder {padding-right:24px;margin-right:25px;border-right:1px solid #eee;}
.pull-1 {margin-left:-40px;}
.pull-2 {margin-left:-80px;}
.pull-3 {margin-left:-120px;}
.pull-4 {margin-left:-160px;}
.pull-5 {margin-left:-200px;}
.pull-6 {margin-left:-240px;}
.pull-7 {margin-left:-280px;}
.pull-8 {margin-left:-320px;}
.pull-9 {margin-left:-360px;}
.pull-10 {margin-left:-400px;}
.pull-11 {margin-left:-440px;}
.pull-12 {margin-left:-480px;}
.pull-13 {margin-left:-520px;}
.pull-14 {margin-left:-560px;}
.pull-15 {margin-left:-600px;}
.pull-16 {margin-left:-640px;}
.pull-17 {margin-left:-680px;}
.pull-18 {margin-left:-720px;}
.pull-19 {margin-left:-760px;}
.pull-20 {margin-left:-800px;}
.pull-21 {margin-left:-840px;}
.pull-22 {margin-left:-880px;}
.pull-23 {margin-left:-920px;}
.pull-24 {margin-left:-960px;}
.pull-1, .pull-2, .pull-3, .pull-4, .pull-5, .pull-6, .pull-7, .pull-8, .pull-9, .pull-10, .pull-11, .pull-12, .pull-13, .pull-14, .pull-15, .pull-16, .pull-17, .pull-18, .pull-19, .pull-20, .pull-21, .pull-22, .pull-23, .pull-24 {float:left;position:relative;}
.push-1 {margin:0 -40px 1.5em 40px;}
.push-2 {margin:0 -80px 1.5em 80px;}
.push-3 {margin:0 -120px 1.5em 120px;}
.push-4 {margin:0 -160px 1.5em 160px;}
.push-5 {margin:0 -200px 1.5em 200px;}
.push-6 {margin:0 -240px 1.5em 240px;}
.push-7 {margin:0 -280px 1.5em 280px;}
.push-8 {margin:0 -320px 1.5em 320px;}
.push-9 {margin:0 -360px 1.5em 360px;}
.push-10 {margin:0 -400px 1.5em 400px;}
.push-11 {margin:0 -440px 1.5em 440px;}
.push-12 {margin:0 -480px 1.5em 480px;}
.push-13 {margin:0 -520px 1.5em 520px;}
.push-14 {margin:0 -560px 1.5em 560px;}
.push-15 {margin:0 -600px 1.5em 600px;}
.push-16 {margin:0 -640px 1.5em 640px;}
.push-17 {margin:0 -680px 1.5em 680px;}
.push-18 {margin:0 -720px 1.5em 720px;}
.push-19 {margin:0 -760px 1.5em 760px;}
.push-20 {margin:0 -800px 1.5em 800px;}
.push-21 {margin:0 -840px 1.5em 840px;}
.push-22 {margin:0 -880px 1.5em 880px;}
.push-23 {margin:0 -920px 1.5em 920px;}
.push-24 {margin:0 -960px 1.5em 960px;}
.push-1, .push-2, .push-3, .push-4, .push-5, .push-6, .push-7, .push-8, .push-9, .push-10, .push-11, .push-12, .push-13, .push-14, .push-15, .push-16, .push-17, .push-18, .push-19, .push-20, .push-21, .push-22, .push-23, .push-24 {float:right;position:relative;}
.box {padding:1.5em;margin-bottom:1.5em;background:#E5ECF9;}
hr {background:#ddd;color:#ddd;clear:both;float:none;width:100%;height:.1em;margin:0 0 1.45em;border:none;}
hr.space {background:#fff;color:#fff;}
.clearfix:after, .container:after {content:".";display:block;height:0;clear:both;visibility:hidden;}
.clearfix, .container {display:inline-block;}
* html .clearfix, * html .container {height:1%;}
.clearfix, .container {display:block;}
.clear {clear:both;}

/* forms.css */
label {font-weight:bold;}
fieldset {padding:1.4em;margin:0 0 1.5em 0;border:1px solid #ccc;}
legend {font-weight:bold;font-size:1.2em;}
input.text, input.title, textarea, select {margin:0.5em 0;border:1px solid #bbb;}
input.text:focus, input.title:focus, textarea:focus, select:focus {border:1px solid #666;}
input.text, input.title {width:300px;padding:5px;}
input.title {font-size:1.5em;}
textarea {width:390px;height:250px;padding:5px;}
.error, .notice, .success {padding:.8em;margin-bottom:1em;border:2px solid #ddd;}
.error {background:#FBE3E4;color:#8a1f11;border-color:#FBC2C4;}
.notice {background:#FFF6BF;color:#514721;border-color:#FFD324;}
.success {background:#E6EFC2;color:#264409;border-color:#C6D880;}
.error a {color:#8a1f11;}
.notice a {color:#514721;}
.success a {color:#264409;}'! !

!SKFileLibrary methodsFor: 'processing' stamp: 'lr 9/26/2008 14:47'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot stylesheet
		addScreen;
		addProjection;
		url: (self urlOf: #screenCss).
	aHtmlRoot stylesheet
		addPrint;
		url: (self urlOf: #printCss).
	aHtmlRoot if ie do: [
		aHtmlRoot stylesheet
			addScreen;
			addProjection;
			url: (self urlOf: #ieCss) ].
	aHtmlRoot stylesheet
		url: (self urlOf: #defaultCss).! !

!Object methodsFor: '*sourcetalk' stamp: 'lr 9/26/2008 14:06'!
s2root
	^ SKRoot default! !

Object subclass: #SKEntry
	instanceVariableNames: 'id title wiki tags timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKEntry class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:07'!
descriptionTags
	^ MATokenDescription new
		accessor: #tags;
		priority: 140;
		label: 'Tags';
		yourself! !

!SKEntry class methodsFor: 'accessing-description' stamp: 'lr 10/3/2008 12:13'!
descriptionTimestamp
	^ MATimeStampDescription new
		accessor: #timestamp;
		priority: 200;
		label: 'Created';
		readonly: true;
		beHidden;
		yourself! !

!SKEntry class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:10'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 120;
		label: 'Title';
		beRequired;
		yourself! !

!SKEntry class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:07'!
descriptionWiki
	^ PRDocumentDescription new
		accessor: #wiki;
		priority: 130;
		label: 'Wiki';
		yourself! !

!SKEntry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:41'!
addTag: aTag
	tags add: aTag! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 9/11/2008 11:02'!
id
	^ id! !

!SKEntry methodsFor: 'initialization' stamp: 'lr 10/10/2008 11:42'!
initialize
	id := UUID new.
	timestamp := TimeStamp now.
	tags := #()! !

!SKEntry methodsFor: 'testing' stamp: 'lr 7/7/2008 14:36'!
isEditableBy: aUser
	self subclassResponsibility! !

!SKEntry methodsFor: 'testing' stamp: 'lr 7/7/2008 14:36'!
isVisibleBy: aUser
	self subclassResponsibility! !

!SKEntry methodsFor: 'accessing' stamp: 'AQ 7/7/2008 11:37'!
removeTag: aTag
	tags remove: aTag! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 10/10/2008 11:43'!
tags
	^tags ifNil: [ #() ]! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:33'!
tags: aCollection
	tags := aCollection! !

!SKEntry methodsFor: 'accessing' stamp: 'lr 9/11/2008 10:54'!
timestamp
	^ timestamp! !

!SKEntry methodsFor: 'accessing' stamp: 'AQ 6/30/2008 10:56'!
title
	^title! !

!SKEntry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:39'!
title: aString
	title := aString! !

!SKEntry methodsFor: 'accessing' stamp: 'AQ 6/18/2008 17:56'!
wiki
	^wiki! !

!SKEntry methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:37'!
wiki: anObject
	wiki := anObject! !

SKEntry subclass: #SKMember
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

SKMember subclass: #SKGroup
	instanceVariableNames: 'users admins creator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKGroup methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
addAdmin: aUser
	admins add: aUser.
	aUser groups add: self! !

!SKGroup methodsFor: 'accessing' stamp: 'AQ 7/6/2008 17:30'!
addUser: aUser
	users add: aUser.
	aUser groups add: self! !

!SKGroup methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
admins
	^ admins! !

!SKGroup methodsFor: 'accessing' stamp: 'AQ 9/7/2008 14:44'!
creator
	^ creator! !

!SKGroup methodsFor: 'accessing' stamp: 'AQ 9/7/2008 14:45'!
creator: aString
	creator := aString! !

!SKGroup methodsFor: 'initialization' stamp: 'AQ 7/9/2008 12:14'!
initialize
	super initialize.
	users := Set new.
	admins := Set new.! !

!SKGroup methodsFor: 'testing' stamp: 'lr 10/3/2008 12:23'!
isEditableBy: aUser
	^ aUser isSuperuser or: [admins includes: aUser].! !

!SKGroup methodsFor: 'testing' stamp: 'lr 10/3/2008 12:23'!
isVisibleBy: aUser 
	^ aUser isSuperuser or: [ (admins includes: aUser) or: [ users includes: aUser ] ]! !

!SKGroup methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:13'!
removeAdmin: aUser
	admins remove: aUser.
	aUser groups remove: self! !

!SKGroup methodsFor: 'accessing' stamp: 'AQ 7/6/2008 19:47'!
removeUser: aUser
	users remove: aUser.
	aUser groups remove: self! !

!SKGroup methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:46'!
users
	^ users! !

SKMember subclass: #SKPerson
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

SKPerson subclass: #SKAnonymousUser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKAnonymousUser methodsFor: 'testing' stamp: 'lr 8/19/2008 11:28'!
isAnonymous
	^ true! !

!SKPerson class methodsFor: 'accessing-description' stamp: 'AQ 9/5/2008 16:28'!
descriptionTitle
	^ super descriptionTitle label: 'Name'! !

!SKPerson methodsFor: 'testing' stamp: 'lr 8/19/2008 11:27'!
isAnonymous
	^ false! !

!SKPerson methodsFor: 'accessing' stamp: 'lr 10/3/2008 12:22'!
isSuperuser
	^ false! !

SKPerson subclass: #SKUser
	instanceVariableNames: 'email password groups superuser prename lastname commits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKUser class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:08'!
descriptionEmail
	^ MAStringDescription new
		accessor: #email;
		label: 'Email';
		priority: 150;
		beRequired;
		yourself! !

!SKUser class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:09'!
descriptionLastname
	^ MAStringDescription new
		accessor: #lastname;
		label: 'Last name';
		priority: 110;
		beRequired;
		yourself! !

!SKUser class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:08'!
descriptionPassword
	^ MAPasswordDescription new
		componentClass: MAVerifiedPasswordComponent; 
		accessor: #password;
		label: 'Password';
		priority: 160;
		beRequired;
		yourself! !

!SKUser class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:08'!
descriptionPrename
	^ MAStringDescription new
		accessor: #prename;
		label: 'Prename';
		priority: 100;
		beRequired;
		yourself! !

!SKUser class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:08'!
descriptionSuperuser
	^ MABooleanDescription new
		onlySuperuser: true;
		accessor: #superuser;
		label: 'Superuser';
		priority: 170;
		yourself! !

!SKUser class methodsFor: 'accessing-description' stamp: 'AQ 10/10/2008 10:10'!
descriptionTitle
	^ MAStringDescription new
		accessor: #title;
		priority: 120;
		label: 'Title';
		beHidden;
		yourself! !

!SKUser methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:46'!
addGroup: aGroup
	groups add: aGroup.
	aGroup users add: self! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
email
	^ email! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
email: anObject
	email := anObject! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 6/30/2008 11:57'!
groups
	^ groups! !

!SKUser methodsFor: 'private' stamp: 'lr 7/9/2008 15:01'!
hashPassword: aString 
	^ aString isEmptyOrNil ifFalse: [ SecureHashAlgorithm new hashMessage: aString ]! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 10/10/2008 10:37'!
initialize
	super initialize.
	superuser := false.
	groups := Set new.
	commits := 0.! !

!SKUser methodsFor: 'testing' stamp: 'lr 10/3/2008 12:24'!
isEditableBy: aUser
	^ aUser = self or: [aUser isSuperuser]! !

!SKUser methodsFor: 'testing' stamp: 'lr 10/3/2008 12:22'!
isSuperuser
	^ superuser! !

!SKUser methodsFor: 'testing' stamp: 'lr 9/11/2008 11:41'!
isVisibleBy: aUser
	^ aUser isAnonymous not.! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 10/10/2008 10:05'!
lastname
	^ lastname! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 10/10/2008 10:06'!
lastname: aString
	lastname := aString! !

!SKUser methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:43'!
password
	^ nil! !

!SKUser methodsFor: 'accessing' stamp: 'lr 7/9/2008 15:01'!
password: aString 
	password := self hashPassword: aString! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 10/10/2008 10:05'!
prename
	^ prename! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 10/10/2008 10:05'!
prename: aString
	prename := aString! !

!SKUser methodsFor: 'accessing' stamp: 'AQ 7/6/2008 19:47'!
removeGroup: aGroup
	groups remove: aGroup.
	aGroup users remove: self! !

!SKUser methodsFor: 'accessing' stamp: 'lr 8/19/2008 11:41'!
superuser
	^ superuser! !

!SKUser methodsFor: 'accessing' stamp: 'lr 8/19/2008 11:42'!
superuser: aBoolean
	superuser := aBoolean! !

!SKUser methodsFor: 'testing' stamp: 'lr 7/9/2008 15:02'!
verifyPassword: aString
	^ (self hashPassword: aString) = password! !

SKEntry subclass: #SKProject
	instanceVariableNames: 'repository license state rating visibility admins developers creator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

!SKProject class methodsFor: 'accessing-description' stamp: 'AQ 9/10/2008 19:37'!
descriptionLicense
	^ MASingleOptionDescription new
		options: #( 'None' 'MIT' 'Squeak' 'BSD' 'GPLv2' 'GPLv3' 'LPGLv2' 'LGPLv3' 'WTFPL');
		accessor: #license;
		priority: 140;
		label: 'License';
		beRequired;
		yourself! !

!SKProject class methodsFor: 'accessing-description' stamp: 'AQ 9/15/2008 10:13'!
descriptionState
	^ MASingleOptionDescription new
		options: #( 'Planning' 'Pre-Alpha' 'Alpha' 'Beta' 'Production / Stable' 'Mature' 'Inactive');
		accessor: #state;
		priority: 150;
		label: 'State';
		yourself! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 7/12/2008 22:00'!
addAdmin: aUserOrGroup
	admins add: aUserOrGroup.! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 7/12/2008 22:00'!
addDeveloper: aUserOrGroup
	developers add: aUserOrGroup.! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
admins
	^ admins! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 9/7/2008 14:44'!
creator
	^ creator! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 9/7/2008 14:45'!
creator: aString
	creator := aString! !

!SKProject methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:39'!
developers
	^ developers! !

!SKProject methodsFor: 'initialization' stamp: 'lr 9/2/2008 11:50'!
initialize
	super initialize.
	developers := Set new.
	admins := Set new.
	rating := 0.
	visibility := #hidden.
	state := 'Created'.! !

!SKProject methodsFor: 'testing' stamp: 'lr 10/3/2008 12:23'!
isEditableBy: aUser
	^ aUser isSuperuser or: [admins includes: aUser].! !

!SKProject methodsFor: 'testing' stamp: 'lr 10/3/2008 12:23'!
isVisibleBy: aUser 
	^ aUser isSuperuser or: 
		[ (admins includes: aUser) or: [ (developers includes: aUser) or: [ visibility = #visible ] ] ]! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
license
	^ license! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
license: anObject
	license := anObject! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
rating
	^ rating! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
rating: anObject
	rating := anObject! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 7/12/2008 22:04'!
removeAdmin: aUserOrGroup
	admins remove: aUserOrGroup.! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 7/12/2008 22:05'!
removeDeveloper: aUserOrGroup
	developers remove: aUserOrGroup.! !

!SKProject methodsFor: 'accessing' stamp: 'lr 9/11/2008 12:10'!
repository
	^ repository ifNil: [ repository := MDFileRepository named: self id asString ]! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
state
	^ state! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 6/29/2008 17:34'!
state: anObject
	state := anObject! !

!SKProject methodsFor: 'accessing' stamp: 'AQ 7/9/2008 12:56'!
visibility
	^ visibility
	
"
#hidden
#visible
#writeable
"! !

!SKProject methodsFor: 'accessing' stamp: 'lr 7/7/2008 14:35'!
visibility: aCaracter
	visibility := aCaracter

"
#hidden
#visible
#writeable
"
! !

SKEntry subclass: #SKRoot
	instanceVariableNames: 'anonymous users groups projects smtpServer noReplyMail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Core'!

SKRoot class
	instanceVariableNames: 'Default'!

SKRoot class
	instanceVariableNames: 'Default'!

!SKRoot class methodsFor: 'accessing' stamp: 'lr 7/7/2008 14:29'!
default
	^ Default! !

!SKRoot class methodsFor: 'accessing-description' stamp: 'lr 9/8/2008 11:49'!
descriptionNoReplyMail
	^ MAStringDescription new
		accessor: #noReplyMail;
		priority: 150;
		label: 'Generated email';
		beRequired;
		yourself! !

!SKRoot class methodsFor: 'accessing-description' stamp: 'lr 9/26/2008 14:52'!
descriptionSmtpServer
	^ MAStringDescription new
		accessor: #smtpServer;
		priority: 140;
		label: 'SMTP Server';
		comment: 'This is the SMTP Server used for sending mails.';
		beRequired;
		yourself! !

!SKRoot class methodsFor: 'initialization' stamp: 'lr 7/7/2008 14:29'!
initialize
	Default := self new! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addGroup: aGroup
	groups add: aGroup! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addProject: aProject
	projects add: aProject! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:35'!
addUser: aUser
	users add: aUser! !

!SKRoot methodsFor: 'accessing' stamp: 'AQ 8/20/2008 14:58'!
anonymous
	^ anonymous! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:35'!
countProjectsOfUser: aUser 
	^ self projects
		count: [:project | (project admins includes: aUser)
				or: [project developers includes: aUser]]! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:45'!
getGroupsOfUser: aUser 
	^ self groups
		select: [:group | (group admins includes: aUser)
				or: [group users includes: aUser]]! !

!SKRoot methodsFor: 'querying' stamp: 'lr 9/11/2008 12:06'!
getProjectNamed: aString
	^ self projects detect: [:each | each title = aString].! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/6/2008 13:43'!
getProjectsOfUser: aUser 
	^ self projects
		select: [:project | (project admins includes: aUser)
				or: [project developers includes: aUser]]! !

!SKRoot methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:41'!
groups
	^ groups! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/5/2008 16:23'!
groupsOfUser: aUser 
	^ self groups
		select: [:eachGroup | (eachGroup admins includes: aUser)
				or: [eachGroup users includes: aUser]]! !

!SKRoot methodsFor: 'initialization' stamp: 'lr 9/18/2008 14:57'!
initialize
	super initialize.
	title := 'Sourcetalk'.
	anonymous := SKAnonymousUser new.
	users := Set new.
	projects := Set new.
	groups := Set new! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:27'!
noReplyMail
	^ noReplyMail! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:27'!
noReplyMail: anObject
	noReplyMail := anObject! !

!SKRoot methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:42'!
projects
	^ projects! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:37'!
removeGroup: aGroup
		groups remove: aGroup! !

!SKRoot methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:52'!
removeProject: aProject
		projects remove: aProject! !

!SKRoot methodsFor: 'accessing' stamp: 'AQ 7/6/2008 20:51'!
removeUser: aUser
		users remove: aUser! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:27'!
smtpServer
	^ smtpServer! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:27'!
smtpServer: anObject
	smtpServer := anObject! !

!SKRoot methodsFor: 'querying' stamp: 'AQ 9/7/2008 14:24'!
userByEMail: aString
	^ self users detect: [ :each | each email = aString ] ifNone: [ nil ]! !

!SKRoot methodsFor: 'accessing' stamp: 'lr 6/30/2008 14:36'!
users
	^ users! !

WAComponent subclass: #SKComponent
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKComponent class methodsFor: 'instance creation' stamp: 'AQ 9/2/2008 01:39'!
on: aComponent
	^ self new initializeOn: aComponent! !

!SKComponent methodsFor: 'initialization' stamp: 'AQ 9/2/2008 01:37'!
initializeOn: aComponent
	root := aComponent! !

!SKComponent methodsFor: 'accessing' stamp: 'AQ 9/2/2008 01:37'!
root
	^ root! !

!SKComponent methodsFor: 'accessing' stamp: 'AQ 9/2/2008 01:37'!
user
	^ self session user! !

SKComponent subclass: #SKContentComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKContentComponent subclass: #SKCodeBrowserView
	instanceVariableNames: 'repository memo selectedClass selectedMethod categories selectedCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKCodeBrowserView methodsFor: 'querying-highlevel' stamp: 'lr 10/10/2008 11:30'!
categories
	^ categories ifNil: [ 
		categories := self classes
			collect: [ :each | each variant properties at: #category ].
		categories := categories asArray sort ]! !

!SKCodeBrowserView methodsFor: 'querying-highlevel' stamp: 'lr 10/10/2008 11:14'!
classes
	^ self versions select: [ :each | each element isKindOf: MDClassElement ]! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'lr 10/3/2008 11:52'!
elements
	^ self versions collect: [ :each | each element ]! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/3/2008 11:34'!
memo
	^ memo! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/3/2008 11:34'!
memo: anObject
	memo := anObject! !

!SKCodeBrowserView methodsFor: 'querying-highlevel' stamp: 'lr 10/10/2008 11:16'!
methods
	selectedClass ifNil: [ ^ Set new ].
	^ self versions select: [ :each | (each element isKindOf: MDMethodElement) and: [each element theClassName = selectedClass element theClassName ]]! !

!SKCodeBrowserView methodsFor: 'rendering' stamp: 'AQ 10/11/2008 19:54'!
renderContentOn: html 
	html heading: self memo name.
	html form: [ html div class: 'browse'; with: [
			html select on: #selectedCategory of: self; list: self categories; size: 10; beSubmitOnChange.
			html select on: #selectedClass of: self; list: self classes; size: 10; beSubmitOnChange; labels: [ :each | each element theClassName ].
			html select on: #selectedMethod of: self; list: self methods; size: 10; beSubmitOnChange; labels: [ :each | each element selector ]]].
	self renderSourceOn: html! !

!SKCodeBrowserView methodsFor: 'rendering' stamp: 'AQ 10/11/2008 19:52'!
renderSourceOn: html 
	selectedMethod isNil ifFalse: [ html code: (selectedMethod variant properties at: #source) ]! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/3/2008 11:34'!
repository
	^ repository! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/3/2008 11:34'!
repository: anObject
	repository := anObject! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/10/2008 11:29'!
selectedCategory
	^ selectedCategory! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'lr 10/10/2008 11:29'!
selectedCategory: aString
	selectedCategory := aString! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 20:17'!
selectedClass
	^ selectedClass! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 16:33'!
selectedClass: aMDClassElement
	selectedClass := aMDClassElement! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/9/2008 21:10'!
selectedMethod
	^ selectedMethod! !

!SKCodeBrowserView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 16:39'!
selectedMethod: aMDMethodElement
	selectedMethod := aMDMethodElement! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'lr 10/3/2008 11:48'!
snapshot
	^ self repository get: self memo reference! !

!SKCodeBrowserView methodsFor: 'querying' stamp: 'lr 10/3/2008 11:50'!
versions
	^ self snapshot getVersionsFrom: self repository! !

SKContentComponent subclass: #SKForgotPasswordView
	instanceVariableNames: 'input message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKForgotPasswordView methodsFor: 'actions' stamp: 'AQ 10/4/2008 21:53'!
checkInput
	| user |
	user := self s2root userByEMail: input.
	user notNil
		ifTrue: [message := 'We sended you your password per mail'.
			self sendMail: user]
		ifFalse: [message := 'EMAIL FALSE']! !

!SKForgotPasswordView methodsFor: 'accessing' stamp: 'AQ 9/7/2008 01:36'!
input
	^ input! !

!SKForgotPasswordView methodsFor: 'accessing' stamp: 'AQ 9/7/2008 01:37'!
input: aString
	input := aString! !

!SKForgotPasswordView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 21:51'!
renderContentOn: html
	html heading: 'Forgot your Password?'.
	html paragraph: message.
	html form: [
		html text: 'Enter your Email: '.
		html textInput on: #input of: self;
			value: ''.
		html break.
		html submitButton text: 'Submit';
			callback: [self checkInput]]! !

!SKForgotPasswordView methodsFor: 'rendering' stamp: 'lr 10/3/2008 12:23'!
sendMail: user 
	| url view |
	user isSuperuser ifTrue: 
		[ self inform: 'Superusers shoud never forget their password.'.
		self answer ].
	Continuation currentDo: 
		[ :cc | 
		url := self session actionUrlForContinuation: cc.
		
		[ self 
			sendMailTo: user
			url: url ] 
			on: Exception
			do: 
				[ :error | 
				self
					inform: error messageText , '. Please contact the site-administrator.';
					answer ].
		self inform: 'An e-mail has been successfully sent to you.'.
		self answer ].
	self session login: user.
	view := SKUserView on: self root.
	view viewedUser: user.
	self root content: view.
	view edit! !

!SKForgotPasswordView methodsFor: 'rendering' stamp: 'lr 9/8/2008 12:05'!
sendMailTo: aUser url: aUrl
	SMTPClient
		deliverMailFrom: self s2root noReplyMail
		to: (Array with: aUser email)
		text: (String streamContents: [ :stream |
			stream nextPutAll: 'From: '; nextPutAll: self s2root noReplyMail; crlf.
			stream nextPutAll: 'To: '; nextPutAll: aUser email; crlf.
			stream nextPutAll: 'Subject: Forgot password'; crlf.
			stream crlf.
			stream nextPutAll: 'Hi Andrea Quadri,

we received a request (presumeably by you) that you forgot your password. To log into your account and to change your password please visit the link below:

	'; print: aUrl; nextPutAll: '
	
If you didn''t sent this request, please forget about this mail. Your account-information won''t be changed and you will be able to access your account with your old password.'; crlf. ])
		usingServer: self s2root smtpServer.! !

SKContentComponent subclass: #SKGroupView
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKGroupView methodsFor: 'actions' stamp: 'AQ 9/2/2008 19:18'!
delete: aGroup 
	self s2root removeGroup: aGroup! !

!SKGroupView methodsFor: 'editing' stamp: 'AQ 9/2/2008 19:18'!
edit
	self call: (group asComponent addValidatedForm; addMessage: 'Edit Group'; yourself)! !

!SKGroupView methodsFor: 'accessing' stamp: 'AQ 9/2/2008 18:26'!
group
	^ group! !

!SKGroupView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:40'!
group: aGroup 
	group := aGroup! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:18'!
renderActionsOn: html 
	html
		break;
		break.
	(self group isEditableBy: self session user) ifFalse: [ ^ self ].
	html anchor
		callback: [ self edit ];
		with: 'Edit'.
	html break.
	html anchor
		callback: [ self delete: self group ];
		with: 'Delete'! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:54'!
renderContentOn: html 
	html heading: group title , ' Group'.
	self renderWikiOn: html.
	self renderMembersOn: html.
	self renderActionsOn: html! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:53'!
renderGroupAdminsOn: html 
	html break.
	html text: 'Admins:'.
	group admins do: 
		[ :admin | 
		html
			text: ' ';
			text: admin title ]! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:53'!
renderGroupCreatorOn: html 
	html
		break;
		break.
	html text: 'Creator:'.
	html
		text: ' ';
		text: group creator! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:52'!
renderGroupUsersOn: html
	html break.
	html text: 'Members:'.
	group users do: 
		[ :user | 
		html
			text: ' ';
			text: user title ]! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:54'!
renderMembersOn: html 
	html text: 'Members'.
	self renderGroupCreatorOn: html.
	self renderGroupAdminsOn: html.
	self renderGroupUsersOn: html! !

!SKGroupView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:17'!
renderWikiOn: html 
	PRViewRenderer new 
		start: self group wiki
		in: self
		on: html! !

SKContentComponent subclass: #SKGroupsView
	instanceVariableNames: 'searchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKGroupsView class methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:38'!
label
	^ 'Groups'.! !

!SKGroupsView methodsFor: 'initialization' stamp: 'AQ 10/10/2008 09:36'!
initialize
	super initialize.
	self searchString: '*'! !

!SKGroupsView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:30'!
renderContentOn: html 
	html heading: 'Groups'.
	html table: 
		[ self rendertableHeadOn: html.
		self s2root groups asOrderedCollection keysAndValuesDo: (self renderGroupsTableOn: html) ]! !

!SKGroupsView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:31'!
renderGroupsTableOn: html 
	^ [:index :each | ((searchString match: each title)
			or: [searchString match: each tags asCommaString])
		ifTrue: [html tableRow class: 'even' if: index even;
				with: (self renderTableDataOn: html with: each)]]! !

!SKGroupsView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:31'!
renderTableDataOn: html with: each 
	^ 
	[ html tableData: 
		[ html anchor
			callback: [ self viewGroup: each ];
			with: each title ].
	html tableData: [ each admins do: [ :ea | html text: ea name ] ].
	html tableData: [ each users do: [ :ea | html text: ea name ] ].
	html tableData: (each tags isNil ifFalse: [ each tags asCommaString ]) ]! !

!SKGroupsView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:28'!
rendertableHeadOn: html 
	html tableHead: 
		[ html
			tableHeading: 'Groupname';
			tableHeading: 'Admins';
			tableHeading: 'Member';
			tableHeading: 'Tags' ]! !

!SKGroupsView methodsFor: 'accessing' stamp: 'AQ 9/6/2008 15:43'!
searchString
	^ searchString! !

!SKGroupsView methodsFor: 'accessing' stamp: 'AQ 9/6/2008 15:43'!
searchString: anObject
	searchString := anObject! !

!SKGroupsView methodsFor: 'as yet unclassified' stamp: 'AQ 10/4/2008 15:57'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot link
		beRss; 
		beAlternate;
		title: self s2root title;
		url: 'http://localhost:8080/seaside/groups.rss'.! !

!SKGroupsView methodsFor: 'as yet unclassified' stamp: 'AQ 10/4/2008 15:58'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'groups'! !

!SKGroupsView methodsFor: 'actions' stamp: 'AQ 10/10/2008 09:29'!
viewGroup: aGroup 
	| view |
	view := SKGroupView new.
	view group: aGroup.
	self call: view; on: self root content.! !

SKContentComponent subclass: #SKMembersView
	instanceVariableNames: 'searchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKMembersView class methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:38'!
label
	^ 'Members'.! !

!SKMembersView methodsFor: 'initialization' stamp: 'AQ 10/10/2008 09:36'!
initialize
	super initialize.
	self searchString: '*'! !

!SKMembersView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:33'!
renderContentOn: html 
	html heading: 'Members'.
	html
		table: [self renderTableHeadOn: html.
			(self renderMemberTableOn: html)]! !

!SKMembersView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:56'!
renderMemberTableOn: html 
	^ self s2root users asOrderedCollection
				keysAndValuesDo: [:index :each | ((searchString match: each title)
			or: [searchString match: each tags asCommaString])
		ifTrue: [html tableRow class: 'even' if: index even;
				with: [self renderTableDataOn: html with: each]]]! !

!SKMembersView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:22'!
renderTableDataOn: html with: each 
	html tableData: 
		[ html anchor
			callback: [ self viewUser: each ];
			with: each title ].
	html tableData: (self s2root countProjectsOfUser: each).
	html tableData: (self s2root groupsOfUser: each).
	^ html tableData: (each tags isNil ifFalse: [ each tags asCommaString ])! !

!SKMembersView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:26'!
renderTableHeadOn: html 
	html tableHead: 
		[ html
			tableHeading: 'Name';
			tableHeading: 'Projects';
			tableHeading: 'Groups';
			tableHeading: 'Tags';
			tableHeading: 'Commits' ]! !

!SKMembersView methodsFor: 'accessing' stamp: 'AQ 9/6/2008 15:17'!
searchString
	^ searchString! !

!SKMembersView methodsFor: 'accessing' stamp: 'AQ 9/6/2008 15:17'!
searchString: anObject
	searchString := anObject! !

!SKMembersView methodsFor: 'updating' stamp: 'AQ 10/4/2008 15:45'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot link
		beRss; 
		beAlternate;
		title: self s2root title;
		url: 'http://localhost:8080/seaside/members.rss'.! !

!SKMembersView methodsFor: 'updating' stamp: 'AQ 10/4/2008 15:47'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'members'! !

!SKMembersView methodsFor: 'actions' stamp: 'AQ 10/10/2008 09:52'!
viewUser: aUser
	| view |
	view := SKUserView new.
	view viewedUser: aUser.
	self call: view; on: self root content.
	! !

SKContentComponent subclass: #SKProjectView
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKProjectView class
	instanceVariableNames: 'project'!

SKProjectView class
	instanceVariableNames: 'project'!

!SKProjectView methodsFor: 'actions' stamp: 'lr 9/18/2008 14:43'!
addAdmin
	| view users |
	view := SKSelectUserView new.
	view title: 'Add Admins'.
	view project: project.
	view list: (self s2root users reject: [ :each | project admins includes: each ]).
	users := self call: view.
	users do: [ :user | project addAdmin: user ]! !

!SKProjectView methodsFor: 'actions' stamp: 'lr 9/18/2008 14:43'!
addDeveloper
	| view users |
	view := SKSelectUserView new.
	view title: 'Add Developers'.
	view project: project.
	view list: (self s2root users reject: 
			[ :each | 
			(project admins includes: each) or: [ project developers includes: each ] ]).
	users := self call: view.
	users do: [ :user | project addDeveloper: user ]! !

!SKProjectView methodsFor: 'actions' stamp: 'lr 10/3/2008 11:32'!
browse: aRepository with: aMemo
	| view |
	view := SKCodeBrowserView new.
	view repository: aRepository; memo: aMemo.
	self call: view; on: self root content.! !

!SKProjectView methodsFor: 'actions' stamp: 'AQ 9/3/2008 13:43'!
delete: aProject 
	self s2root removeProject: aProject! !

!SKProjectView methodsFor: 'actions' stamp: 'AQ 9/3/2008 13:43'!
edit
	self call: (project asComponent addValidatedForm; addMessage: 'Edit Project'; yourself)! !

!SKProjectView methodsFor: 'accessing' stamp: 'lr 7/9/2008 14:41'!
project
	^ project! !

!SKProjectView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:43'!
project: aProject 
	project := aProject! !

!SKProjectView methodsFor: 'actions' stamp: 'lr 9/18/2008 14:43'!
removeAdmin
	| view users |
	view := SKSelectUserView new.
	view project: project.
	view title: 'Remove Admins'.
	view list: (self s2root getProjectNamed: project title) admins.
	users := self call: view.
	users do: [ :user | project removeAdmin: user ]! !

!SKProjectView methodsFor: 'actions' stamp: 'lr 9/18/2008 14:43'!
removeDeveloper
	| view users |
	view := SKSelectUserView new.
	view project: project.
	view title: 'Remove Developer'.
	view list: (self s2root getProjectNamed: project title) developers.
	users := self call: view.
	users do: [ :user | project removeDeveloper: user ]! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:15'!
renderActionsOn: html 
	html
		break;
		break.
	(self project isEditableBy: self session user) ifFalse: [ ^ self ].
	html anchor
		callback: [ self edit ];
		with: 'Edit Project'.
	html break.
	html anchor
		callback: [ self delete: self project ];
		with: 'Delete'! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:27'!
renderAdminsOn: html 
	html break.
	html text: 'Admins: '.
	project admins do: [ :admin | html text: admin title , ', ' ].
	(project isEditableBy: self session user) ifFalse: [ ^ self ].
	self renderEditAdminsOn: html! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:16'!
renderContentOn: html 
	html heading
		level: 2;
		with: 'Project ' , project title.
	self renderWikiOn: html.
	self renderCreatorOn: html.
	self renderAdminsOn: html.
	self renderDeveloperOn: html.
	self renderRegistrationOn: html.
	self renderVersionsOn: html.
	self renderStatisticsOn: html.
	self renderActionsOn: html! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:16'!
renderCreatorOn: html 
	html heading
		level: 3;
		with: 'Members'.
	html text: 'Creator:'.
	html
		text: ' ';
		text: project creator! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:27'!
renderDeveloperOn: html 
	html break.
	html text: 'Developers:'.
	project developers do: 
		[ :developer | 
		html text: ' ';
			text: developer title ].
	(project isEditableBy: self session user) ifFalse: [ ^ self ].
	self renderEditDeveloperOn: html! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:27'!
renderEditAdminsOn: html 
	html text: ' ('.
	html anchor
		callback: [ self addAdmin ];
		with: 'Add'.
	html text: ' / '.
	html anchor
		callback: [ self removeAdmin ];
		with: 'Remove'.
	html text: ')'! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:27'!
renderEditDeveloperOn: html 
	html text: ' ('.
	html anchor
		callback: [ self addDeveloper ];
		with: 'Add'.
	html text: ' / '.
	html anchor
		callback: [ self removeDeveloper ];
		with: 'Remove'.
	html text: ')'! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 21:37'!
renderRegistrationOn: html 
	html break; break.
	html heading
		level: 3;
		with: 'Registration'.
	html code: ('MDSourceTalkRepository
		url: ''http://localhost:8080/seaside/repository/''
		project: ''' , project title , '''
		email: ''').
	self session isLoggedIn ifTrue: [ html code: self session user email ].
	html code: ('''
		password: ''''').! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:15'!
renderStatisticsOn: html 
	html heading
		level: 3;
		with: 'Statistics'.
	html text: 'Registerd: '.
	html text: project timestamp.
	html break.
	html text: 'Total Versions: '.
	html text: (project repository memos count: [ :each | true ])! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:29'!
renderVersionTableDataOn: html 
	^ 
	[ :index :memo | 
	html tableRow
		class: 'even'
			if: index even;
		with: 
			[ html
				tableData: 
					[ html anchor
						callback: 
							[ self 
								browse: self project repository
								with: memo ];
						with: memo name ];
				tableData: memo properties author;
				tableData: memo timestamp asString;
				tableData: memo properties comment ] ]! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:29'!
renderVersionsOn: html 
	html
		break;
		break.
	html heading
		level: 3;
		with: 'Versions'.
	html table: 
		[ self renderVersionsTableHeadOn: html.
		self project repository memos asSortedCollection keysAndValuesDo: (self renderVersionTableDataOn: html) ]! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 10:29'!
renderVersionsTableHeadOn: html 
	html tableHead: 
		[ html
			tableHeading: 'Filename';
			tableHeading: 'Author';
			tableHeading: 'Timestamp';
			tableHeading: 'Comments' ]! !

!SKProjectView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:08'!
renderWikiOn: html 
	PRViewRenderer new 
		start: self project wiki
		in: self
		on: html! !

SKContentComponent subclass: #SKProjectsView
	instanceVariableNames: 'searchString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKProjectsView class methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:38'!
label
	^ 'Projects'.! !

!SKProjectsView methodsFor: 'initialization' stamp: 'AQ 10/10/2008 09:36'!
initialize
	super initialize.
	self searchString: '*'! !

!SKProjectsView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:25'!
renderContentOn: html 
	html heading: 'Projects'.
	html table: 
		[ self renderTableHeadOn: html.
		self s2root projects asOrderedCollection keysAndValuesDo: (self renderProjectsTableOn: html) ]! !

!SKProjectsView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:27'!
renderProjectsTableOn: html 
	^ [:index :each | ((searchString match: each title)
			or: [searchString match: each tags asCommaString])
		ifTrue: [html tableRow class: 'even' if: index even;
				with: [self renderTableDataOn: html with: each]]]! !

!SKProjectsView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:27'!
renderTableDataOn: html with: each 
	html tableData: 
		[ html anchor
			callback: [ self viewProject: each ];
			with: each title ].
	html tableData: [ each admins do: [ :ea | html text: ea title ] ].
	html tableData: [ each developers do: [ :ea | html text: ea title ] ].
	^ html tableData: (each tags isNil ifFalse: [ each tags asCommaString ])! !

!SKProjectsView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:23'!
renderTableHeadOn: html 
	html tableHead: 
		[ html
			tableHeading: 'Projectname';
			tableHeading: 'Admins';
			tableHeading: 'Developers';
			tableHeading: 'Tags';
			tableHeading: 'Activity';
			tableHeading: 'Downloads' ]! !

!SKProjectsView methodsFor: 'accessing' stamp: 'AQ 9/6/2008 15:35'!
searchString
	^ searchString! !

!SKProjectsView methodsFor: 'accessing' stamp: 'AQ 9/6/2008 15:35'!
searchString: anObject
	searchString := anObject! !

!SKProjectsView methodsFor: 'updating' stamp: 'AQ 10/4/2008 15:45'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot link
		beRss; 
		beAlternate;
		title: self s2root title;
		url: 'http://localhost:8080/seaside/projects.rss'.! !

!SKProjectsView methodsFor: 'updating' stamp: 'lr 10/3/2008 12:01'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'projects'! !

!SKProjectsView methodsFor: 'actions' stamp: 'AQ 10/10/2008 09:24'!
viewProject: aProject 
	| view |
	view := SKProjectView new.
	view project: aProject.
	self call: view; on: self root content.! !

SKContentComponent subclass: #SKSearchView
	instanceVariableNames: 'searchInput users projects groups'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKSearchView class methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:38'!
label
	^ 'Search'.! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 9/6/2008 15:27'!
children
	^ Array with: users with: projects with: groups.! !

!SKSearchView methodsFor: 'initialization' stamp: 'lr 9/18/2008 14:43'!
initialize
	super initialize.
	users := SKMembersView on: self.
	projects := SKProjectsView on: self.
	groups := SKGroupsView on: self! !

!SKSearchView methodsFor: 'rendering' stamp: 'AQ 10/10/2008 09:50'!
renderContentOn: html 
	html heading: 'Search'.
	self renderSelectionOn: html.
	searchInput isNil ifTrue: [ ^ self ].
	html render: users.
	"html render: projects.
	html render: groups"! !

!SKSearchView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:22'!
renderSelectionOn: html 
	html form: 
		[ html textInput
			on: #searchInput
				of: self;
			value: ''.
		html break.
		html submitButton
			text: 'Search';
			callback: [ self search ] ]! !

!SKSearchView methodsFor: 'actions' stamp: 'AQ 9/6/2008 15:40'!
search
	(self searchInput sameAs: '')
		ifTrue: [ self searchInput: '*']
		ifFalse: [self searchInput: '*', searchInput, '*'].
	users searchString: searchInput.
	projects searchString: searchInput.
	groups searchString: searchInput.! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 9/5/2008 18:10'!
searchInput
	^ searchInput! !

!SKSearchView methodsFor: 'accessing' stamp: 'AQ 9/5/2008 18:11'!
searchInput: aString
	searchInput := aString! !

!SKSearchView methodsFor: 'as yet unclassified' stamp: 'AQ 10/4/2008 16:01'!
updateUrl: aUrl
	super updateUrl: aUrl.
	aUrl addToPath: 'search'! !

SKContentComponent subclass: #SKSelectUserView
	instanceVariableNames: 'selectedUsers title project list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKSelectUserView methodsFor: 'initialization' stamp: 'AQ 9/11/2008 02:22'!
initialize
	super initialize.
	selectedUsers := Set new.! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/18/2008 12:27'!
list
	^ list! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/18/2008 12:28'!
list: aCollection
	list := aCollection! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/17/2008 00:01'!
project
	^ project! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/17/2008 00:01'!
project: aProject
	project := aProject! !

!SKSelectUserView methodsFor: 'rendering' stamp: 'lr 9/18/2008 14:21'!
renderContentOn: html 
	html heading: title.
	html
		form: [
			html multiSelect on: #selectedUsers of: self;
				list: list;
				labels: [ :each | each title ]. html break.
			html submitButton 
				text: title;
				callback: [ self answer: self selectedUsers ].
			html submitButton
				text: 'Cancel';
				callback: [ self answer: #() ] ].! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/11/2008 02:18'!
selectedUsers
	^ selectedUsers! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/17/2008 00:05'!
selectedUsers: aCollection
	selectedUsers := aCollection! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/11/2008 00:49'!
title
	^ title! !

!SKSelectUserView methodsFor: 'accessing' stamp: 'AQ 9/17/2008 00:06'!
title: aString
	title := aString! !

SKContentComponent subclass: #SKUserView
	instanceVariableNames: 'viewedUser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKUserView methodsFor: 'actions' stamp: 'AQ 9/2/2008 10:02'!
delete: aUser 
	self s2root removeUser: aUser.
	aUser = self session user
		ifTrue: [self session logout]! !

!SKUserView methodsFor: 'actions' stamp: 'AQ 10/4/2008 14:09'!
edit
	| user description component |
	user := viewedUser.
	description := user description
		reject: [ :each | each onlySuperuser and: [ self user isSuperuser not ] ].
	component := description asComponentOn: user.
	user := self call: (component
			addValidatedForm;
			addMessage: 'Edit User';
			yourself).! !

!SKUserView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:20'!
renderActionsOn: html 
	(self viewedUser isEditableBy: self session user) ifFalse: [ ^ self ].
	html anchor
		callback: [ self edit ];
		with: 'Edit'.
	html break.
	html anchor
		callback: [ self delete: self viewedUser ];
		with: 'Delete'! !

!SKUserView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:20'!
renderContentOn: html 
	html heading: 'User ' , viewedUser title.
	self renderWikiOn: html.
	html table: [ viewedUser description do: (self renderUserInfoOn: html) ].
	self renderActionsOn: html! !

!SKUserView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 23:25'!
renderUserInfoOn: html 
	^ 
	[ :description | 
	(description label = 'Password' or: [ description label = 'Superuser' or: [ description label = 'Wiki' ] ]) ifFalse: 
		[ html tableRow: 
			[ html tableData: description label , ': '.
			html tableData: [html text: (description toString: (viewedUser readUsing: description))]]]]! !

!SKUserView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:03'!
renderWikiOn: html 
	PRViewRenderer new 
		start: self viewedUser wiki
		in: self
		on: html! !

!SKUserView methodsFor: 'accessing' stamp: 'AQ 7/15/2008 21:44'!
viewedUser
	^ viewedUser! !

!SKUserView methodsFor: 'accessing' stamp: 'AQ 7/15/2008 21:44'!
viewedUser: anObject
	viewedUser := anObject! !

SKContentComponent subclass: #SKWelcomeView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKWelcomeView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:18'!
renderContentOn: html 
	html heading: 'Home'.
	self renderWikiOn: html.
	self renderStatisticsOn: html! !

!SKWelcomeView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:19'!
renderStatisticsOn: html 
	html break; break.
	html heading level: 3; with: 'Statistics:'.
	html text: 'Members (' , (self s2root users count: [ :each | true ]) asString , ')'.
	html break.
	html text: 'Projects (' , (self s2root projects count: [ :each | true ]) asString , ')'.
	html break.
	html text: 'Groups (' , (self s2root groups count: [ :each | true ]) asString , ')'! !

!SKWelcomeView methodsFor: 'rendering' stamp: 'AQ 10/3/2008 10:01'!
renderWikiOn: html 
	PRViewRenderer new 
		start: self s2root wiki
		in: self
		on: html! !

SKComponent subclass: #SKLeftMenuComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

SKLeftMenuComponent subclass: #SKLoginView
	instanceVariableNames: 'email password message'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKLoginView methodsFor: 'actions' stamp: 'AQ 10/10/2008 10:20'!
addUser: newUser 
	newUser title: newUser prename , ' ' , newUser lastname.
	self s2root addUser: newUser.
	self session user: newUser.
	self root content: SKWelcomeView new! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 21:42'!
email
	^ email! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 21:42'!
email: aString
	email := aString! !

!SKLoginView methodsFor: 'actions' stamp: 'AQ 10/4/2008 21:46'!
forgotPassword
	self message: ''.
	self root content call: (SKForgotPasswordView on: self root)! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 9/3/2008 13:47'!
hashPassword: aString 
	^ aString isEmptyOrNil
		ifFalse: [SecureHashAlgorithm new hashMessage: aString]! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 22:08'!
message
	^ message! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 10/4/2008 22:08'!
message: aString
	message := aString! !

!SKLoginView methodsFor: 'actions' stamp: 'AQ 10/10/2008 10:20'!
newUser
	| newUser description component |
	self message: ''.
	newUser := SKUser new.
	description := newUser description reject: [ :each | each onlySuperuser and: [ self user isSuperuser not ] ].
	component := description asComponentOn: newUser.
	newUser := self root content call: (component
			addValidatedForm;
			addMessage: 'Create User Account';
			yourself).
	newUser isNil ifTrue: [ ^ self ].
	self addUser: newUser! !

!SKLoginView methodsFor: 'accessing' stamp: 'AQ 8/17/2008 16:28'!
password
	^ password! !

!SKLoginView methodsFor: 'accessing' stamp: 'lr 9/8/2008 11:44'!
password: aString 
	password := aString! !

!SKLoginView methodsFor: 'rendering' stamp: 'AQ 10/6/2008 13:24'!
renderContentOn: html 
	html paragraph: self message.
	html form: 
		[ self session isLoggedIn 
			ifFalse: 
				[ 
				self renderRegistNowOn: html.
				self renderLoginInputOn: html.
				self renderLoginButtonsOn: html ]
			ifTrue: [ self renderLoggedIn: html ] ]! !

!SKLoginView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:37'!
renderLoggedIn: html 
	html text: self session user title.
	html break.
	^ html submitButton
		text: 'Logout';
		callback: 
			[ self session logout.
			self root content: SKWelcomeView new ]! !

!SKLoginView methodsFor: 'rendering' stamp: 'AQ 10/6/2008 13:23'!
renderLoginButtonsOn: html 
	html break.
	html submitButton
		text: 'Login';
		callback: [ self validateLogin ].
	html break.
	^ html anchor
		callback: [ self forgotPassword ];
		with: 'Forgot Password?'! !

!SKLoginView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:39'!
renderLoginInputOn: html 
	html text: 'Email: '.
	html textInput
		on: #email
			of: self;
		value: ''.
	html break.
	html text: 'Password: '.
	html passwordInput
		callback: [ :value | self password: value ];
		value: ''! !

!SKLoginView methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:34'!
renderRegistNowOn: html 
	html break.
	html anchor
		callback: [ self newUser ];
		with: 
			[ html image
				url: 'http://localhost:8080/seaside/files/SKFileLibrary/register_now.jpg';
				altText: 'register now' ]! !

!SKLoginView methodsFor: 'actions' stamp: 'AQ 10/4/2008 22:42'!
validateLogin
	"checks if login data is correct."
	| user |
	user := self s2root userByEMail: self email.
	user notNil 
		ifTrue: 
			 [ (user verifyPassword: self password) 
				ifTrue: 
					[ self session user: user.
					self message: '' ]
				ifFalse: [ 'EMAIL OR PASSWORD FALSE' ] ]
		ifFalse: [ self message: 'EMAIL OR PASSWORD FALSE' ]! !

SKLeftMenuComponent subclass: #SKUserMenuComponent
	instanceVariableNames: 'project group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKUserMenuComponent methodsFor: 'actions' stamp: 'AQ 10/4/2008 14:06'!
editAccount
	| user description component |
	user := self session user.
	description := user description
		reject: [ :each | each onlySuperuser and: [ self user isSuperuser not ] ].
	component := description asComponentOn: user.
	user := self root content call: (component
			addValidatedForm;
			addMessage: 'Edit User Account';
			yourself).! !

!SKUserMenuComponent methodsFor: 'actions' stamp: 'lr 9/26/2008 14:54'!
editRoot
	self root content call: (self s2root
		asComponent
			addValidatedForm;
			addMessage: 'Edit Root';
			yourself).! !

!SKUserMenuComponent methodsFor: 'accessing' stamp: 'AQ 10/4/2008 15:08'!
group
	^ group! !

!SKUserMenuComponent methodsFor: 'accessing' stamp: 'AQ 10/4/2008 15:08'!
group: aGroup
	group := aGroup! !

!SKUserMenuComponent methodsFor: 'actions' stamp: 'AQ 10/4/2008 15:09'!
newGroup
	| newGroup |
	newGroup := self root content call: (SKGroup new asComponent
			addValidatedForm;
			addMessage: 'Create Group';
			yourself).
	newGroup isNil ifTrue: [ ^ self ].
	self s2root addGroup: newGroup.
	newGroup creator: self session user title.
	newGroup addAdmin: self session user.
	self group: newGroup.
	self viewGroup.! !

!SKUserMenuComponent methodsFor: 'actions' stamp: 'AQ 10/4/2008 15:09'!
newProject
	| newProject |
	newProject := self root content call: (SKProject new asComponent
			addValidatedForm;
			addMessage: 'Create Project';
			yourself).
	(newProject isNil not and: [ self session user isAnonymous not ]) 
		ifFalse: [ ^ self ].
	self s2root addProject: newProject.
	newProject creator: self session user title.
	newProject addAdmin: self session user.
	self project: newProject.
	self viewProject.! !

!SKUserMenuComponent methodsFor: 'accessing' stamp: 'AQ 10/4/2008 15:09'!
project
	^project! !

!SKUserMenuComponent methodsFor: 'accessing' stamp: 'AQ 10/4/2008 15:09'!
project: aProject
	project := aProject! !

!SKUserMenuComponent methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:47'!
renderContentOn: html 
	self session isLoggedIn ifTrue: 
		[ html anchor
			callback: [ self editAccount ];
			with: 'Edit Account'.
		html break;break.
		self renderProjectsOn: html.
		self renderGroupsOn: html ].
	self session user isSuperuser ifFalse: [ ^ self ].
	self renderSuperuserMenuOn: html! !

!SKUserMenuComponent methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:45'!
renderGroupsOn: html 
	html break.
	html heading
		level: 6;
		with: 'Groups '.
	html anchor
		callback: [ self newGroup ];
		with: '+'.
	html break.
	(self s2root getGroupsOfUser: self session user) do: 
		[ :each | 
		html anchor
			callback: 
				[ self group: each.
				self viewGroup ];
			with: each title ]! !

!SKUserMenuComponent methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:45'!
renderProjectsOn: html 
	html heading
		level: 6;
		with: 'Projects '.
	html anchor
		callback: [ self newProject ];
		with: '+'.
	html break.
	(self s2root getProjectsOfUser: self session user) do: 
		[ :each | html anchor
				callback: [ self project: each. self viewProject ];
				with: each title.
			html break ]! !

!SKUserMenuComponent methodsFor: 'rendering' stamp: 'AQ 10/4/2008 22:54'!
renderSuperuserMenuOn: html 
	html break; break.
	html heading
		level: 6;
		with: 'Admin'.
	html break.
	html anchor
		callback: [ self editRoot ];
		with: 'Edit Root'! !

!SKUserMenuComponent methodsFor: 'actions' stamp: 'AQ 10/4/2008 15:09'!
viewGroup
	| view |
	view:= SKGroupView new.
	view group: self group.
	self root content: view.! !

!SKUserMenuComponent methodsFor: 'actions' stamp: 'AQ 10/4/2008 15:09'!
viewProject
	| view |
	view:= SKProjectView new.
	view project: self project.
	self root content: view.! !

SKComponent subclass: #SKMenuComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKMenuComponent methodsFor: 'accessing' stamp: 'lr 9/26/2008 14:37'!
classes
	^ Array with: SKProjectsView with: SKSearchView with: SKMembersView with: SKGroupsView! !

!SKMenuComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:12'!
renderContentOn: html 
	self classes do: [ :each | 	self renderTab: each on: html ]! !

!SKMenuComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:30'!
renderTab: aClass on: html 
	html div
		class: 'span-6';
		class: 'last' if: self classes last = aClass;	
		class: 'active' if: self root content class = aClass;
		with: [ 
			html anchor
				callback: [ self root content: aClass new ];
				with: aClass label ]! !

WAComponent subclass: #SKRootComponent
	instanceVariableNames: 'content userMenu login menu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKRootComponent class methodsFor: 'testing' stamp: 'AQ 8/20/2008 14:52'!
canBeRoot
	^ true! !

!SKRootComponent class methodsFor: 'initialization' stamp: 'AQ 9/22/2008 09:52'!
initialize
	| application |
	application := self registerAsApplication: 'sourcetalk'.
	application 
		preferenceAt: #sessionClass
		put: SKSession.
	application addLibrary: SKFileLibrary! !

!SKRootComponent methodsFor: 'accessing' stamp: 'AQ 9/6/2008 14:45'!
children
	^ Array with: content with: userMenu with: login with: menu.! !

!SKRootComponent methodsFor: 'accessing' stamp: 'AQ 9/3/2008 16:10'!
content
	^ content! !

!SKRootComponent methodsFor: 'accessing' stamp: 'AQ 8/20/2008 17:50'!
content: aComponent
	content:= aComponent! !

!SKRootComponent methodsFor: 'initialization' stamp: 'AQ 10/4/2008 16:01'!
initialRequest: aRequest
	| names |
	super initialRequest: aRequest.
	names := aRequest url findTokens: '/'.
	names last = 'projects'
		ifTrue: [ ^ self content: SKProjectsView new ].
	names last = 'members'
		ifTrue: [ ^ self content: SKMembersView new ].
	names last = 'groups'
		ifTrue: [ ^ self content: SKGroupsView new ].
	names last = 'search'
		ifTrue: [ ^ self content: SKSearchView new].! !

!SKRootComponent methodsFor: 'initialization' stamp: 'lr 9/18/2008 14:43'!
initialize
	super initialize.
	content := SKWelcomeView on: self.
	login := SKLoginView on: self.
	userMenu := SKUserMenuComponent on: self.
	menu := SKMenuComponent on: self! !

!SKRootComponent methodsFor: 'accessing' stamp: 'lr 10/3/2008 12:07'!
menu
	^ menu! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:15'!
renderBodyOn: html 
	html render: content! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:15'!
renderContentOn: html 
	html div class: 'container'; with: [
		self renderLogoOn: html.
		self renderTabsOn: html.
		self renderMainOn: html ]! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 13:51'!
renderLogoOn: html
	html div class: 'logo'; class: 'span-24'; class: 'last'; with: [
		html heading level: 1; with: [
			html anchor
				title: self s2root title;
				callback: [ self content: SKWelcomeView new ];
				with: [ html span: self s2root title ] ] ]! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:31'!
renderMainOn: html 
	html div class: 'main'; class: 'span-24'; class: 'last'; with: [
		html div class: 'menu';class: 'span-6'; with: [ self renderMenuOn: html ].
		html div class: 'body'; class: 'span-18'; class: 'last'; with: [ self renderBodyOn: html ] ]! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:15'!
renderMenuOn: html
	html render: login.
	html render: userMenu! !

!SKRootComponent methodsFor: 'rendering' stamp: 'lr 10/3/2008 14:12'!
renderTabsOn: html
	html div class: 'tabs'; class: 'span-24'; class: 'last'; with: menu! !

!SKRootComponent methodsFor: 'updating' stamp: 'lr 10/3/2008 12:08'!
updateRoot: html
	super updateRoot: html.
	html title: self s2root title.! !

!SKRootComponent methodsFor: 'actions' stamp: 'lr 9/18/2008 14:43'!
viewUser: aUser 
	content := SKUserView on: self.
	content viewedUser: aUser! !

WASession subclass: #SKSession
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-View'!

!SKSession methodsFor: 'initialization' stamp: 'lr 8/19/2008 11:44'!
initialize
	super initialize.
	self logout.! !

!SKSession methodsFor: 'testing' stamp: 'AQ 8/20/2008 14:50'!
isLoggedIn
	^ self user isAnonymous not! !

!SKSession methodsFor: 'accessing' stamp: 'AQ 8/17/2008 21:03'!
login: aUser 
	self user: aUser! !

!SKSession methodsFor: 'accessing' stamp: 'AQ 9/6/2008 14:24'!
logout
	self user: self s2root anonymous.! !

!SKSession methodsFor: 'accessing' stamp: 'AQ 8/17/2008 17:38'!
user
	^ user! !

!SKSession methodsFor: 'accessing' stamp: 'AQ 8/20/2008 14:46'!
user: aS2Person 
	user := aS2Person! !

MDCmdAddRepository subclass: #MDCmdAddSourceTalkRepository
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sourcetalk-Client'!

!MDCmdAddSourceTalkRepository methodsFor: 'running' stamp: 'lr 9/10/2008 10:31'!
createRepository
	| chunk |
	chunk := OBTextRequest
		prompt: 'SourceTalk Repository:'
		template: self creationTemplate.
	^ chunk isNil 
		ifFalse: [ MDSourceTalkRepository readFrom: chunk ]! !

!MDCmdAddSourceTalkRepository methodsFor: 'accessing' stamp: 'AQ 9/26/2008 12:06'!
creationTemplate
	^ 'MDSourceTalkRepository
	url: ''http://www.sourcetalk.com/''
	project: ''Seaside 2.9''
	email: ''''
	password: '''''! !

!MDCmdAddSourceTalkRepository methodsFor: 'accessing' stamp: 'lr 9/10/2008 09:51'!
label
	^ 'add sourcetalk repository...'! !

!MDAbstractProjectBrowser methodsFor: '*sourcetalk-client' stamp: 'lr 9/10/2008 10:36'!
cmdAddSourceTalkRepository
	^ MDCmdAddSourceTalkRepository! !
SKRRssGroupsFeed initialize!
SKRRssMembersFeed initialize!
SKRRssProjectsFeed initialize!
SKHttpHandler initialize!
SKRoot initialize!
SKRootComponent initialize!
